<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # TRACKBACK-Script  (Maschine <-> Maschine)     #
  #################################################

  require('include/funktions_sammlung.inc.php');
  require('include/article.class.php');

  $success = FALSE;
  $errormessage="";
  ##############################################################################
  # Add a trackback on a article file
  # german readers should look at
  # http://unblogbar.com/weblog/262/trackback-mit-php-realisieren/

  # the artikle ID that the trackback reference will given via URL rewriting
  # e.g: addTrackback.php?676464564
  # trackbackdata always be given with the http POST method,


  $articleID = chop(getenv('QUERY_STRING'));

  if ((is_numeric($articleID)) && ($TRACKBACKS=="AN"))
  {

    ## GET TRACKBACK DATA ##

    // required
    if (issetPostGet('url')) {$url=getPostGetText('url');}
    else {$errormessage = "FEHLER: Parameter 'url' fehlt. / parameter is missing";}

    // optional
    if (issetPostGet('blog_name')) {$blog_name=getPostGetText('blog_name');}
    else {$blog_name = "";}

    // optional
    if (issetPostGet('title')) {$title=getPostGetText('title');}
    else {$title = "";}

    // optional
    if (issetPostGet('excerpt')) {$excerpt=getPostGetText('excerpt');}
    else {$excerpt = "";}

    $blog_name = chop(strip_tags($blog_name));
    $title     = chop(strip_tags($title));
    $excerpt   = chop(strip_tags($excerpt));

    ## ADD DATA TO ARTICLE ##

    if ((file_exists("publicData/".$articleID.".article")) && ($errormessage == ""))
    {
      // load article
      $artikel = article::loadArticleFromFile("publicData/".$articleID.".article");

      //construct trackback-comment-object
      $commentObj = new trackback($title, $blog_name, $excerpt, $url);

      //Add the trackback to the article object
      if (($artikel->addComment($commentObj)) && ($artikel->save("publicData")))
      { $success = TRUE;

        // send maybe a Mail.to an Admin
        if ($GLOBALS['ADMIN_EMAILNOTIFICATION']=="JA")
        {
          $aname     = $artikel->getTitle();
          $validdate = date("D d.m.Y - H:i",(time()+3*24*60*60));
          $linktoadmin = "http://".HTTP_BASISADRESSE."admin.php";
          $quickdeletelink = $linktoadmin."?aktion=commentQuickDelete&articleID=".$artikel->getID()."&commentID=".$commentObj->getPublishedUnixtime()."&quickDeleteCode=".$commentObj->getQuickdeleteCode();
          if ($blog_name=="") { $blog_name = "-"; }
          if ($title    =="") { $title     = "-"; }
          if ($excerpt  =="") { $excerpt   = "-"; }
          $mailtext  = get_lang('admin_quickdelete_mailtext2',$GLOBALS['PODCAST_NAME'],$aname,$url,$blog_name,$title,$excerpt,$validdate,$quickdeletelink, $linktoadmin);


          require_once("include/mail_wrapper.class.php");
          mail_wrapper::sendmail($GLOBALS['ADMIN_EMAIL'], '[podblogger-mail] '.get_lang('admin_quickdelete_subject2'), $mailtext);
        }
      }
      else
      { $errormessage = "Trackback could not be saved."; }

    }
    else
    { $errormessage = "Article does not exist."; }

  }
  else
  { $errormessage = "Trackback support is OFF or article id is not valid."; }

  ## FEEDBACK ##

  header("Content-type: text/xml");
  print '<?xml version="1.0" encoding="utf-8"?>';
  if ($success)
  {
?>
<response>
<error>0</error>
</response>
<?
  }
  else
  {
  if ($errormessage=="") {$errormessage="An ERROR occured.";}
?>
<response>
<error>1</error>
<message><? print $errormessage; ?></message>
</response>
<?
  }

?>