<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #################################################
  # ADMINBEREICH-Script                           #
  #################################################

/**
* Needed files:
*
*  require('include/funktions_sammlung.inc.php');
*  require('include/bbcode.inc.php');
*  require('include/LogFile.class.php');
*  require('include/smarty/Smarty.class.php');
*  require('include/ID3v1x.class.php');
*  require('include/article.class.php');
*  require('include/layout.class.php');
*  require('include/podbloggerservices.inc.php');
*  require('include/ticketmanager.inc.php');
*  require('include/audiomailimport.class.inc.php');
*/

  ini_set( 'include_path', ini_get( 'include_path' ) . PATH_SEPARATOR . '/include' ); 


  require_once('include/funktions_sammlung.inc.php');
  require_once('include/bbcode.inc.php');
  require_once('include/LogFile.class.php');
  require_once('include/smarty/Smarty.class.php');
  require_once('include/ID3v1x.class.php');
  require_once('include/article.class.php');
  require_once('include/layout.class.php');
  require_once('include/podbloggerservices.inc.php');
  require_once('include/ticketmanager.inc.php');
  require_once('include/audiomailimport.class.inc.php');
  require_once("include/testServerPath.inc.php");

  // starting the php-session
  // because there is stored if the user is ADMIN or not
  session_start();

    # security access on article
    if ((isset($RESTRICTED_ACCESS)) && ($RESTRICTED_ACCESS=="YES") )
    {

      // check if server is able to provide dynamic access to files
      require_once("include/testServerPath.inc.php");
      if (testServerPath())
      {
        // make sure that directory publicData is protected
        if (!file_exists("publicData/.htaccess"))
        { @copy("podbloggerData/.htaccess","publicData/.htaccess"); }
      }
      else
      {
        $RESTRICTED_ACCESS="disabled";
        $GLOBALS['reply_on_admin_menu']="<strong><font color='red'>".get_lang("RESTRICTED_ACCESS_NOT_WORKING")."</font></strong>";
      }
    }
    else
    {
      if (file_exists("publicData/.htaccess"))
      { @unlink("publicData/.htaccess"); }
    }

  if (!isset($_SESSION['admin']))
  { $_SESSION['admin'] = "notADMIN"; }

  // try to read the action parameter
  if (issetPostGet('aktion')) {$aktion=getPostGetText('aktion');}
  else						  {$aktion="";}

  // ## Quickdeletecode - AKTION ##
  // the quickdelete code allows to delete comments an trackbacks with a hyperlink
  // and without ADMIN-LogIn.Note the comment musst be younger than 3 days
  if ($aktion=="commentQuickDelete")
  {
    if (issetPostGet('articleID')) {$articleID=getPostGetText('articleID');}
    else {die("FEHLER: Parameter fehlt. / parameter is missing");}

    if (issetPostGet('commentID')) {$commentID=getPostGetText('commentID');}
    else {die("FEHLER: Parameter fehlt. / parameter is missing");}

    if (issetPostGet('quickDeleteCode')) {$quickDeleteCode=getPostGetText('quickDeleteCode');}
    else {die("FEHLER: Parameter fehlt. / parameter is missing");}

    $deleted = FALSE;
    if (file_exists("publicData/".$articleID.".article"))
    {
      $artikel = article::loadArticleFromFile("publicData/".$articleID.".article");
      if ($obj = $artikel->getCommentByTimeID($commentID))
      {
        $articleTitle  = $artikel->getTitle();
        $commentAuthor = $obj->getAuthorName();
        $deleted = $artikel->tryQuickDeleteComment($commentID, $quickDeleteCode);
        $artikel->save("publicData");
        print "<!$deleted>";
      }
      else
      {print "<!comment not found>";}
    }
    else {print "<!article not found>";}

    ?>
      <html>
      <head>
        <title>Podblogger - QuickDelete</title>
        <link rel="stylesheet" href="htmlContent/design.css" type="text/css">
      </head>
      <body>
        <? printHeadline('QuickDelete','Instant-ADMIN'); ?>
        <span class="text">
        <br><b>
        <?
        // report result
        if ($deleted)
        { print_lang('admin_quickdelete_TRUE',$articleTitle,$commentAuthor); }
        else
        { print_lang('admin_quickdelete_FALSE'); }

        ?><br><br><br><br>
        <? printEndline('<strong>[</strong> <a href="index.php">'.get_lang('startpage').'</a> <strong>]</strong>&nbsp;<strong>[</strong> <a href="index.php?permalink='.$articleID.'">'.get_lang('toArticle').'</a> <strong>]</strong>'); ?>
        </span>
      </body>
      </html>
      <?
      exit();
  }

  // if parameter pass is given then the script checks the login
  if (issetPostGet('pass'))
  {
    // sleep for 1 sec to slow down possible bruteforce attacs
    sleep(1);

    // ----- check password and manual upload import
    $pass = getPostGetText('pass');
    if ($pass == $ADMIN_PASSWORD)
    {
      $_SESSION['admin'] = "ADMIN";
    }
    else
    {
      $_SESSION['admin'] = "notADMIN";
      ?>
      <html>
      <head>
        <title><? print_lang('ADMINAREA'); ?> - <? print_lang('login'); ?></title>
        <link rel="stylesheet" href="htmlContent/design.css" type="text/css">
      </head>
      <body>
        <? printHeadline(get_lang('administration'),get_lang('login')); ?>
        <span class="text">
        <b><? print_lang('admin_password_wrong'); ?><br><br><br>
        <? printEndline('<strong>[</strong> <a href="javascript:history.go(-1)">'.get_lang('back').'</a> <strong>]</strong>'); ?>
        </span>
      </body>
      </html>
      <?
      exit();
    }
  }

  if ($_SESSION['admin'] == "notADMIN")
  {
    // ---- print out Login-Form
    ?>
    <html>
      <head>
        <title><? print_lang('ADMINAREA'); ?> - <? print_lang('login'); ?></title>
        <link rel="stylesheet" href="htmlContent/design.css" type="text/css">
      </head>
      <body>
        <? printHeadline(get_lang('administration'),get_lang('login')); ?>
        <span class="text">
        <? print_lang('admin_password_enter');?><br>
        <form method="post" action="admin.php">
          <input type="password" name="pass"><br><br>
          <? print '<input type="submit" value="'.get_lang('login').'">'; ?>
        </form>
        <? printEndline(menuButtonStr(get_lang('back'),"javascript:history.go(-1)")); ?>
                </span>
      </body>
    </html>
    <?
  }
  else if ($_SESSION['admin'] == "ADMIN")
  {


      // ##### manual upload import #################
      // imports all files that were loaded to publicDATA by FTP

      // load article-File names
      $articlefiles = getFilesFromDirWithEnding("publicData","article");
      // load articleobjects in publicData
      $arcitlemp3s = Array();
      foreach($articlefiles as $name)
      {
        $obj = article::loadArticleFromFile("publicData/".$name);
        foreach ($obj->getAllAppendantFiles() as $file)
        {
          array_push($arcitlemp3s,$file);
        }
        #array_push($arcitlemp3s,$obj->getFile());
      }

      // load mp3-filenames in publicData
      $mp3files = getFilesFromDirWithEnding("publicData","mp3");
      #foreach ($mp3files as $file) {print $file."<br>\n";}
      $mp3notlisted = Array();
      foreach($mp3files as $file)
      {
        if (!in_array($file,$arcitlemp3s))
        {
          #print $file." is noT listed<br>\n";
          array_push($mp3notlisted,$file);
        }
      }

      // if there are not listed mp3s make article objects for them
      $i=0;
      foreach ($mp3notlisted as $mp3)
      { $i+=100;
        // create article object
        $article = new article(article::createUniqueID());
        $article->setUnixTime(time()+$i);
        $article->setTitle($mp3);
        $article->setDescription("[b]manual upload - please edit data before making public[/b]");
        $article->setCategory("!NOT PUBLIC!");
        $article->setFile($mp3);
        #print $article->getUnixTime()."<br>\n";


        // save article in uploadData-dir
        $article->save("publicData");
      }

      		##### END manual upload import #################

    $show_menu = 1;

    if (issetPostGet('aktion'))
    {


      // ---  System Logout ------------------------------
      // -------------------------------------------------
      if ($aktion == "logout")
      {
        $_SESSION['admin'] = "notADMIN";
        session_destroy();
        ?>
        <html>
        <head>
          <title><? print_lang('ADMINAREA'); ?> - LogOut</title>
          <link rel="stylesheet" href="htmlContent/design.css" type="text/css">
        </head>
        <body>
        <? printHeadline(get_lang('administration'),get_lang('logout')); ?>
          <span class="text">
          <br><b><? print_lang('admin_menu_logoutOK'); ?></b><br><br>
          <br>

        <? printEndline(menuButtonStr(get_lang('startpage'),"index.php")); ?>
          </span>
        </body>
        </html>
      <?
      exit();
      }



      // --- Trackback entrie on the article object-------
      // -------------------------------------------------
      else if ($aktion == "pingTrackback")
      {
        if (issetPostGet('artikel')) {$artikel_dat=getPostGetText('artikel');}
        else {die("FEHLER: Parameter artikel fehlt. / parameter is missing");}
        if (issetPostGet('schritt')) {$schritt=getPostGetText('schritt');}
        else {die("FEHLER: Parameter schritt fehlt./ parameter is missing");}

        //read. Trackback URL from user via
        if ($schritt=="1")
        {
          print "<html><head><title>".get_lang('admin_trackback_title')."</title></head><body>\n<center>";
          print "<font face='Arial' size='2'>".get_lang('admin_trackback_enterURL')."<br><br></font>\n";
          print "<form action='admin.php' method='post'>";
          print "<input type='text' name='url' value='http://' size='45'><br><br>";
          print "<input type='hidden' name='aktion' value='pingTrackback'>";
          print "<input type='hidden' name='artikel' value='".$artikel_dat."'>";
          print "<input type='hidden' name='schritt' value='2'>";
          print "<input type='submit' value=' ".get_lang('admin_trackback_send')." '></form>";
          print "</center></body></html>";
        }

        // 2.execute Trackback-Ping
        elseif ($schritt=="2")
        {
          if (issetPostGet('url')) {$url=getPostGetText('url');}
          else {die("FEHLER: Parameter url fehlt./ parameter is missing");}

          //load data from the article object wich has the new trackback link
          if (file_exists("publicData/".$artikel_dat)) {
            $artikel = article::loadArticleFromFile("publicData/".$artikel_dat);
          } else {
            die("ERROR: Article '".$artikel_dat."'does not exists in podbloggersystem.");
          }

          // check the given URL and make a host lookup
          $url = chop($url);
          $trackback_url = $url;
          $url_data      = @parse_url($trackback_url);
          if ( (!isset($url_data['host'])) ) // (!preg_match( '#^http\\:\\/\\/[a-z0-9\-]+\.([a-z0-9\-]+\.)?[a-z]+#i' ,$url)) ||
          {
            exit("<html><head><title>ERROR</title></head><body><font face='Arial' size='2'><center><br>".get_lang('admin_trackback_unvalidURL')."</center></font><body/></html>");
          }
          $host = $url_data['host'];

          // prime the data
          $blogname = $GLOBALS['PODCAST_NAME'];
          $title    = $artikel->getTitle();
          $link     = "http://".HTTP_BASISADRESSE."index.php?permalink=".$artikel->getID();
          $excerpt  = ""; // no support in this podbloggerversion (excerpt is optional in th trackbacks spec)
          $data     = "title=".urlencode($title)."&url=".urlencode($link)."&excerpt=".urlencode($excerpt)."&blog_name=".urlencode($blogname);


          // send trackback Ping
          // http://unblogbar.com/weblog/262/trackback-mit-php-realisieren/
          $fp = @fsockopen($host, 80);
          @fputs($fp, "POST ".$trackback_url." HTTP/1.1\r\n");
          @fputs($fp, "Host: ".$host."\r\n");
          @fputs($fp, "Content-Type: application/x-www-form-urlencoded; charset=utf-8\r\n");
          @fputs($fp, "Content-length: ".strlen($data)."\r\n");
          @fputs($fp, "Connection: close\r\n\r\n");
          @fputs($fp, $data);
          @fclose($fp);

          print("<html><head><title>".get_lang('admin_trackback_title')."</title></head><body><font face='Arial' size='2'><center><br>".get_lang('admin_trackback_pingdone')."</center></font><body/></html>");
        }
        else
        {
          die("ERROR: Unvalid value of parameter 'schritt'.");
        }

        exit();
      }


 //dowload a audio file in the admin section from the save upload-data folder
 // ----------------------------------------------------------------------------
      else if ($aktion == "download")
      {
        if (issetPostGet('dat')) {$dat=getPostGetText('dat');}
        else {die("FEHLER: Parameter dat fehlt.");}

        $artikel = article::loadArticleFromFile('uploadData/'.$dat);
        $dat = $artikel->getFile();

		//cease Header for download
		if      (getDateiEndung($dat) == "mp3") {header("Content-type: audio/mpeg");}
		else if (getDateiEndung($dat) == "ogg") {header("Content-type: audio");}
		else if (getDateiEndung($dat) == "avi") {header("Content-type: video/x-msvideo");}
		else if (getDateiEndung($dat) == "mov") {header("Content-type: video/quicktime");}
		else 									{header("Content-type: audio");}
		header("Content-Disposition: attachment; filename=".$dat);

		// the original file
		readfile('uploadData/'.$dat);
      }


      // ------ delete files
      // -------------------------------------------------
      else if ($aktion == "delete")
      {
        if (issetPostGet('dat')) {$dat=getPostGetText('dat');}
        else {die("FEHLER: Parameter dat fehlt. / parameter is missing");}
        if (issetPostGet('verzeichnis')) {$verzeichnis=getPostGetText('verzeichnis');}
        else {die("FEHLER: Parameter verzeichnis fehlt./ parameter 'verzeichnis' is missing");}

        // see function at the end of this file
        private_delete_article($verzeichnis.'/'.$dat);
      }

      // --- edit article informations
      // -------------------------------------------------
      else if ($aktion == "edit")
      {
        if (issetPostGet('dat')) {$dat=getPostGetText('dat');}
        else {die("FEHLER: Parameter dat fehlt. / parameter 'dat' is missing");}
        if (issetPostGet('verzeichnis')) {$verzeichnis=getPostGetText('verzeichnis');}
        else {die("FEHLER: Parameter verzeichnis fehlt. / parameter 'verzeichnis' is missing");}
        if (issetPostGet('schritt')) {$schritt=getPostGetInt('schritt');}
        else {die("FEHLER: Parameter schritt fehlt. / parameter 'schritt' is missing");}

        if ($schritt==1)
        {
            // 1.display the edit site with SMARTY

          // instance and configure a new SMARTY Template data object
          $smarty = new Smarty;

          $smarty->template_dir 	= 'htmlContent/system_templates/';
          $smarty->compile_dir 		= SMARTYPATH_COMPILE;
          $smarty->config_dir 		= SMARTYPATH_CONFIG;
          $smarty->cache_dir 		= SMARTYPATH_CACHE;


          $artikel = article::loadArticleFromFile($verzeichnis."/".$dat);

            if ((is_object($artikel)) && ($artikel->checkValid()))
            {
              $show_menu = FALSE;

              // delete file suffix
              $namensteile = explode(".",stripslashes($artikel->getFile()));
              array_pop($namensteile);
              $dateinameOhneEndung = implode(".",$namensteile);

              // define SMARTY values ##

              // language  fragments in the SMARTY template
              $smarty->assign('text_back'		      ,get_lang('back'));
              $smarty->assign('text_programmedby'     ,get_lang('programmedby'));
              $smarty->assign('text_hmtltitle'        ,get_lang('ADMINAREA'));
  			  $smarty->assign('text_fileinfo'		  ,get_lang('admin_text_fileinfo'));
  			  $smarty->assign('text_filename1'		  ,get_lang('admin_text_filename1'));
  			  $smarty->assign('text_filename2'		  ,get_lang('admin_text_filename2'));
  			  $smarty->assign('text_filetitle'		  ,get_lang('admin_text_filetitle'));
  			  $smarty->assign('text_filecategory'	  ,get_lang('admin_text_filecategory'));
  			  $smarty->assign('text_filedescript1'	  ,get_lang('admin_text_filedescript1'));
  			  $smarty->assign('text_filedescript2'	  ,get_lang('admin_text_filedescript2'));
  			  $smarty->assign('text_fileauthorname'	  ,get_lang('admin_text_fileauthorname'));
  			  $smarty->assign('text_fileauthormail'	  ,get_lang('admin_text_fileauthormail'));
  			  $smarty->assign('text_filepubdate'	  ,get_lang('admin_text_filepubdate'));
  			  $smarty->assign('text_filesend'		  ,get_lang('admin_text_filesend'));
  			  $smarty->assign('text_deleteoption'	  ,get_lang('admin_text_deleteoption'));

  			  if ( ($GLOBALS['TRACKBACKS']=="AN") && ($verzeichnis=="publicData") ) {
  			    $smarty->assign('text_addtrackbacklink' ,"<strong>[</strong>&nbsp;<a href='javascript:popup(\"admin.php?aktion=pingTrackback&schritt=1&artikel=".$dat."\")'>".get_lang('admin_text_addtrackback')."</a>&nbsp;<strong>]</strong>&nbsp;(<a href='".get_lang('admin_text_trackbackinfo')."'>?</a>)");
  			  } else {
  			    $smarty->assign('text_addtrackbacklink' ,"");
  			  }

  			  if ( (isset($GLOBALS['RESTRICTED_ACCESS'])) && ($GLOBALS['RESTRICTED_ACCESS']=="YES") )
  			  {
  			    $pub = get_lang('fileaccess_public');
  			    $res = get_lang('fileaccess_restricted');
  			    $pri = get_lang('fileaccess_private');

  			    if (isset($GLOBALS['ACCESS_OPTIONNAME_PUBLIC']))     {$pub = $GLOBALS['ACCESS_OPTIONNAME_PUBLIC'];}
  			    if (isset($GLOBALS['ACCESS_OPTIONNAME_RESTRICTED'])) {$res = $GLOBALS['ACCESS_OPTIONNAME_RESTRICTED'];}
  			    if (isset($GLOBALS['ACCESS_OPTIONNAME_PRIVATE']))    {$pri = $GLOBALS['ACCESS_OPTIONNAME_PRIVATE'];}

  			    $access_options_intern = array("PUBLIC","RESTRICTED_ACCESS","NOT_PUBLISHED");
  			    $access_options_extern = array($pub,$res,$pri);
  			    $set = $artikel->getRightsData('fileaccess'); if ($set==FALSE) {$set=$access_options_intern[0];}
  			    $smarty->assign('text_fileaccess'		  ,get_lang('admin_text_fileaccess'));
  			    $smarty->assign('access_option_intern'	  ,$access_options_intern);
  			    $smarty->assign('access_option_extern'	  ,$access_options_extern);
  			    $smarty->assign('access_option_set'	      ,$set);
  			  }


              // SMARTY datafields
              $smarty->assign('article_file', 			$dateinameOhneEndung);
              $smarty->assign('article_title', 			$artikel->getTitle());
              $smarty->assign('article_description',	$artikel->getDescription());
              $smarty->assign('article_category', 		$artikel->getCategory());
              $smarty->assign('article_category_array', $PODCAST_CATEGORY);
              $smarty->assign('article_authorName', 	$artikel->getAuthorName());
              $smarty->assign('article_authorMail', 	$artikel->getAuthorMail());
              $smarty->assign('article_date', 			date("d.m.Y;H:i",$artikel->getUnixTime()));
              $smarty->assign('article_articlefile', 	$artikel->getID().".article");
              $smarty->assign('article_id', 			$artikel->getID());
              $smarty->assign('article_time', 			$artikel->getUnixTime());
              $smarty->assign('article_dir', 			$verzeichnis);

              // make xtrafileds in article editible
              $furtherfields = array();

              // check if article got already al xtrafields of the actual layout
              $i=1; $xtrafieldnames = array();
              while (isset($GLOBALS['xtra_field'.$i]))
              {
                array_push($xtrafieldnames, trim($GLOBALS['xtra_field'.$i]));
                $i++;
              }


              foreach ($artikel->getExtendedData() as $key=>$value)
              {

                if ( (strlen($key)>1) && (in_array($key,$xtrafieldnames)) )
                {
                  $field=array();
                  $field['text']        = $key;
                  $field['value']       = $value;
                  $field['formtagname'] = "more_".md5($key);
                  $furtherfields[$key]  = $field;
                }
              }

              // check if article got already al xtrafields of the actual layout
              $i=1; while (isset($GLOBALS['xtra_field'.$i]))
              {
                $key = trim($GLOBALS['xtra_field'.$i]);
                if ( (!array_key_exists($key,$artikel->getExtendedData())) && (strlen($key)>1) )
                {
                  $field=array();
                  $field['text']        = $key;
                  $field['value']       = "";
                  $field['formtagname'] = "more_".md5($key);
                  $furtherfields[$key]  = $field;
                }
                $i++;
              }

              // autodefine length of audio
              $key = "";
              if (isset($furtherfields["Dauer"]))  {$key="Dauer";}
              if (isset($furtherfields["Length"])) {$key="Length";}
              if (isset($furtherfields["length"])) {$key="length";}
              if ( ($key!="") && ($furtherfields[$key]['value']=="") )
              {
                // try to autodefine length of file
                if ( strtoupper(getDateiEndung($artikel->getFile())) == "MP3" )
                {
                  include_once("include/mp3Info.class.php");
                  $file = "";
                  if (file_exists("publicData/".$artikel->getFile())) {$file = "publicData/".$artikel->getFile();}
                  if (file_exists("uploadData/".$artikel->getFile())) {$file = "uploadData/".$artikel->getFile();}
                  if ($file!="")
                  {
                    $info = new mp3Info($file,FALSE);
                    $furtherfields[$key]['value']=$info->getLength();
                  }
                }
              }

              // Assign fields for the smarty template
              $smarty->assign('article_furtherfields', $furtherfields);

			  if ((isset($GLOBALS['INTERNAL_ARCHIVE_MODE'])) && ($GLOBALS['INTERNAL_ARCHIVE_MODE']=="ON"))
			  {
                $smarty->assign('article_deletenotice_option', "ON");

                $value = $artikel->getRightsData('deletenotice');
                if ($value==FALSE) {$value="CONSULTATION";}

                $intern_array = array(
                  "DELETEONNEXTSWEEP",
                  "3",
                  "7",
                  "14",
                  "31",
                  "92",
                  "189",
                  "365",
                  "2190",
                  "CONSULTATION",
                  "NEVERDELETE"
                );

                $extern_array = array(
                  get_lang("delOption_DELETEONNEXTSWEEP"),
                  get_lang("delOption_3"),
                  get_lang("delOption_7"),
                  get_lang("delOption_14"),
                  get_lang("delOption_31"),
                  get_lang("delOption_92"),
                  get_lang("delOption_189"),
                  get_lang("delOption_365"),
                  get_lang("delOption_2190"),
                  get_lang("delOption_CONSULTATION"),
                  get_lang("delOption_NEVERDELETE")
                );

                $smarty->assign('article_deletenotice_array_intern', $intern_array);
                $smarty->assign('article_deletenotice_array_extern', $extern_array);
                $smarty->assign('article_deletenotice_array_value' , $value);
			  }
			  else
			  { $smarty->assign('article_deletenotice_option', "OFF"); }

             // display template site
             $smarty->display('system_article_edit.htm');
            }
        } // End if Step == 1

        else if ($schritt==2)
        {
          // 2.save changes

          if (issetPostGet('dat'))
          {$filename = getPostGetText('dat');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter");}

          if (issetPostGet('articleid'))
          {$articleid = getPostGetText('articleid');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter");}

          $artikel = article::loadArticleFromFile($verzeichnis."/".$dat);

          // ---- deliver parameter

          $orgFilename = $artikel->getFile();
          $orgEndung = getDateiEndung($artikel->getFile());

          if (issetPostGet('neuerdateiname'))
          {$neuerdateiname = getPostGetText('neuerdateiname');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter");}

          $neuerdateiname = stripslashes($neuerdateiname);
          $neuerdateiname = strip_tags($neuerdateiname);

          if (strlen($neuerdateiname) > 0)
          {
            $neuerdateiname = $neuerdateiname.".".$orgEndung;
            if ( file_exists($verzeichnis."/".$neuerdateiname) )
            {
              $ausgabe = get_lang('admin_note_fileexists');
              $neuerdateiname = $orgFilename;
            }
          }
          else
          {
            $ausgabe = get_lang('admin_note_namelength');
            $neuerdateiname = $orgFilename;
          }


          if (issetPostGet('titel'))
          {$titel = getPostGetText('titel');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter ");}
          $titel = strip_tags($titel);

          if (issetPostGet('zeit'))
          {$zeit = getPostGetInt('zeit');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter ");}

          if (issetPostGet('beschreibung'))
          {$beschreibung = getPostGetText('beschreibung');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter ");}
          $beschreibung = str_replace("\n\r","\n",$beschreibung);
          $beschreibung = str_replace("\r\n","\n",$beschreibung);

          if (issetPostGet('autor_name'))
          {$autor_name = getPostGetText('autor_name');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter");}
          $autor_name = strip_tags($autor_name);

          if (issetPostGet('autor_mail'))
          {$autor_mail = getPostGetText('autor_mail');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter");}
          $autor_mail = strip_tags($autor_mail);

          if (issetPostGet('kategorie'))
          {$kategorie = getPostGetText('kategorie');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter");}

          if (issetPostGet('date'))
          {$date = getPostGetText('date');}
          else { die("FEHLER: Es fehlen Parameter! / missing parameter");}

          //check if the publication date is valid
          if (!$unixdate = getUnixTimeFromStr($date))
          {
            $unixdate = $artikel->getUnixTime();
          }

          $autor_telefon = $artikel->getAuthorXtra();
          $autor_bemerkung = $artikel->getAuthorComment();

          if ($titel != "")
          {
            // ---- save input
            $artikel = article::loadArticleFromFile($verzeichnis."/".$articleid.".article");

            $artikel->setUnixTime($unixdate);
            $artikel->setFile($neuerdateiname);
            $artikel->setTitle($titel);
            $artikel->setDescription($beschreibung);
            $artikel->setAuthorName($autor_name);
            $artikel->setAuthorMail($autor_mail);
            $artikel->setAuthorXtra($autor_telefon);
            $artikel->setAuthorComment($autor_bemerkung);
            $artikel->setCategory($kategorie);

            // check extended metadata
            foreach ($artikel->getExtendedData() as $key=>$value)
            {
              if (issetPostGet("more_".md5($key)))
              {
               $value = getPostGetText("more_".md5($key));
               $artikel->setExtendedData($key,$value);
              }
            }

           // check if article got already al xtrafields of the actual layout
           $i=1; while (isset($GLOBALS['xtra_field'.$i]))
           {
             $key = $GLOBALS['xtra_field'.$i];
             if ( (!array_key_exists($key,$artikel->getExtendedData())) && (issetPostGet("more_".md5($key))) )
             {
               $value = getPostGetText("more_".md5($key));
               $artikel->setExtendedData($key,$value);
             }
             $i++;
            }

            // maybe set fileaccess rights
            if ( (isset($GLOBALS['RESTRICTED_ACCESS'])) && ($GLOBALS['RESTRICTED_ACCESS']=="YES") )
  		    {
              if (issetPostGet("fileaccess"))
              {
               $value = getPostGetText('fileaccess');
               $artikel->setRightsData('fileaccess',$value);
              }
			}

            // maybe set deleteoption
            if (issetPostGet("deleteoption"))
            {
              $value = getPostGetText('deleteoption');
              $artikel->setRightsData('deletenotice',$value);
            }

            if ($orgFilename != $neuerdateiname)
            {
              // rename MP3 files
              rename($verzeichnis."/".$orgFilename,$verzeichnis."/".$neuerdateiname);

              // move further fileformats, if existing
              if ($files = $artikel->moreFiles())
              {
                foreach ($files as $file)
                {
                  // HIER noCH SAUBER IMPLEMENTIEREN
                  #rename($verzeichnis."/".$orgFilename,$verzeichnis."/".$neuerdateiname);
                }
              }
            }

            // VORSICHT: Wenn Artikel nicht gespeichert werden kann, dann ist das renaming rckgngig zu machen !!!!!
            if (!$artikel->save($verzeichnis))
            { die("\nFEHLER: In Verzeichnis '$verzeichnis' koennen keine Dateien angelegt werden. Bitte Schreibrechte pruefen. / in directory '$verzeichnis' no files can be written. check write permissions on server.");}



            // ---- MP3 ID-Tag Edit
            // has problems if server has set writing limit (www.attrax-online.de)

            $ID3 = new ID3v1x($verzeichnis."/".$neuerdateiname);
            @$ID3->write_tag(1, strip_tags($titel), strip_tags($PODCAST_NAME), strip_tags($kategorie), date("Y",time()), substr(HTTP_BASISADRESSE,0,strlen(HTTP_BASISADRESSE)-1), "0", "37");

           } // end if titel != ""
        } // end step == 2

      } // end aktion == edit


      // --- Autodelete / Cleansweep Archive -------------
      // -------------------------------------------------
      // this feature allows to delete all articles with an outdated delete notice
      // at one time. the INTERNAL_ARCHIVE_MODE needs to be ON for this
      else if ($aktion == "autodelete")
      {
        if (issetPostGet('schritt'))
        {$schritt = getPostGetInt('schritt');}
        else { die("FEHLER: Es fehlen Parameter! / missing parameter");}

        if ((isset($GLOBALS['INTERNAL_ARCHIVE_MODE'])) && ($GLOBALS['INTERNAL_ARCHIVE_MODE']=="ON"))
        {
          if ($schritt==1)
          {
            // make a list of files that can be deleteted
            $Dateien = getFilesFromDirWithEnding("publicData","article");


            // build Array with articles that are free to delete
            $delArray = array();
            foreach ($Dateien as $datei)
            {
              $artikel = article::loadArticleFromFile("publicData/".$datei);
              if ($artikel->getFile()!="")
              {
                // calculate how old the file is (in days)
                $daysold = floor((time()-$artikel->getUnixTime())/(24*60*60));
                $deletnotice = $artikel->getRightsData('deletenotice');
                if ($deletnotice)
                {
                  if ((is_int(intval($deletnotice))) && (intval($deletnotice)>0))
                  {
                    $protectiondays = intval($deletnotice);
                    if ($protectiondays < $daysold)
                    {
                      array_push($delArray, $artikel);
                    }
                  }
                  elseif ($deletnotice=="DELETEONNEXTSWEEP")
                  {
                    array_push($delArray, $artikel);
                  }
                }
              }
            }

            if (count($delArray)>0)
            {
              $idArray = array();
              $i=1;
              $code = "";
              foreach( $delArray as $delartikel)
              {
                array_push($idArray,$delartikel->getID());

                $name = $delartikel->getTitle();
                $size = 0; foreach ($delartikel->getAllAppendantFiles() as $file)
                { $size += filesize("publicData/".$file); }
                $size = floor($size/(1024*1024))+1;
                $id = $delartikel->getID();
                $author = $delartikel->getAuthorName(); if ($author=="") {$author="-";}

                $code .= '<input type="checkbox" name="delno'.$i.'" value="'.$id.'" checked>&nbsp;<strong>'.$name.'</strong> ('.$size.'MB / '.$author.')'."<br>\n";
                $i++;
              }

              $code = '<form action="admin.php" method="POST">'.$code.'<input type="hidden" name="aktion" value="autodelete"><input type="hidden" name="schritt" value="2">';
              $code = $code.'<br><input type="submit" value=" Markierte Beitr&auml;ge l&ouml;schen "></form>';

              ?>
              <html>
              <head>
                <title><? print_lang('ADMINAREA'); ?> - <? print_lang('login'); ?></title>
                <link rel="stylesheet" href="htmlContent/design.css" type="text/css">
              </head>
              <body>
                <? printHeadline(get_lang('administration'),get_lang('login')); ?>
                <span class="text">
                <strong><font size="+1"><? print get_lang('autodelete'); ?></font></strong><br><br>
                <? print get_lang('autodelete_text'); ?>
                <br><br>
                <? print $code; ?>
                <b><br>
                <? printEndline('<strong>[</strong> <a href="admin.php">'.get_lang('back').'</a> <strong>]</strong>'); ?>
                </span>
              </body>
              </html>
              <?

              // save list in ADMIN session
              $_SESSION['delArray'] = $idArray;

              print "<!-- ".count($idArray)."/".count($_SESSION['delArray'])." -->";exit();
            }
            else
            {
              $GLOBALS['reply_on_admin_menu']="<strong><font color='red'>".get_lang("no_files_to_delete")."</font></strong>";
            }

          }
          elseif ($schritt==2)
          {
            $i=1;
            if (isset($_SESSION['delArray']))
            {
              // filter not checked boxes
              $my_delArray = array();
              foreach ($_SESSION['delArray'] as $id)
              {
                if ( (issetPostGet('delno'.$i)) && (getPostGetText('delno'.$i)==$id) )
                { array_push($my_delArray, $id);}
                $i++;
              }

              if (count($my_delArray) > 0)
              {
                foreach ($my_delArray as $id)
                {
                  private_delete_article("publicData/".$id.".article");
                }
                $GLOBALS['reply_on_admin_menu']="<strong><font color='green'>".get_lang("files_were_deleted",count($my_delArray))."</font></strong>";
              }
            }
          }
        }
      }

      // --- publish file --------------------------------
      // -------------------------------------------------
      //  move from uploadData -> publicData

      else if ($aktion == "makepublic")
      {
        if (issetPostGet('dat'))
        {$articleFileName = getPostGetText('dat');}
        else { die("FEHLER: Es fehlen Parameter! / missing parameter");}

        if (file_exists("uploadData/".$articleFileName)) {
          $artikel = article::loadArticleFromFile("uploadData/".$articleFileName);
        } else {$artikel=FALSE;}

        if ((is_object($artikel)) && (file_exists("uploadData/".$artikel->getFile())))
        {

          // delete all tickets for this article
          ticketmanager::deleteAllTicketsForArticle($artikel->getID());

          // move all files of article
          foreach ($artikel->getAllAppendantFiles() as $file)
          {
            movefile("uploadData/".$file,"publicData/".$file);
          }

          // move article-file
          movefile("uploadData/".$articleFileName,"publicData/".$articleFileName);

        }
      }

      // -------------------------------------------------
      // --- check for new Audiomails
      // -------------------------------------------------
      else if ($aktion == "checkaudiomail")
      {
        // check for new audiiomail
        $result = checkAndImportNewAudioMail();

        if (is_Numeric($result))
        {
          if ($result>0)
          {
            $GLOBALS['reply_on_admin_menu'] = "<font color='green'>Audiomailcheck: ".get_lang('mailimport_report_OK',$result)."</font>";
          }
          else
          {
            $GLOBALS['reply_on_admin_menu'] = "<font color='blue'>Audiomailcheck: ".get_lang('mailimport_report_NOMAIL')."</font>";
          }
        }
        else
        {
          $GLOBALS['reply_on_admin_menu'] = "<font color='red'>".get_lang('mailimport_report_error')." Audiomailcheck: ".$result."</font>";
        }
      }

      // -------------------------------------------------
      // --- delete a comment from a article object
      // -------------------------------------------------
      else if ($aktion == "del_comment")
      {
        //carch article article ID
        if (issetPostGet('article'))
        {$artikelID = getPostGetText('article');}
        else { die("FEHLER: Es fehlen Parameter! / missing parameter");}

        // get Comment id
        if (issetPostGet('id'))
        {$commentID = getPostGetText('id');}
        else { die("FEHLER: Es fehlen Parameter! / missing parameter");}

        if (file_exists("publicData/".$artikelID.".article")) {

          // load article file
          $artikel = article::loadArticleFromFile("publicData/".$artikelID.".article");

          // delete commentar on article object
          $artikel->deleteComment($commentID);

          //Save article file
          $artikel->save('publicData');
        }

      }


      // --- delete / abort converttickets from article object
      // -------------------------------------------------
      else if ($aktion == "del_ticket")
      {
         print "<!-- START admin.php aktion=del_ticket ->\n";
        // get ticket ID
        if (issetPostGet('id'))
        {$ticketID = getPostGetText('id');}
        else { die("FEHLER: Es fehlen Parameter! / missing parameter");}
        ticketmanager::deleteTicketById($ticketID);
      }


      // --- configuration
      // -------------------------------------------------
      //

      else if ($aktion == "config")
      {
        $pod_reply 		= "";
        $pass_reply 	= "";
        $category_reply = "";
        $option_reply 	= "";
        $relais_reply 	= "";
        $layout_reply 	= "";


        //instance and configure SMARTY Template data object
        $smarty = new Smarty;

        $smarty->template_dir 	= 'htmlContent/system_templates/';
        $smarty->compile_dir 	= SMARTYPATH_COMPILE;
        $smarty->config_dir 	= SMARTYPATH_CONFIG;
        $smarty->cache_dir 		= SMARTYPATH_CACHE;

        loadPostGetString('mode');

        // ############ Basic Configurations ####################################
        if ($mode == "language")
        {
          if (isset($_POST['language']))
          {
            $sprache = $_POST['language'];
            $ADMIN_LANGUAGE=$sprache;
            updateValueInConfigFile("ADMIN_LANGUAGE");
            write_weiterleitung("admin.php?aktion=config&mode=menu");
            exit();
          }
        }
        elseif ($mode == "base")
        {
          loadPostGetString('pod_name');
          loadPostGetString('pod_description');
          loadPostGetString('pod_admin');
          loadPostGetString('pod_adminmail');

          //no html allowed
          $pod_name 			= strip_tags($pod_name);
          $pod_description 		= strip_tags($pod_description);
          $pod_admin 			= strip_tags($pod_admin);
          $pod_adminmail		= strip_tags($pod_adminmail);

          if (strlen($pod_name) > 6)
          {
            $PODCAST_NAME = $pod_name;
            updateValueInConfigFile("PODCAST_NAME");

            $PODCAST_DESCRIPTION = $pod_description;
            updateValueInConfigFile("PODCAST_DESCRIPTION");

            $ADMIN_NAME = $pod_admin;
            updateValueInConfigFile("ADMIN_NAME");

            $ADMIN_EMAIL = $pod_adminmail;
            updateValueInConfigFile("ADMIN_EMAIL");

            $pod_reply = "<strong>OK: <font color='green'>".
          		         get_lang('admin_feedback_saved').
          		         "</font><strong><br><br>";
          }
          else
          {
            $pod_reply = "<strong>PROBLEM: <font color='red'>".
                       get_lang('admin_feedback_namelength').
                       "</font><strong><br><br>";
          }

          $mode = "menu";
        } // END mode='base'


        // ############ PASSWORD ####################################
        elseif ($mode == "pass")
        {
          loadPostGetString('pass_old');
          loadPostGetString('pass_new1');
          loadPostGetString('pass_new2');

          if ($pass_old == $ADMIN_PASSWORD)
          {
            if ($pass_new1 == $pass_new2)
            {
              if (strlen($pass_new1) > 5)
              {
                $ADMIN_PASSWORD = $pass_new1;
                // Update config.txt
                updateValueInConfigFile("ADMIN_PASSWORD");
                $pod_reply = "<strong>OK: <font color='green'>".
          		             get_lang('admin_feedback_newpassOK').
          		             "</font><strong><br><br>";
          	  }
          	  else
          	  {
                $pod_reply = "<strong>PROBLEM: <font color='red'>".
          		           get_lang('admin_feedback_passlen').
          		           "</font><strong><br><br>";
          	  }
            }
            else
            {
              $pod_reply = "<strong>PROBLEM: <font color='red'>".
          		           get_lang('admin_feedback_passrepeat').
          		           "</font><strong><br><br>";
            }
          }
          else
          {
            $pod_reply = "<strong>PROBLEM: <font color='red'>".
            		     get_lang('admin_feedback_passwrong').
          		         "</font><strong><br><br>";
          }
          $mode = "menu";
        } // END mode='pass'


        // ############ CATEGORY ####################################
        elseif ($mode == "category")
        {

          loadPostGetString('option');

          // ############ new category
          if ( $option=="new" )
          {
            loadPostGetString('category_name');

            $category_name 		= strip_tags($category_name);
            $category_name 		= trim($category_name);
            $category_name      = htmlspecialchars($category_name);

            if (strlen($category_name) >= 3)
            {

              // add category
              array_push($PODCAST_CATEGORY,$category_name);

              // Update config.txt
              updateValueInConfigFile("PODCAST_CATEGORY");

              $pod_reply = "<strong>OK: <font color='green'>".
            		       get_lang('admin_feedback_categoryOK').
          		           "</font><strong><br><br>";
          	}
          	else
          	{
          	  if (strlen($category_name)>=1)
              $pod_reply = "<strong>PROBLEM: <font color='red'>".
                 		   get_lang('admin_category_to_short').
          		           "</font><strong><br><br>";
          	  else
              $pod_reply = "<strong>Hinweis: <font color='blue'>".
                 		   get_lang('admin_category_need_name').
          		           "</font><strong><br><br>";
          	}
            $mode="menu";
          } //fin ;-)

          // ############ delete category
          elseif ( $option=="delete" )
          {
            loadPostGetString('category');

            // delete category
            $newArray = array();
            foreach ($PODCAST_CATEGORY as $cat)
            { if ($cat != $category) {array_push($newArray,$cat);} }
            $PODCAST_CATEGORY = $newArray;

            // Update config.txt
            updateValueInConfigFile("PODCAST_CATEGORY");

            $pod_reply = "<strong>OK: <font color='green'>".
                 		 get_lang('admin_category_delteOK',$category).
          		         "</font><strong><br><br>";

            $mode="menu";
          }  //fin delete
          else
          {
            $mode="menu";
          }
        } //  Fin mode='menu'

        // ############ SYSTEM OPTIONS ####################################
        elseif ($mode == "option")
        {
          loadPostGetString('option_mail');
          loadPostGetString('option_rss');
          loadPostGetString('option_mp3');
          loadPostGetString('option_postsPerPage');
          loadPostGetString('option_webspace');
          loadPostGetString('option_textcomments');
          loadPostGetString('option_trackbacks');
          loadPostGetString('uploadjustadmin');

          if (!is_numeric($option_postsPerPage))
          {
            $pod_reply = "<strong>PROBLEM: <font color='red'>".
                 	   get_lang('admin_postperpage_needNum').
                       "</font><strong><br><br>";
          }
          elseif (intval($option_postsPerPage) <= 0)
          {
            $pod_reply = "<strong>PROBLEM: <font color='red'>".
                 	   get_lang('admin_postperpage_bigger').
                       "</font><strong><br><br>";
          }
          elseif (!is_numeric($option_webspace))
          {
            $pod_reply = "<strong>PROBLEM: <font color='red'>".
                 	   get_lang('admin_weblimit_needNum').
                       "</font><strong><br><br>";
          }
          else
          { // all values OK

            // maybe map. YES / no to JA / NEIN
            if ($option_mail==get_lang('yes')) {$option_mail="JA";  }
            if ($option_mail==get_lang('no'))  {$option_mail="NEIN";}

            if ($option_mp3==get_lang('yes')) {$option_mp3="JA";  }
            if ($option_mp3==get_lang('no'))  {$option_mp3="NEIN";}

            if ($option_rss==get_lang('yes')) {$option_rss="JA";  }
            if ($option_rss==get_lang('no'))  {$option_rss="NEIN";}

            if ($uploadjustadmin==get_lang('yes')) {$uploadjustadmin="JA";  }
            if ($uploadjustadmin==get_lang('no'))  {$uploadjustadmin="NEIN";}

            if ($option_textcomments==get_lang('ON')) 	    {$option_textcomments="AN";   }
            if ($option_textcomments==get_lang('OFF')) 	    {$option_textcomments="AUS";  }
            if ($option_textcomments==get_lang('JUSTSHOW')) {$option_textcomments="NURANZEIGEN";  }

            if ($option_trackbacks  ==get_lang('ON')) 	    {$option_trackbacks  ="AN";   }
            if ($option_trackbacks  ==get_lang('OFF')) 	    {$option_trackbacks  ="AUS";  }
            if ($option_trackbacks  ==get_lang('JUSTSHOW')) {$option_trackbacks  ="NURANZEIGEN";  }

            if (($GLOBALS['ADMIN_EMAIL']=="") && ($GLOBALS['ADMIN_EMAILNOTIFICATION']=="NEIN") && ($option_mail=="JA"))
            {
              $pod_reply = "<strong>ACHTUNG: <font color='red'>".
                   	       get_lang('admin_config_noemail').
          		           "</font><strong><br><br>";
            }
            else
            {
              $ADMIN_EMAILNOTIFICATION = $option_mail;
              updateValueInConfigFile("ADMIN_EMAILNOTIFICATION");
            }

            $STATS_RSS = $option_rss;
            updateValueInConfigFile("STATS_RSS");

            $STATS_MP3 = $option_mp3;
            updateValueInConfigFile("STATS_MP3");

            $FILES_PER_PAGE = $option_postsPerPage;
            updateValueInConfigFile("FILES_PER_PAGE");

            $WEBSPACE_LIMIT = $option_webspace;
            updateValueInConfigFile("WEBSPACE_LIMIT");

            $TEXTCOMMENTS = $option_textcomments;
            updateValueInConfigFile("TEXTCOMMENTS");

            $TRACKBACKS = $option_trackbacks;
            updateValueInConfigFile("TRACKBACKS");

            $JUST_ADMIN_UPLOAD = $uploadjustadmin;
            updateValueInConfigFile("JUST_ADMIN_UPLOAD");

            if ($pod_reply=="")
            {
              $pod_reply = "<strong>OK: <font color='green'>".
                   	       get_lang('admin_config_saved').
          		           "</font><strong><br><br>";
          	}
          }

          $mode = "menu";
        } // FIN mode='option'


        // ############ configure extern SERVICES ####################################
        elseif ($mode == "extservices")
        {
          if (issetPostGet('service_uploadON'))  {loadPostGetString('service_uploadON');}  else {$service_uploadON="AUS";}
          if (issetPostGet('service_convertON')) {loadPostGetString('service_convertON');} else {$service_convertON="AUS";}
          if (issetPostGet('service_mailON'))    {loadPostGetString('service_mailON');}    else {$service_mailON="AUS";}

	  // save upload relay configurations
          $UPLOADRELAIS_SWITCH = $service_uploadON;
          updateValueInConfigFile("UPLOADRELAIS_SWITCH");
          if ($service_uploadON=="AN")
          {
            if (issetPostGet('relais_uploadscript'))
            {
              // Service was already configured -> take over the configuration
              loadPostGetString('relais_uploadscript');

              $UPLOADRELAIS_UP_ADRESS = $relais_uploadscript;
              updateValueInConfigFile("UPLOADRELAIS_UP_ADRESS");

              if ($relais_uploadscript!="")
              {
                $teile = explode("/",$relais_uploadscript); array_pop($teile);
                $UPLOADRELAIS_DOWN_ADRESS = implode("/",$teile)."/download.cgi";
                updateValueInConfigFile("UPLOADRELAIS_DOWN_ADRESS");
              }
              else
              {
                $UPLOADRELAIS_DOWN_ADRESS = "";
                updateValueInConfigFile("UPLOADRELAIS_DOWN_ADRESS");
              }
            }
            else
            {
              // Case that the service is new configured

              // If there is an adress in the config.txt file try to autoconfig
              if ($UPLOADRELAIS_DOWN_ADRESS=="")
              {
                // check if the local uploadrelay is avalible
                if ($relais_uploadscript = podbloggerServices::lokalPerl())
                {
                  $UPLOADRELAIS_UP_ADRESS   = $relais_uploadscript."upload.cgi";
                  updateValueInConfigFile("UPLOADRELAIS_UP_ADRESS");
                  $UPLOADRELAIS_DOWN_ADRESS = $relais_uploadscript."download.cgi";
                  updateValueInConfigFile("UPLOADRELAIS_DOWN_ADRESS");
                }
                // if not than try the autoswitchcenter
                else
                {
                  if ($dataObj = podbloggerServices::getRelayFromNet($PODBLOGGER_VERSION))
                  {
                    $UPLOADRELAIS_UP_ADRESS   = $dataObj->getHttpAdress_Uploadscript();
                    updateValueInConfigFile("UPLOADRELAIS_UP_ADRESS");
                    $UPLOADRELAIS_DOWN_ADRESS = $dataObj->getHttpAdress_Downloadscript();
                    updateValueInConfigFile("UPLOADRELAIS_DOWN_ADRESS");
                  }
                }
              }
            }
          }


          // ##save converter configurations
          $AUDIOCONVERT_SWITCH = $service_convertON;
          updateValueInConfigFile("AUDIOCONVERT_SWITCH");
          if ($service_convertON=="AN")
          {
            if (issetPostGet('konverter_addresse'))
            {
              // Service was already configured -> take over the configuration
              loadPostGetString('konverter_addresse');

              $AUDIOCONVERT_ADDRESS = $konverter_addresse;
              updateValueInConfigFile("AUDIOCONVERT_ADDRESS");
            }
            else
            {
              // Case that the service is new configured

              // If there is an adress in the config.txt file try to autoconfig
              if ($AUDIOCONVERT_ADDRESS=="")
              {

                if ($dataObj = podbloggerServices::getConverterFromNet($PODBLOGGER_VERSION))
                {
                  $AUDIOCONVERT_ADDRESS   = $dataObj->getHttpAdress();
                  updateValueInConfigFile("AUDIOCONVERT_ADDRESS");
                }
              }
            }
          }

          	## save MAILIMPORT configurations ##
          $MAILIMPORT_SWITCH   = $service_mailON;
          updateValueInConfigFile("MAILIMPORT_SWITCH");

          if ($service_mailON=="AN")
          {
            if (issetPostGet('mail_pop'))
            {
              loadPostGetString('mail_pop');
              loadPostGetString('mail_name');
              loadPostGetString('mail_pass');

              $MAILIMPORT_POP  = $mail_pop;
              updateValueInConfigFile("MAILIMPORT_POP");
              $MAILIMPORT_NAME = $mail_name;
              updateValueInConfigFile("MAILIMPORT_NAME");
              $MAILIMPORT_PASS = $mail_pass;
              updateValueInConfigFile("MAILIMPORT_PASS");
            }
          }

          $pod_reply = "<strong>OK: <font color='blue'>".
                 	   get_lang('admin_cgiconfig_saved').
          		       "</font><strong><br><br>";


          $mode = "menu";
        } // fin mode='pass'

        // ############ LAYOUT ####################################
        elseif ($mode == "layout")
        {
          loadPostGetString('layout_select');
          loadPostGetString('lastLayoutID');

          if ($o_layout = layout::loadLayoutFromPluginDir($layout_select))
          {
            $LAYOUT_ID = $o_layout->getID();
            updateValueInConfigFile("LAYOUT_ID");

            //check the variables definition fits for the layout
            if ($old_layout = layout::loadLayoutFromPluginDir($lastLayoutID))
            {
              $defVars = $old_layout->getDefinitionArray();
              foreach ($defVars as $def)
              {
                if (issetPostGet("layoutdef_".$def['smartyname']))
                {
                  $value = getPostGetText("layoutdef_".$def['smartyname']);
                  $old_layout->setDefinitionValue($def['smartyname'], $value);
                }
              }
              $old_layout->saveDefinitionValues();
            }


            //some outputs
            if ($LAYOUT_ID == $lastLayoutID){
            $pod_reply = "<strong>OK: <font color='green'>".
                 	     get_lang('admin_layout_valuessaved').
          		         "</font><strong><br><br>"; }
          	else {
            $pod_reply = "<strong>OK: <font color='blue'>".
                 	     get_lang('admin_layout_saved').
          		         "</font><strong><br><br>"; }
          }
          else
          {
            $pod_reply = "<strong>PROBLEM: <font color='red'>".
                 	     get_lang('admin_layout_problem').
          		         "</font><strong><br><br>";
          }
          $mode = "menu";
        } // fin mode='layout'


        // ############ setting menue ####################################
        if ($mode == "menu")
        {

          // ## SMARTY-Werte belegen ##

          // language snipbits
          $smarty->assign('text_headline',      get_lang('admin_text_headline'));
          $smarty->assign('text_back',          get_lang('back'));
          $smarty->assign('text_startpage',     get_lang('startpage'));
          $smarty->assign('text_programmedby',  get_lang('programmedby'));
          $smarty->assign('text_delete',        get_lang('com_delete'));
          $smarty->assign('text_edit',          get_lang('com_edit'));
          $smarty->assign('text_mainconfig',    get_lang('admin_text_mainconfig'));
          $smarty->assign('text_podbloggername',get_lang('admin_text_podbloggername'));
          $smarty->assign('text_rssinfotext',   get_lang('admin_text_rssinfotext'));
          $smarty->assign('text_adminname',     get_lang('admin_text_adminname'));
          $smarty->assign('text_adminmail',     get_lang('admin_text_adminmail'));
          $smarty->assign('text_adminsend',     get_lang('admin_text_adminsend'));
          $smarty->assign('text_passwort',      get_lang('admin_text_passwort'));
          $smarty->assign('text_oldpass',       get_lang('admin_text_oldpass'));
          $smarty->assign('text_newpass1',      get_lang('admin_text_newpass1'));
          $smarty->assign('text_newpass2',      get_lang('admin_text_newpass2'));
          $smarty->assign('text_passwortsend',  get_lang('admin_text_passwortsend'));
          $smarty->assign('text_category',      get_lang('admin_text_category'));
          $smarty->assign('text_newcategory',   get_lang('admin_text_newcategory'));
          $smarty->assign('text_systemoptions', get_lang('admin_text_systemoptions'));
          $smarty->assign('text_mailoption',    get_lang('admin_text_mailoption'));
          $smarty->assign('text_rssoption',     get_lang('admin_text_rssoption'));
          $smarty->assign('text_mp3option',     get_lang('admin_text_mp3option'));
          $smarty->assign('text_uploadjustadmin',get_lang('admin_text_uploadjustadmin'));
          $smarty->assign('text_textcomments',  get_lang('admin_text_textcomments'));
          $smarty->assign('text_trackbacks',    get_lang('admin_text_trackbacks'));
          $smarty->assign('text_itemsperpage',  get_lang('admin_text_itemsperpage'));
          $smarty->assign('text_weblimit',      get_lang('admin_text_weblimit'));
          $smarty->assign('text_optionsave',    get_lang('admin_text_optionsave'));
          $smarty->assign('text_cgioption',     get_lang('admin_text_cgioption'));
          $smarty->assign('text_servicetext',   get_lang('admin_text_serviceinfotext'));
          $smarty->assign('text_cgiddress',     get_lang('admin_text_cgiddress'));
          $smarty->assign('text_cgisend',       get_lang('admin_text_cgisend'));
          $smarty->assign('text_layout',        get_lang('admin_text_layout'));
          $smarty->assign('text_layouttext',    get_lang('admin_text_layouttext'));
          $smarty->assign('text_layoutsend',    get_lang('admin_text_layoutsend'));

          $smarty->assign('text_head_upload',   get_lang('admin_text_head_upload'));
          $smarty->assign('text_upload_switch',get_lang('admin_text_switch_upload'));

          $smarty->assign('text_convert_head',    get_lang('admin_text_head_convert'));
          $smarty->assign('text_convert_switch',  get_lang('admin_text_switch_convert'));
          $smarty->assign('text_convert_address', get_lang('admin_text_http_convert'));

          $smarty->assign('text_mail_head',       get_lang('admin_text_head_mail'));
          $smarty->assign('text_mail_switch',     get_lang('admin_text_switch_mail'));
          $smarty->assign('text_mail_pop',        get_lang('admin_text_pop_mail'));
          $smarty->assign('text_mail_name',       get_lang('admin_text_name_mail'));
          $smarty->assign('text_mail_pass',       get_lang('admin_text_pass_mail'));

          // set up setting values

          $langs_values = getAllAvailableLanguages();
          $langs_output = array(); foreach ($langs_values as $o_lang) { array_push($langs_output,strtoupper($o_lang)); }
          $smarty->assign('lang_array_output',	$langs_output);
          $smarty->assign('lang_array_values',	$langs_values);
          $smarty->assign('lang',  				$ADMIN_LANGUAGE);

          if (($pod_reply == "") && ($ADMIN_NAME == "") && ($ADMIN_EMAIL == ""))
          {
            $pod_reply = "<strong>Hinweis: <font color='blue'>".
		                 get_lang('admin_data_neednamemail').
          		         "</font><strong><br><br>";
          }
          elseif (($pod_reply == "") && ($ADMIN_NAME == ""))
          {
            $pod_reply = "<strong>Hinweis: <font color='blue'>".
		                 get_lang('admin_data_needname').
          		         "</font><strong><br><br>";
          }
          elseif (($pod_reply == "") && ($ADMIN_EMAIL == ""))
          {
            $pod_reply = "<strong>Hinweis: <font color='blue'>".
		                 get_lang('admin_data_needmail').
          		         "</font><strong><br><br>";
          }
          $smarty->assign('pod_reply',			$pod_reply);
          $smarty->assign('pod_name',			$PODCAST_NAME);
          $smarty->assign('pod_description',	$PODCAST_DESCRIPTION);
          $smarty->assign('pod_admin',			$ADMIN_NAME);
          $smarty->assign('pod_adminmail',		$ADMIN_EMAIL);

          $smarty->assign('pass_reply',			$pass_reply);

          $smarty->assign('category_reply',		$category_reply);

          $category_array = array();
          foreach ($PODCAST_CATEGORY as $cat)
          {
            array_push($category_array,array('name' => $cat, 'name_urlencode' => urlencode($cat)));
          }
          $smarty->assign('category_array',					$category_array);

          $smarty->assign('option_reply',		"");
          $smarty->assign('option_postsPerPage',$FILES_PER_PAGE);
          $smarty->assign('option_webspace',	$WEBSPACE_LIMIT);

          // mapping JA / NEIN -> yes / no
          $map_mail = $ADMIN_EMAILNOTIFICATION; $map_rss  = $STATS_RSS; $map_mp3  = $STATS_MP3;
          $map_textcomments = $TEXTCOMMENTS; $map_trackbacks = $TRACKBACKS; $map_upload=$JUST_ADMIN_UPLOAD;
          if ($map_mail=="JA") {$map_mail=get_lang('yes');} if ($map_mail=="NEIN") {$map_mail=get_lang('no');}
          if ($map_rss =="JA") {$map_rss =get_lang('yes');} if ($map_rss =="NEIN") {$map_rss =get_lang('no');}
          if ($map_mp3 =="JA") {$map_mp3 =get_lang('yes');} if ($map_mp3 =="NEIN") {$map_mp3 =get_lang('no');}
          if ($map_upload =="JA") {$map_upload =get_lang('yes');} if ($map_upload =="NEIN") {$map_upload =get_lang('no');}
          if ($map_textcomments =="EIN") 		 {$map_textcomments =get_lang('ON');}
          if ($map_textcomments =="AUS") 		 {$map_textcomments =get_lang('OFF');}
          if ($map_textcomments =="NURANZEIGEN") {$map_textcomments =get_lang('JUSTSHOW');}
          if ($map_trackbacks   =="EIN") 		 {$map_trackbacks =get_lang('ON');}
          if ($map_trackbacks   =="AUS") 		 {$map_trackbacks =get_lang('OFF');}
          if ($map_trackbacks   =="NURANZEIGEN") {$map_trackbacks =get_lang('JUSTSHOW');}

          $smarty->assign('option_mail_array',	array(get_lang('yes'),get_lang('no')));
          $smarty->assign('option_mail',		$map_mail);
          $smarty->assign('option_rss_array',	array(get_lang('yes'),get_lang('no')));
          $smarty->assign('option_rss',			$map_rss);
          $smarty->assign('option_mp3_array',	array(get_lang('yes'),get_lang('no')));
          $smarty->assign('option_mp3',			$map_mp3);
          $smarty->assign('option_uploadjustadmin_array',	array(get_lang('yes'),get_lang('no')));
          $smarty->assign('option_uploadjustadmin',			$map_upload);

          $smarty->assign('option_textcomments_array',	array(get_lang('ON'),get_lang('OFF'),get_lang('JUSTSHOW')));
          $smarty->assign('option_textcomments',		$map_textcomments);
          $smarty->assign('option_trackbacks_array',	array(get_lang('ON'),get_lang('OFF'),get_lang('JUSTSHOW')));
          $smarty->assign('option_trackbacks',		    $map_trackbacks);

          // ### data for upload relay ####################################################
          if ($UPLOADRELAIS_SWITCH=="AN")
          {
            $smarty->assign('upload_an',        "checked");
            $smarty->assign('relais_uploadscript'	,$UPLOADRELAIS_UP_ADRESS);

            // check the settings / deliver setting menu
            // for upload relay

            if ($UPLOADRELAIS_DOWN_ADRESS=="")
            {
             $relais_info = get_lang('admin_relay_entryplease');
            }
            elseif (podbloggerservices::test_cgiRelay($UPLOADRELAIS_UP_ADRESS, $UPLOADRELAIS_DOWN_ADRESS))
            {
              $relais_info = get_lang('admin_relay_OK')." (".date("H:i:s",time()).")";
            }
            else
            {
              $relais_info = get_lang('admin_relay_problem')." (".date("H:i:s",time()).")";
            }

            $smarty->assign('relais_info',"<br>".$relais_info."<br><br>");
          }
          else
          { $smarty->assign('upload_an',""); }


          // ### data for converter service #################################################
          if ($AUDIOCONVERT_SWITCH=="AN")
          {
            $smarty->assign('convert_an',"checked");
            $smarty->assign('konverter_addresse',$AUDIOCONVERT_ADDRESS);

            // check the settings / deliver setting menu
            // for converter service

            if ($AUDIOCONVERT_ADDRESS=="")
            {
             $converter_info = get_lang('admin_text_entry_convert');
            }
            elseif (podbloggerservices::test_cgiConverter($AUDIOCONVERT_ADDRESS))
            {
              $converter_info = get_lang('admin_text_ok_convert')." (".date("H:i:s",time()).")";
            }
            else
            {
              $converter_info = get_lang('admin_text_no_convert')." (".date("H:i:s",time()).")";
            }

            $smarty->assign('konverter_info',"<br>".$converter_info."<br><br>");
          }
          else
          { $smarty->assign('convert_an',""); }

          // data for mail import
          if ($MAILIMPORT_SWITCH=="AN")
          {
            $smarty->assign('mail_an',          "checked");
            $smarty->assign('mail_pop',		    $MAILIMPORT_POP);
            $smarty->assign('mail_name',		$MAILIMPORT_NAME);
            $smarty->assign('mail_pass',		$MAILIMPORT_PASS);
            $mail_info  = "";

            if     ( ($MAILIMPORT_POP=="") && ($MAILIMPORT_NAME=="") && ($MAILIMPORT_PASS=="") )
            { $mail_info  = get_lang('admin_mail_entryplease'); }
            elseif ( ($MAILIMPORT_POP=="") || ($MAILIMPORT_NAME=="") || ($MAILIMPORT_PASS=="") )
            { $mail_info  = get_lang('admin_mail_moreentry'); }
            else
            {
              $ergebnis = test_pop3Login($MAILIMPORT_POP, $MAILIMPORT_NAME, $MAILIMPORT_PASS);
              if ($ergebnis=="OK")
              { $mail_info  = get_lang('admin_mail_ok')." (".date("H:i:s",time()).")"; }
              elseif ($ergebnis=="NOCONNECT")
              { $mail_info  = get_lang('admin_mail_badpop3')." (".date("H:i:s",time()).")"; }
              else
              { $mail_info  = get_lang('admin_mail_badlogin')." (".date("H:i:s",time()).")"; }
            }

            $smarty->assign('mail_info',		"<br>".$mail_info."<br><br>");
          }
          else
          { $smarty->assign('mail_an',          ""); }

          // dynamic layout plugin
          // all subfolders fromAlle htmlContent/smarty_templates with the file 'layout_definition.txt'
          // are valid for the admin menu layout

          if ($layout_array = layout::getAllLayoutPlugIns())
          {
            //build layout names and value array
            $layout_select_array 	= array();
            $layout_value_array		= array();
            $actual_layoutID_found  = FALSE;
            foreach ($layout_array as $o_layout)
            {
              array_push($layout_select_array,$o_layout->getName());
              array_push($layout_value_array,$o_layout->getID());
              if ($o_layout->getID() == $LAYOUT_ID) { $actual_layout = $o_layout; }
            }

            $smarty->assign('layout_select_array',	$layout_select_array);
            $smarty->assign('layout_value_array',	$layout_value_array);

            if (!isset($actual_layout))
            {
              $smarty->assign('layout_reply',"<br><font color='blue'>".get_lang('admin_layout_auto')."</font><br>");
              $LAYOUT_ID 		= $layout_array[0]->getID();
              $actual_layout 	= $layout_array[0];
              updateValueInConfigFile("LAYOUT_ID");
            }
            else
            {
              $smarty->assign('layout_reply',"");
            }

            $smarty->assign('layout_select',		$LAYOUT_ID);

            // load informations from the actuell layout
            $name 		= $actual_layout->getName();
            $author  	= $actual_layout->getAuthor();
            if ($author == "") {$author="-";}
            $homepage  	= "<a href='". $actual_layout->getHomepage() ."'>". $actual_layout->getHomepage() ."</a>";
            if ($actual_layout->getHomepage() == "") {$homepage="-";}
            $info = "<br>NAME: $name<br>AUTHOR: $author<br>HOMEPAGE: $homepage<br><br>";

            // maybe build formfields for layout definition fields
            $defs = $actual_layout->getDefinitionArray();

            if (count($defs) > 0)
            {
              $layout_definitionen = "<table border='0'>";
              foreach ($defs as $def)
              {
                // maybe calculate. maxlegth
                if (isset($def['maxlength'])) 	{$maxlength = $def['maxlength'];}
                else							{$maxlength = 0;}

                $layout_definitionen .= "<tr><td valign='top'>".$def['description']."&nbsp;</td><td>";

                $value =  $actual_layout->getDefinitionValue($def['smartyname']);

                //input field as oneline textfield
                if (($maxlength > 0) && ($maxlength < 100))
                {
                  if ($maxlength<40) {$size = $maxlength;} else {$size = 40;}
                  $layout_definitionen .= "<input name='layoutdef_".$def['smartyname']."' type='text' value='".$value."' size='".$size."' maxlength='".$maxlength."'>";
                }
                // input field as multiline textfield
                else
                {
                  $layout_definitionen .= "<textarea name='layoutdef_".$def['smartyname']."' cols='40' rows='5' wrap='VIRTUAL'>".$value."</textarea>";
                }

                $layout_definitionen .= "</td></tr>";
              }
              $layout_definitionen .= "</table>";
            }
            else
            {
              $layout_definitionen = "<font color='green'><strong>".get_lang('admin_layout_neednochange')."</strong></font><br><br>";
            }

            $layout_definitionen .= '<input name="lastLayoutID" type="hidden" id="lastLayoutID" value="'.$LAYOUT_ID.'">';
            $smarty->assign('layout_definitionen', $layout_definitionen);
          }
          else
          {
            //case that no layouts could be loaded
            $smarty->assign('layout_select_array'	,array(""));
            $smarty->assign('layout_value_array'	,array("0"));
            $smarty->assign('layout_select',		"0");
            $smarty->assign('layout_reply',		"<strong><font color='red'>".get_lang('admin_layout_problem2')."</font></strong><br><br>");
            $smarty->assign('layout_info',		"<br>".get_lang('admin_layout_nolayoutfound',LAYOUTDIR)."<br><br>");
            $smarty->assign('layout_definitionen', "");
          }

          // deliver template site
          $smarty->display('system_config.htm');
          exit();

        } // fin mode='menu'

      } // fin aktion='config'


      // --- statistics -----------------------------------
      // -------------------------------------------------
      else if ($aktion == "stats")
      {
      ?>
      <html>
        <head>
          <title><? print_lang('ADMINAREA'); ?> - <? print_lang('statistic'); ?></title>
          <link rel="stylesheet" href="htmlContent/design.css" type="text/css">
        </head>
        <body>
          <span class="text">
          <? printHeadline(get_lang('administration'),get_lang('statistic')); ?>

           <b>[</b>&nbsp;<a href="admin.php"><? print_lang('back'); ?></a>&nbsp;<b>]</b>&nbsp;<br>
      <? if (($PODCAST_RSS_STATS == "JA") || ($PODCAST_MP3_STATS == "JA"))
      {
         LogFile::compressOldLogs();

         if ($PODCAST_RSS_STATS == "JA")
         {

      // ------------------------- RSS-FEED-STATISTICS --------------------------

          $summe_heute   		= 0;
          $summe_gestern 		= 0;
          $summe_dieserMonat  	= 0;
          $summe_letzterMonat 	= 0;
          $summe_insgesamt		= 0;

        // -------- table header -------------
      ?>

      <p><font size="2" face="Arial, Helvetica, sans-serif"><strong><? print_lang('admin_statistic_rsshits'); ?></strong></font></p>
      <table width="75%" border="0" cellpadding="1" cellspacing="1" bgcolor="#000000">
      <tr>
        <td height="20" bgcolor="#222222"><font size="1" face="Arial, Helvetica, sans-serif">&nbsp;</font></td>
        <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('today'); ?></font></td>
        <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('yesterday'); ?></font></td>
        <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('thismonth'); ?> </font></td>
        <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('lastmonth'); ?> </font></td>
        <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('altogether'); ?></font></td>
      </tr>
      <?
        // -------- row for MAIN-RSS-Feed
      ?>
      <tr>
        <td height="20" align="left" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('lastmonth'); ?></font></td>
        <? $log = new LogFile("RSS/");
          $summe_heute   		+= $log->zugriffeHeute();
          $summe_gestern 		+= $log->zugriffeGestern();
          $summe_dieserMonat  	+= $log->zugriffeDieserMonat();
          $summe_letzterMonat 	+= $log->zugriffeLetzterMonat();
          $summe_insgesamt		+= $log->zugriffeInsgesamt();
        ?>
        <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeHeute(); ?></font></td>
        <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeGestern(); ?></font></td>
        <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeDieserMonat(); ?></font></td>
        <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeLetzterMonat(); ?></font></td>
        <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeInsgesamt(); ?></font></td>
      </tr>
      <?
        // -------- row for RSS-Feed by categorie

      foreach ($PODCAST_KATEGORIEN as $kategorie)
      {
        $log = new LogFile("RSS/".$kategorie);
        $summe_heute   			+= $log->zugriffeHeute();
        $summe_gestern 			+= $log->zugriffeGestern();
        $summe_dieserMonat  	+= $log->zugriffeDieserMonat();
        $summe_letzterMonat 	+= $log->zugriffeLetzterMonat();
        $summe_insgesamt		+= $log->zugriffeInsgesamt();
        ?>
        <tr>
          <td height="20" align="left" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('category'); ?>-'<? print $kategorie; ?>'-Feed</font></td>
          <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeHeute(); ?></font></td>
          <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeGestern(); ?></font></td>
          <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeDieserMonat(); ?></font></td>
          <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeLetzterMonat(); ?></font></td>
          <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeInsgesamt(); ?></font></td>
        </tr>
      <? }
        // -------- row for SUMME
       ?>
        <tr>
          <td height="20" align="left" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif">&nbsp;</font></td>
          <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_heute; ?></font></td>
          <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_gestern; ?></font></td>
          <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_dieserMonat; ?></font></td>
          <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_letzterMonat; ?></font></td>
          <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_insgesamt; ?></font></td>
        </tr>
    </table><br>

      <?
         }

      // ------------------------- MP3-STATISTIC --------------------------

         if ($PODCAST_MP3_STATS == "JA")
         {
           //sum variables for  the altogether counter
           $summe_heute   			= 0;
           $summe_gestern 			= 0;
           $summe_dieserMonat  		= 0;
           $summe_letzterMonat 		= 0;
           $summe_insgesamt			= 0;

           //sum variables Browserrequested content B=Browser
           $summeB_heute   			= 0;
           $summeB_gestern 			= 0;
           $summeB_dieserMonat  	= 0;
           $summeB_letzterMonat 	= 0;
           $summeB_insgesamt		= 0;

           //sum variables RSS requestet  F=Feed
           $summeF_heute   			= 0;
           $summeF_gestern 			= 0;
           $summeF_dieserMonat  	= 0;
           $summeF_letzterMonat 	= 0;
           $summeF_insgesamt		= 0;


           ?>
         <p><font size="2" face="Arial, Helvetica, sans-serif"><strong> <? print_lang('admin_statistic_mp3hits'); ?></strong></font>
        </p>

        <?
          // check if server is able to count iTunes hits by iTunes-URL-parameter-hack
          if (!testServerPath())
          {
           ?>
           <p><font size="2" face="Arial, Helvetica, sans-serif"><strong> <? print_lang('admin_statistic_noiTunesCount'); ?></strong></font>
           </p>
           <?
          }
        ?>

        <table width="75%" border="0" cellpadding="1" cellspacing="1" bgcolor="#000000">
          <tr>
            <td height="20" bgcolor="#222222"><font size="1" face="Arial, Helvetica, sans-serif">&nbsp;</font></td>
            <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('today'); ?><br>
              <font color="#888888">(RSS / Browser) </font></font></td>
            <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('yesterday'); ?><br>
              <font color="#888888">(RSS / Browser) </font></font></td>
            <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('thismonth'); ?><br>
              <font color="#888888">(RSS / Browser) </font></font></td>
            <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('lastmonth'); ?><br>
              <font color="#888888">(RSS / Browser) </font></font></td>
            <td width="15%" align="center" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print_lang('altogether'); ?><br>
              <font color="#888888">(RSS / Browser) </font></font></td>
          </tr>
           <?

           // -------- row for single MP3 files

           // table Public folder
           $Dateien = getFilesFromDirWithEnding("publicData","article");


           //build Array with Keys
           $keyArray = array();
           foreach ($Dateien as $datei)
           {
             $artikel = article::loadArticleFromFile("publicData/".$datei);
             if ($artikel->getFile()!="")
             {
               $keyArray[$artikel->getUnixTime()] = $artikel;
             }
           }

           uksort($keyArray,"cmp");
           reset($keyArray);

           if (count($keyArray) > 0)
           {
             foreach ($keyArray as $artikel)
             {

               // load logfiles
               $log = new LogFile("publicData/".$artikel->getFile());

               //sum variables for altogether
               $summe_heute            += $log->zugriffeHeute();
               $summe_gestern          += $log->zugriffeGestern();
               $summe_dieserMonat      += $log->zugriffeDieserMonat();
               $summe_letzterMonat     += $log->zugriffeLetzterMonat();
               $summe_insgesamt        += $log->zugriffeInsgesamt();

               // sum variables for Browser access   B=Browser
               $summeB_heute            += $log->zugriffeHeute("BROWSER");
               $summeB_gestern          += $log->zugriffeGestern("BROWSER");
               $summeB_dieserMonat      += $log->zugriffeDieserMonat("BROWSER");
               $summeB_letzterMonat     += $log->zugriffeLetzterMonat("BROWSER");
               $summeB_insgesamt        += $log->zugriffeInsgesamt("BROWSER");

               // sum variables for RSS access       F=Feed
               $summeF_heute            += $log->zugriffeHeute("RSS");
               $summeF_gestern          += $log->zugriffeGestern("RSS");
               $summeF_dieserMonat      += $log->zugriffeDieserMonat("RSS");
               $summeF_letzterMonat     += $log->zugriffeLetzterMonat("RSS");
               $summeF_insgesamt        += $log->zugriffeInsgesamt("RSS");

               $file 	= $artikel->getFile();
               $titel 	= $artikel->getTitle();
               if (strlen($file) > 50) 	{$file 	= substr($file,0,45)."...";}
               if (strlen($titel)> 50)  {$titel = substr($titel,0,45)."...";}

               ?>
              <tr>
                <td height="40" align="left" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif"><? print $titel; ?><br>
                  <font color="#999999"><? print $file; ?></font></font></td>
                <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeHeute(); ?><br>
                  <font color="#AAAAAA">(<? print $log->zugriffeHeute("RSS"); ?> / <? print $log->zugriffeHeute("BROWSER"); ?>) </font></font></td>
                <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeGestern(); ?><br>
                  <font color="#AAAAAA">(<? print $log->zugriffeGestern("RSS"); ?> / <? print $log->zugriffeGestern("BROWSER"); ?>)</font></font></td>
                <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeDieserMonat(); ?><br>
                  <font color="#AAAAAA">(<? print $log->zugriffeDieserMonat("RSS"); ?> / <? print $log->zugriffeDieserMonat("BROWSER"); ?>)</font></font></td>
                <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeLetzterMonat(); ?><br>
                  <font color="#AAAAAA">(<? print $log->zugriffeLetzterMonat("RSS"); ?> / <? print $log->zugriffeLetzterMonat("BROWSER"); ?>)</font></font></td>
                <td align="center" bgcolor="#FFFFFF"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $log->zugriffeInsgesamt(); ?><br>
                  <font color="#AAAAAA">(<? print $log->zugriffeInsgesamt("RSS"); ?> / <? print $log->zugriffeInsgesamt("BROWSER"); ?>)</font></font></td>
              </tr>
               <?
             }
           }
           else
           {
             print "<tr><td bgcolor='#FFFFFF'><center>- Bisher keine MP3-Dateien im System -</center></td></tr>";
           }

           // SUM
           ?>
              <tr>
                <td height="40" align="left" bgcolor="#222222"><font color="#FFFFFF" size="1" face="Arial, Helvetica, sans-serif">&nbsp;</font></td>
                <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_heute; ?><br>
                  <font color="#666666">(<? print $summeF_heute; ?> / <? print $summeB_heute; ?>) </font></font></td>
                <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_gestern; ?><br>
                  <font color="#666666">(<? print $summeF_gestern; ?> / <? print $summeB_gestern; ?>) </font></font></td>
                <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_dieserMonat; ?><br>
                  <font color="#666666">(<? print $summeF_dieserMonat; ?> / <? print $summeB_dieserMonat; ?>) </font></font></td>
                <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_letzterMonat; ?><br>
                  <font color="#666666">(<? print $summeF_letzterMonat; ?> / <? print $summeB_letzterMonat; ?>) </font></font></td>
                <td align="center" bgcolor="#FFAAAA"><font color="#000000" size="1" face="Arial, Helvetica, sans-serif"><? print $summe_insgesamt; ?><br>
                  <font color="#666666">(<? print $summeF_insgesamt; ?> / <? print $summeB_insgesamt; ?>) </font></font></td>
              </tr>
        </table><br><br>
           <?
         }


       } else print(get_lang('admin_statistic_notactive')."<br><br>");

      printEndline('<b>[</b>&nbsp;<a href="admin.php">'.get_lang('back').'</a>&nbsp;<b>]</b');
      exit();
      }
    }

    if ($show_menu)
    {
    // ----- ADMIN-menu ---------
    ?>
      <html>
        <head>
          <title><? print_lang('ADMINAREA'); ?> - <? print_lang('menu'); ?></title>
          <?
            if (ticketmanager::areTicketsActive())
            {
              // there som tickets in process therefor  refresh the Admin menu,more often

              print "<meta http-equiv='refresh' content='15; URL=http://".HTTP_BASISADRESSE."admin.php'>";
            }
            else
            {
              // refreshing with normal period
              print "<meta http-equiv='refresh' content='180; URL=http://".HTTP_BASISADRESSE."admin.php'>";
            }
            ?>
          <link rel="stylesheet" href="htmlContent/design.css" type="text/css">
        </head>
        <body>
          <span class="text">
          <? printHeadline(get_lang('administration'),"Version ".$PODBLOGGER_VERSION ); ?>

           <b>[</b>&nbsp;<a href="index.php"><? print_lang('startpage'); ?></a>&nbsp;<b>]</b>&nbsp;
           <b>[</b>&nbsp;<a href="admin.php?aktion=config&mode=menu"><? print_lang('config'); ?></a>&nbsp;<b>]</b>&nbsp;
           <b>[</b>&nbsp;<a href="upload.php"><? print_lang('mp3upload'); ?></a>&nbsp;<b>]</b>&nbsp;
           <? if (($MAILIMPORT_SWITCH == "AN")) {?>
           <b>[</b>&nbsp;<a href="admin.php?aktion=checkaudiomail"><? print_lang('audiomailcheck'); ?></a>&nbsp;<b>]</b>&nbsp;
           <? } ?>
           <? if (($PODCAST_RSS_STATS == "JA") || ($PODCAST_MP3_STATS == "JA")) {?>
           <b>[</b>&nbsp;<a href="admin.php?aktion=stats"><? print_lang('statistic'); ?></a>&nbsp;<b>]</b>&nbsp;
           <? }
           if ( (isset($GLOBALS['INTERNAL_ARCHIVE_MODE']))
             && ($GLOBALS['INTERNAL_ARCHIVE_MODE']=="ON") )
           { ?>
           <b>[</b>&nbsp;<a href="admin.php?aktion=autodelete&schritt=1"><? print_lang('autodelete'); ?></a>&nbsp;<b>]</b>&nbsp;
           <? } ?>
           <b>[</b>&nbsp;<a href="admin.php"><? print_lang('refresh'); ?></a>&nbsp;<b>]</b>&nbsp;
           <b>[</b>&nbsp;<a href="admin.php?aktion=logout"><? print_lang('logout'); ?></a>&nbsp;<b>]</b>&nbsp;&nbsp;&nbsp;

           <?
               print "<strong>".get_lang('usedspace')." : </strong>".round(getUsedWebspace()/(1024*1024))."MB";
               if ($WEBSPACE_LIMIT>0) print "<strong>&nbsp;von </strong>".round($WEBSPACE_LIMIT/(1024*1024))."MB";
           ?>
           <br>

           <?
             if (isset($GLOBALS['reply_on_admin_menu']))
             {
               print "<br><font size='2'><strong>".$GLOBALS['reply_on_admin_menu']."</strong></font><br>";
             }
           ?>
<br>
           <table width="75%" border="0" cellpadding="1" cellspacing="1" bgcolor="#000000">
           <tr><th colspan="2" class="admin"><b><? print_lang('admin_menu_filesinupload'); ?></b></th></tr>
           <?
             $anz = 0;
             // table for the Upload FolderVerzeichnis
             $Dateien = getFilesFromDirWithEnding("uploadData","article");
             if (count($Dateien) > 0)
             {
               foreach ($Dateien as $datei)
               {
                 $artikel = article::loadArticleFromFile("uploadData/".$datei);

                 if ($artikel->checkValid())
                 {
                   $anz++;
	  			   $size = round(filesize("uploadData/".$artikel->getFile()) / 1048576);
				   if ($size == 0) {$size = 1;}

                   print "<tr><td bgcolor='#FFFFFF' width='80%'><center><br><table width='90%' border='0' align='center' cellpadding='1' cellspacing='1' bgcolor='#DDDDDD'>";
                   print "<tr><td bgcolor='#FFFFFF'><br><b><font color='blue'>".$artikel->getCategory()."</font>: '".$artikel->getTitle()."'</b><br><br</td></tr>";
                   print "<tr><td bgcolor='#EEEEEE'><font color='black'>".get_lang('file').":</font></td></tr>";
                   print "<tr><td bgcolor='#FFFFFF'>"; $space=FALSE;
                   foreach ($artikel->getAllAppendantFiles() as $file)
                   {
                     if ($space) {print "<br>";} else {$space=TRUE;}
                     print "uploadData/".$file." (ca. ".$size."MB)";
                     if (!file_exists("uploadData/".$file)) {print "<strong><font color='red'> !!not found!!</font></strong>";}
                   }
                   print "</td></tr>";
                   if (strlen($artikel->getDescription()) > 2 )
                   {
                   print "<tr><td bgcolor='#EEEEEE'><font color='black'>".get_lang('description')."</font></td></tr>";
                   print "<tr><td bgcolor='#FFFFFF'>".
                         bbcode_inc::renderBBCode($artikel->getDescription()).
                         "</td></tr>";
                   }
                   print "<tr><td bgcolor='#EEEEEE'><font color='black'>".get_lang('admin_menu_moreinfo')."</font></td></tr>";
                   print "<tr><td bgcolor='#FFFFFF'>".get_lang('date').": ".date("j.n.y - H:i",$artikel->getUnixTime())." id:".$artikel->getID();
                   if ( (strlen($artikel->getAuthorName()) > 2) || (strlen($artikel->getAuthorMail()) > 2))  print "<br>".get_lang('author').": ".$artikel->getAuthorName()." / ".$artikel->getAuthorMail();
                   if (strlen($artikel->getAuthorXtra()) > 2) print ", ".$artikel->getAuthorXtra();
                   if (($artikel->getAuthorComment()!="-".get_lang('nocomment')."-") && ($artikel->getAuthorComment()!="")) print "<br>".get_lang('comment').": ".$artikel->getAuthorComment();
                   // if necessary.show tickets
                   $activeTickets = 0;
                   if ( count(ticketmanager::getAllTicketsForArticle($artikel->getID())) > 0 )
                   {
                     print "</td></tr><tr><td bgcolor='#EEEEEE'>".get_lang('admin_tickets').":";
                     print "</td></tr><tr><td bgcolor='#FFFFFF'><font color='black'>";

                     foreach (ticketmanager::getAllTicketsForArticle($artikel->getID()) as $ticket)
                     {
                       $state = trim(ticketmanager::getState($ticket));
                       if ($state!="DONE") $activeTickets++;

                       print "<table border='0' width='100%'><tr><td>";
                       if (ticketmanager::getType($ticket)=="CONVERT")
                       {
                         print "<b>".get_lang('admin_convertticket')." '".ticketmanager::getData($ticket)."'</b><br>".get_lang('admin_ticketdate')." ".date("j.n.y - H:i",ticketmanager::getTime($ticket))."<br>";
                         print "".get_lang('ticketstate').": ";
                         if   ($state=="DONE") {print "<font color='green'>".get_lang('ticketstate_'.$state)."</font>";}
                         else                  {print "<font color='red'>  ".get_lang('ticketstate_'.$state)."</font>";}
                       }
                       else
                       {
                         print "Not defined Ticket-Type";
                       }
                       print "</td><td width='100' align='right' valign='top'>";
                       if ($state!="DONE") print "<strong>[</strong>&nbsp;<a href='admin.php?aktion=del_ticket&id=".urlencode(ticketmanager::getID($ticket))."'>".get_lang('com_abort')."</a>&nbsp;<strong>]</strong>";
                       print "</td></tr></table><hr width='100%'>";
                     }
                   }
                   print "</td></tr>";

                   print "</table></center><br></td><td valign='top' bgcolor='#DDDDDD'><br>";

                   // show options for article that do not begin with '!!'
                   $kategorie = $artikel->getCategory();
                   print '<b>[</b>&nbsp;<a href="admin.php?aktion=download&dat='.urlencode($datei).'">'.get_lang('com_download').'</a>&nbsp;<b>]</b><br>';
                   print '<b>[</b>&nbsp;<a href="admin.php?aktion=edit&dat='.urlencode($datei).'&verzeichnis=uploadData&schritt=1">'.get_lang('com_edit').'</a>&nbsp;<b>]</b><br>';
                   if (($artikel->isReadyToPublish()) && ($activeTickets==0))
                   {
                     print '<b>[</b>&nbsp;<a href="admin.php?aktion=makepublic&dat='.urlencode($datei).'">'.get_lang('com_publish').'</a>&nbsp;<b>]</b><br>';
                   }
                   print '<b>[</b>&nbsp;<a href="admin.php?aktion=delete&dat='.urlencode($datei).'&verzeichnis=uploadData">'.get_lang('com_delete').'</a>&nbsp;<b>]</b><br>';
                   print "</td></tr>";
                 }
               }
             }
             if ($anz==0)
             {
               print "<tr><td bgcolor='#FFFFFF'><center>- ".get_lang('nofiles')." -</center></td></tr>";
             }
           ?>
           </table>
           </p>
           <p>
           <table width="75%"  border="0" cellpadding="1" cellspacing="1" bgcolor="#000000">
          <!-- <tr><th colspan="2" class="admin"><b><? print_lang('admin_menu_filespublished'); ?></b></th></tr>-->
           <?
             // table Public-folder
             $Dateien = getFilesFromDirWithEnding("publicData","article");

             //build array with Keys
             $keyArray = array();
             foreach ($Dateien as $datei)
             {
               $artikel = article::loadArticleFromFile("publicData/".$datei);
               if ($artikel->getFile()!="")
               {
                 $keyArray[$artikel->getUnixTime()] = $artikel;
               }
             }

             uksort($keyArray,"cmp");
             reset($keyArray);

             $show_delete = TRUE;
             if ( (isset($GLOBALS['INTERNAL_ARCHIVE_MODE'])) && ($GLOBALS['INTERNAL_ARCHIVE_MODE']=="ON") )
             {$show_delete = FALSE; }

             if (count($keyArray) > 0)
             {
               foreach ($keyArray as $artikel)
               {
                 print "<tr><td bgcolor='#FFFFFF' width='80%'><center>";

				 $size = round(@filesize("publicData/".$artikel->getFile()) / 1048576);
				 if ($size == 0) {$size = 1;}

                   print "<br><table width='90%' border='0' align='center' cellpadding='1' cellspacing='1' bgcolor='#DDDDDD'>";
                   print "<tr><td bgcolor='#FFFFFF'><br><b><font color='blue'>".$artikel->getCategory()."</font>: '".$artikel->getTitle()."'</b><br><br</td></tr>";
                   print "<tr><td bgcolor='#EEEEEE'><font color='black'>".get_lang('file').":</font></td></tr>";
                   print "<tr><td bgcolor='#FFFFFF'>"; $space=FALSE;
                   foreach ($artikel->getAllAppendantFiles() as $file)
                   {
                     if ($space) {print "<br>";} else {$space=TRUE;}
                     print "publicData/".$file." (ca. ".$size."MB)";
                     if (!file_exists("publicData/".$file)) {print "<strong><font color='red'> !!not found!!</font></strong>";}
                   }
                   print "</td></tr>";

                   if (strlen($artikel->getDescription()) > 2 )
                   {
                   print "<tr><td bgcolor='#EEEEEE'><font color='black'>".get_lang('description')."</font></td></tr>";
                   print "<tr><td bgcolor='#FFFFFF'>".
                         bbcode_inc::renderBBCode($artikel->getDescription()).
                         "</td></tr>";
                   }
                   print "<tr><td bgcolor='#EEEEEE'><font color='black'>".get_lang('admin_menu_moreinfo')."</font></td></tr>";
                   print "<tr><td bgcolor='#FFFFFF'>".get_lang('date').": ".date("j.n.y - H:i",$artikel->getUnixTime())." id:".$artikel->getID();
                   if ( (strlen($artikel->getAuthorName()) > 2) || (strlen($artikel->getAuthorMail()) > 2))  print "<br>".get_lang('author').": ".$artikel->getAuthorName()." / ".$artikel->getAuthorMail();
                   if (strlen($artikel->getAuthorXtra()) > 2) print ", ".$artikel->getAuthorXtra();
                   // if necessary.show comments
                   if ( $artikel->gotComments() )
                   {
                     print "</td></tr><tr><td bgcolor='#EEEEEE'>".get_lang('comments').":";
                     print "</td></tr><tr><td bgcolor='#FFFFFF'><font color='black'>";
                     foreach ($artikel->getComments() as $comment)
                     {
                       // check if comment is younger than 3 days
                       if ($comment->getPublishedUnixtime()>(time()-(3*24*60*60)))	{$neu = TRUE;}
                       else 														{$neu = FALSE;}

                       print "<table border='0' width='100%'><tr><td>";#
                       if ($neu) {print "<strong><font color='red'>".get_lang('NEW')."</font>:</strong>&nbsp;";}
                       if ($comment->getType()=="TEXTCOMMENT")
                       {
                         print "<b>".get_lang('textcomment')."</b> ".get_lang('by')." <b>".htmlspecialchars($comment->getAuthorName())."</b><br>";
                         print htmlspecialchars($comment->getCommenttext())."<br>";
                       }
                       elseif ($comment->getType()=="TRACKBACK")
                       {
                         $tb_url 	 = $comment->geturl();
                         $tb_name 	 = $comment->getBlogname();
                         $tb_title   = $comment->getTitle();
                         $tb_excerpt = $comment->getExcerpt();

                         if ($tb_name=="") {$tb_name="-";}

                         print "<strong>".get_lang('trackback')."</strong> ".get_lang('by')." <strong>".htmlspecialchars($tb_name)."</strong><br>";
                         print "<strong>URL</strong>: <a href='".$tb_url."'>".$tb_url."</a><br>";
                         if ($tb_title!="")   { print "<strong>".get_lang('title')."</strong>: ".htmlspecialchars($tb_title)."<br>"; }
                         if ($tb_excerpt!="") { print "<strong>".get_lang('excerpt')."</strong>: ".htmlspecialchars($tb_excerpt)."<br>"; }
                       }
                       else
                       {
                         print "Not defined Comment";
                       }
                       print "(".get_lang('date').": ".date("j.n.y - H:i",$comment->getPublishedUnixtime()).") (IP:".$comment->getAuthorIP()." = ".$comment->getAuthorHOST().")";
                       print "</td><td width='100' align='right' valign='top'><strong>[</strong>&nbsp;<a href='admin.php?aktion=del_comment&article=".urlencode($artikel->getID())."&id=".$comment->getPublishedUnixtime()."'>".get_lang('com_delete')."</a>&nbsp;<strong>]</strong></td></tr></table><hr width='100%'>";
                     }
                   }
                   print "</td></tr></table><br>";


                 print "</center></td><td valign='top' bgcolor='#DDDDDD'><br>";
                 //show options for comments that do not begin with '!!'
                 $kategorie = $artikel->getCategory();
                 if ($kategorie[1]!='!')
                 {
                   print '<b>[</b>&nbsp;<a href="admin.php?aktion=edit&dat='.urlencode($artikel->getID().".article").'&verzeichnis=publicData&schritt=1">'.get_lang('com_edit').'</a>&nbsp;<b>]</b><br>';
                   if ($show_delete) print '<b>[</b>&nbsp;<a href="admin.php?aktion=delete&dat='.urlencode($artikel->getID().".article").'&verzeichnis=publicData">'.get_lang('com_delete').'</a>&nbsp;<b>]</b><br>';
                 }
                 print "</td></tr>";
               }
             }
             else
             {
               print "<tr><td bgcolor='#FFFFFF'><center>- ".get_lang('nofiles')." -</center></td></tr>";
             }
           ?>
           </table>
           </p><br>
           <? printEndline(menuButtonStr(get_lang('startpage'),"index.php")." ".menuButtonStr(get_lang('logout'),"admin.php?aktion=logout")); ?>
          </span>
        </body>
      </html>
    <?
    //} // fin if showmenu
    } // fin if isset(aktion)
  }
  else
  {
    die("FEHLER: Undefinierter Loginzustand. / unknown loginstate");
  }
/**
* Name printHeadline($text1,$text2)
*
* Print the html headline
*
*/
    function printHeadline($text1,$text2)
  {
  ?>
    <table width="100%" border="0" cellpadding="3" cellspacing="1" bordercolor="#000000" bgcolor="#000000">
      <tr>
        <td bgcolor="#FFFFFF"> <div align="left">
            <table width="100%" border="0" cellspacing="1" cellpadding="1">
              <tr>
                <td width="230" height="21" align="left" valign="middle">
      <a href="http://www.rotzoll.de/podblogger">
      <img src="htmlContent/grafiken/podblogger_logo.gif" width="209" height="77" border="0" align="absmiddle"></a></td>
                <td align="left" valign="middle">
                <font size="6" face="Arial, Helvetica, sans-serif"><strong>
                <? print $text1; ?>
                </strong></font></td>
                <td width="120" align="center" valign="middle">
                <font size="2" face="Arial, Helvetica, sans-serif"><strong>
                <? print $text2; ?>
                </strong></font></td>
              </tr>
            </table>
          </div></td>
      </tr>
    </table>
    <font size="3" face="Arial, Helvetica, sans-serif"> <br>
  <?
  }
/**
* Name printHeadline($text1,$text2)
*
* Print the html Endline
*
*/
  function printEndline($content)
  {
  ?>
    <table width="100%" border="0" cellpadding="3" cellspacing="1" bordercolor="#000000" bgcolor="#000000">
      <tr>
        <td bgcolor="#FFFFFF"> <div align="left">
            <table width="100%" border="0" cellspacing="1" cellpadding="1">
              <tr>
                <td height="21" align="left" valign="middle">
                <font size="2" face="Arial, Helvetica, sans-serif">&nbsp;
                <? print $content; ?>
                </font></td>
                <td width="120" align="center" valign="middle">
                <font size="1" face="Arial, Helvetica, sans-serif"><? print_lang('programmedby'); ?><br>
                  christian rotzoll</font></td>
              </tr>
            </table>
          </div></td>
      </tr>
    </table>
    <?
      if ($content != "")
      { ?>
            <font size="1" face="Arial, Helvetica, sans-serif">
            <br><a href="http://smarty.php.net/" target="_blank"><img src="htmlContent/grafiken/smarty_icon.gif" border=0></a>&nbsp;<? print_lang('admin_menu_smartyinfo'); ?>
            </font>
        <?
      }
  }

// deletes a artclefile with all its append files
function private_delete_article($articlefile)
{
    if (file_exists($articlefile))
    {
        $verzeichnis = array_shift(explode("/",$articlefile));
        $artikel = article::loadArticleFromFile($articlefile);

        // delete all audiofiles that belong to the article object
        foreach ($artikel->getAllAppendantFiles() as $file)
        {
          @unlink($verzeichnis."/".$file);
        }

        // delete all tickets that belong to the article object
        ticketmanager::deleteAllTicketsForArticle($artikel->getID());

        // delet the article file itself
        @unlink($articlefile);

        // delete the stat file if exist
        $id = str_replace("/","___v___",$verzeichnis."/".$artikel->getFile());
        @unlink("stats/".$id.".log");
    }
}

/**
* Name: test_fopen()
*
* test the fopen funktion
* return TRUE or FALSE
*/
  function test_fopen()
  {
      if (!@fopen(AUTO_RELAIS_SCRIPT,"r"))
      {
        if (!@fopen("http://".HTTP_BASISADRESSE."/rss.php","r"))
        { return FALSE; }
      }
      return TRUE;
  }
// Finnegans Wake
?>