<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #     
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #################################################
  # convert-Script                                #
  #################################################

  # this script is used to implement the Interface for the audiofile convert
  # service 

  # for debuging use ?debug=true , parameter

  /**
  * Neededfiles
  * 
  * require_once("include/funktions_sammlung.inc.php");
  * require_once("include/article.class.php");
  * require_once("include/audioconverter.class.php");
  * require_once("include/ticketmanager.inc.php");
  */
  require_once("include/funktions_sammlung.inc.php");
  require_once("include/article.class.php");
  require_once("include/audioconverter.class.php");
  require_once("include/ticketmanager.inc.php");

  $PHP_CALLBACKADDRESS			= "http://".HTTP_BASISADRESSE."convert.php";
  $PERLCONVERTER_ADDRESS		= $AUDIOCONVERT_ADDRESS;
  
  /**
  * Name: writeLog($text)
  *
  * Function to write the podbloggerData/convert.php.log
  * file.
  */
  function writeLog($text)
  {
    if ($fp = fopen("podbloggerData/convert.php.log","a"))
    {
      fwrite($fp,"new:".$text.";\n\r");
      fclose($fp);
    }
  }
  /**
  * Name: sendReturnCodeAndExit($code, $message)
  *
  * Sends a return code and exit the script
  */
  function sendReturnCodeAndExit($code, $message)
  {
    # Code-Tabelle: 0 = Alles OK; 1 = Fehler

    writeLog("sendReturnCodeAndExit: ".$code.":".$message);

    if (!headers_sent())
    {
      if ($code!=0)
      {
        header("HTTP/1.1 404 Not Found");
        audioconverter::writeErrorLog("404:".$message);
      }
      else
      { header("HTTP/1.1 200 OK");}

      header("Content-Type: text/plain");
    }

    if ( (isset($GLOBALS['debug'])) && ($GLOBALS['debug'])) print "\n!!! PROTOKOLL RETURN CODE !!!\n";

    print ($code."\n".$message);

    if ( (isset($GLOBALS['debug'])) && ($GLOBALS['debug'])) print "\n!!!!!!!!!!!!!!!!!!!!!!!!!!!!!";
    exit();
  }

  writeLog("1");

  // check if the debug paramter is set
  if (issetPostGet('debug')) {$debug = TRUE; header("Content-Type: text/plain");}
  else {$debug = FALSE;	}
  // get the ACTION parameter
  if (issetPostGet('action')) {$action = getPostGetText('action');}
  else { writeLog("Missing Action-parameter");  sendReturnCodeAndExit(1,"Parameter 'action' fehlt!");		}

  if ($action=="getfile")
  {
    //get the Artikel ID
    if (issetPostGet('articleid')) {$articleid = getPostGetText('articleid');}
    else { sendReturnCodeAndExit(1,"Parameter 'articleid' fehlt!");	}
    //get Audiofile Sourceformat 
    if (issetPostGet('sourceformat')) {$sourceformat = getPostGetText('sourceformat');}
    else { sendReturnCodeAndExit(1,"Parameter 'sourceformat' fehlt!");	}
    //get the unique Ticketcode
    if (issetPostGet('ticketcode')) {$ticketcode = getPostGetText('ticketcode');}
    else { sendReturnCodeAndExit(1,"Parameter 'ticketcode' fehlt!");	}

    // check if the ticketcode match the right article and if it fit's
    if ($debug) print "--- Ticketcode prfen ---\n";
    if (!ticketmanager::isTicketValid("CONVERT",$articleid,$ticketcode))
    {sendReturnCodeAndExit(1,"Ticket not valid. ($articleid/$ticketcode)");}
    else {if ($debug) print "Ticket ist gltig\n\n";}

    // search where the aricle is (first folder Uploaddata)
    if ($debug) print "--- Artikel suchen ---\n";
    if ($debug) print "Suche in uploadData:\n";
    $filelist = getFilesFromDirWithEnding("uploadData","article");
    foreach ($filelist as $file)
    {
      $datid = array_shift(explode(".",$file));
      if ($debug) print "$file/$datid/$articleid";
      if ($datid==$articleid)
      {
        if ($debug) print "/Die gesuchte Datei";
        $article_object = article::loadArticleFromFile("uploadData/".$file);
        $directory = "uploadData";
      }
      if ($debug) print "\n";
    }
    //if file was not found than check folder publicData
    if (!isset($article_object))
    {
      if ($debug) print "Suche in publicData:\n";
      $filelist = getFilesFromDirWithEnding("publicData","article");
      foreach ($filelist as $file)
      {
        $datid = array_shift(explode(".",$file));
        if ($debug) print "$file/$datid/$articleid";
        if ($datid==$articleid)
        {
          if ($debug) print "/Die gesuchte Datei";
          $article_object = article::loadArticleFromFile("publicData/".$file);
          $directory = "publicData";
          if (!is_Object($article_object)) {sendReturnCodeAndExit(1,"Fehler bei Konstruktion des Artikelobjektes.");}
        }
        if ($debug) print "\n";
      }
    }
    //in case of founding no file than report an error
    if (!isset($article_object))
    {
      sendReturnCodeAndExit(1,"Artikel nicht gefunden:".$articleid);
    }
    else
    {
      if ($debug) print "\n--- Datei ausliefern ---\n";
      // read the audiofile name from the <ID>.aticle file
      $filename = $article_object->getFile();
      if ($debug) print "Dateiname:".$filename."\n";
      if ($debug) print "Verzeichnis:".$directory."\n";

      //split the file name from file suffix
      $parts 		= explode(".",$filename); array_pop($parts);
      $dateiname 	= implode(".",$parts);

      // take a look if the file exists
      // Attantion: the file case musst be lowercase
      $sourcedatei = $directory."/".$dateiname.".".strtolower($sourceformat);
      if ($debug) print "Gesucht ist:".$sourcedatei."\n";

      if (file_exists($sourcedatei))
      {
        if ($debug) print "OK. Datei existiert.\n";

        //delivering file
        if (!headers_sent())
        {
          header("HTTP/1.1 200 OK");
          if (strtolower($sourceformat) == "mp3") { header("Content-type: audio/mpeg"); }
          if (strtolower($sourceformat) == "ogg") { header("Content-type: application/ogg"); }
          if (strtolower($sourceformat) == "wav") { header("Content-type: audio/x-wav"); }
          header("Content-Disposition: attachment; filename=".$dateiname.".".strtolower($sourceformat));
        }
        if ($debug)  print "\n--- JETZT WRDE DIE DATEI AUSGEGEBEN WERDEN ---\n";
        if ($debug)  print "--- FERTIG-------------------------------------\n";
        if (!$debug) readfile($sourcedatei);
        exit();
      }
      else
      {
        // file not found
        if ($debug) print "Die Datei im angeforderten Format existiert nicht.\n";
        sendReturnCodeAndExit(1,"Datei nicht gefunden");
      }
    }
  }

  writeLog("2");

  if ($action=="fileready")
  {
    writeLog("START fileready");

    // get article ID
    if (issetPostGet('articleid')) {$articleid = getPostGetText('articleid');}
    else { sendReturnCodeAndExit(1,"Parameter 'articleid' fehlt!");	}
    // get targetformat 
    if (issetPostGet('targetformat')) {$targetformat = getPostGetText('targetformat');}
    else { sendReturnCodeAndExit(1,"Parameter 'targetformat' fehlt!");	}
    // get ticketcode bernehmen
    if (issetPostGet('ticketcode')) {$ticketcode = getPostGetText('ticketcode');}
    else { sendReturnCodeAndExit(1,"Parameter 'ticketcode' fehlt!");}

    writeLog("got parameter");    

    // search where an article file is to find (first look at Uploaddata)
    if ($debug) print "--- Artikel suchen ---\n";
    if ($debug) print "Suche in uploadData:\n";
    $filelist = getFilesFromDirWithEnding("uploadData","article");
    foreach ($filelist as $file)
    {
      $datid = array_shift(explode(".",$file));
      if ($debug) print "$file/$datid/$articleid";
      if ($datid==$articleid)
      {
        if ($debug) print "/Die gesuchte Datei";
        $article_object = article::loadArticleFromFile("uploadData/".$file);
        $directory = "uploadData";
      }
      if ($debug) print "\n";
    }

    // if not found give back error massage
    if (!isset($article_object))
    {
      sendReturnCodeAndExit(1,"Artikel nicht gefunden");
    }
    else
    {
      writeLog("Artcile found - Checking ticketcode");
      
      // check ticketcode
      if ($ticketID = ticketmanager::isTicketValid("CONVERT",$articleid,$ticketcode))
      { writeLog("Ticket is valid"); }
      else
      { sendReturnCodeAndExit(1,"Ticket not valid"); }
      
      // --- process data from ticket file Daten aus Ticket aufbereiten
      $ticket = ticketmanager::getTicketById($ticketID);
      $convertOrder = audioconverter::parseConvertOrder(ticketmanager::getData($ticket));
      
      // --- generate the name for a new file
      $qualityAddition = ""; if ($convertOrder['targetQuality']!="NORM") {$qualityAddition="_".$convertOrder['targetQuality'];}
      $filename = $article_object->getFile();
      $tmp = explode(".",$filename); array_pop($tmp);
      $newfilename = (implode(".",$tmp)).$qualityAddition.".".(strtolower($targetformat));

      // --- catch the file from from convertservice
      writeLog("connect to:".$PERLCONVERTER_ADDRESS);
      $converter = new audioconverter($PERLCONVERTER_ADDRESS,$PHP_CALLBACKADDRESS);
      if ($converter->downloadConvertedAudio($directory."/".$newfilename, $articleid, $targetformat))
      {
        writeLog("Download ready - Writing article and delting ticket");
        
        // declare ticket  as "DONE" for finishing the process
        ticketmanager::setState($ticketID,"DONE");
        
	// put the file referenz into the aticle file
        writeLog("setFile: ".$newfilename."/".$convertOrder['targetFormat']."/".$convertOrder['targetQuality']);        
        $article_object->setFile($newfilename,$convertOrder['targetFormat'],$convertOrder['targetQuality']);
        $article_object->save($directory);
      }
      else
      {
        ticketmanager::setState($ticketID,"ERROR_pickup_failed");
        sendReturnCodeAndExit(1,"Error on download");
      }

      sendReturnCodeAndExit(0,"OK. File downloaded");
    }
  }

sendReturnCodeAndExit(1,"Ungewoehlicher Programmverlauf");
?>