<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # getMedia-Script                               #
  #################################################

  # this Script is used to count or regulate the Mp3 file access

  @require_once("include/funktions_sammlung.inc.php");
  @require_once("include/LogFile.class.php");
  @require_once("include/testServerPath.inc.php");
  @require_once("include/layout.class.php"); // for the systemvalues by layout plugin

  // check how much should be logged for one file e.g.. (RSS|Download|Flash)
  if (issetPostGet('log'))
  {
    if ($PODCAST_MP3_STATS == "JA")
    {
      $file = getPostGetText('log');
      $ip = $REMOTE_ADDR."|".gethostbyaddr($REMOTE_ADDR);
      LogFile::writeLog($file, $ip, "BROWSER");
      header("Content-type: application/x-www-form-urlencoded");
      print "antwort=ok";
      exit();
    }
  }

  // to take over Parameter
  if (issetPostGet('file')) {$file = getPostGetText('file');}
  else
  {
    // try to get iTunesHack Parameters from URL
    $file=getHackParametersFromURL();
    if ($file == "") {exit("Parameterconfiguration is unvalid.");}
  }
  
  // security check if (just publicData directory is allowed for access)
  if (stristr($file,"publicData")==FALSE) {exit("sorry, invalid access");}

  if (issetPostGet('from')) {$from = getPostGetText('from');}
  else {$from = "RSS";}

  if ($PODCAST_MP3_STATS == "JA")
  {
    $ip = "no IP log";//$REMOTE_ADDR."|".gethostbyaddr($REMOTE_ADDR);
    LogFile::writeLog($file, $ip, $from);
  }

  $pfadTeile = explode("/",$file);
  $filename  = array_pop($pfadTeile);
  $dateinameTeile = explode(".",$filename);
  $endung = array_pop($dateinameTeile);

  // check if user is allowed to download the file
  if ( (isset($GLOBALS['RESTRICTED_ACCESS'])) && ($GLOBALS['RESTRICTED_ACCESS']=="YES") )
  {
    require_once("include/article.class.php");

    // get article that belongs to file
    $artikelID = article::getArticleIdByFilename($file);
    if ($artikelID)
    {
         $artikel = article::loadArticleFromFile("publicData/".$artikelID.".article");
  	     $fileaccess = $artikel->getRightsData('fileaccess');
  	     if ($fileaccess=="NOT_PUBLISHED") { print "SORRY. THIS FILE IS NOT PUBLISHED YET."; exit(); }
  	     elseif ($fileaccess=="RESTRICTED_ACCESS")
  	     {
  	       // include user defined function to test access rights
  	       if (!file_exists("podbloggerData/mod_include/security.inc.php")) { print "PROBLEM No.1 ON SECURITY CLEARANCE."; exit();  }
  	       include_once("podbloggerData/mod_include/security.inc.php");
  	       if (!function_exists("is_valid_access_article")) { print "PROBLEM No.2 ON SECURITY CLEARANCE."; exit(); }

  	       // check if user got is allowed to view item
  	       $article_access = is_valid_access_article($artikel->getID(),TRUE);

  	       if (!$article_access) { print "SORRY. YOU ARE NOT ALLOWED TO ACCESS THIS FILE."; exit(); }  // user is not allowed
  	       // otherwise the process can be continued
        }
    }
    else
    {
      print "ARTICLE TO THIS FILE CAN NOt BE FOUND"; exit();
    }
  }


  if (strtolower($endung) == "mp3") { header("Content-type: audio/mpeg"); }
  if ($size = filesize("publicData/".$filename)) { header("Content-Length: ".$size); }
  header("Content-Disposition: attachment; filename=".$filename);
  readfile($file);
  //header("Location: http://".HTTP_BASISADRESSE.$file);
  exit;
?>