<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #     
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # audioconverter.class.php                      #
  #################################################

// global variable
$singelton_ref_to_converter = NULL;

// needed files
require_once("include/ticketmanager.inc.php");

/**
* This Class is used to communicate with CGI Coverter-Webservice
*
*/
class audioconverter {

  /**
  * member variables
  * 
  *  var $service_httpaddr  = "";
  *  var $callback_httpaddr = "";
  *  var $connected		 = FALSE;
  *  var $debug			 = TRUE;
  */
  
  var $service_httpaddr  = "";
  var $callback_httpaddr = "";
  var $connected		 = FALSE;
  var $debug			 = TRUE;

  // Constructor

/**
* Name: audioconverter($httpaddr, $callbackaddr)
* 
* Constructur
* Enter the http-address of Service an the callback adress
*/
  
  function audioconverter($httpaddr, $callbackaddr)
  {
    // singleton check
    if ($GLOBALS['singelton_ref_to_converter'] != NULL) return $singelton_ref_to_converter;
    $GLOBALS['singelton_ref_to_converter'] = $this;

    //check if userdefinded debugmode is set
    if ( (isset($GLOBALS['debug'])) && ($GLOBALS['debug']) ) {$this->debug=TRUE;}

    $this->service_httpaddr  = $httpaddr;
    $this->callback_httpaddr = $callbackaddr;

    // connecttivity check
    if ($this->pingService()) $this->connected=TRUE;
  }


  // PUBLIC-Methods
/**
* Name: requestAudioConvertion($audiofile, $convertorder, $articleid, $id3title="", $id3artist="", $id3album="")
*
* This function handles the convertion of an audiofile with the
* cgi converter file
*  
*/

  function requestAudioConvertion($audiofile, $convertorder, $articleid, $id3title="", $id3artist="", $id3album="")
  {
    if ($this->connected)
    {
      // check if audiofilename for fobidden character
      if (!(strpos($audiofile,"|")===FALSE))
      {
        if ($this->debug) print "\nPROBLEM:::CONVERTER-CLASS::requestAudioConvertion: Audiofilename contains the '|'-character (not allowed): $audiofile \n";
        return 0;
      }

      // check if audiofile exists
      if (!file_exists($audiofile))
      {
        if ($this->debug) print "\nPROBLEM:::CONVERTER-CLASS::requestAudioConvertion: Audiofile does not exists: $audiofile \n";
        return 0;
      }

      // parsing the convertorder
      $convertorder = trim($convertorder);

      // get targetformat
      $parts = explode("/",$convertorder);
      $targetformat = strtoupper($parts[0]);

      // maybe get more parameter
      $targetquality  = "";
      $targetbitrate  = "";
      if (isset($parts[1]))
      {
        $parts = explode("=",$parts[1]);
        $targetquality  = strtoupper($parts[0]);
        if (isset($parts[1])) $targetbitrate  = strtoupper($parts[1]);
      }

      $filesize		= filesize($audiofile);
      $sourceformat	= strtoupper(array_pop(explode(".",$audiofile)));
      $targetformat = strtoupper($targetformat);

      // Be sure that no string contais the '|'-character and then urlencode
      $sourceformat	= str_replace ( "|", "/", $sourceformat );
      $targetformat	= str_replace ( "|", "/", $targetformat );
      $articleid	= str_replace ( "|", "/", $articleid );
      $id3title		= str_replace ( "|", "/", $id3title );
      $id3artist	= str_replace ( "|", "/", $id3artist );
      $id3album		= str_replace ( "|", "/", $id3album );

      $org_articleid  = str_replace ( "\n", "", $articleid );

      $sourceformat	= urlencode(str_replace ( "\n", "", $sourceformat ));
      $targetformat	= urlencode(str_replace ( "\n", "", $targetformat ));
      $id3title		= urlencode(str_replace ( "\n", "", $id3title ));
      $id3artist	= urlencode(str_replace ( "\n", "", $id3artist ));
      $id3album		= urlencode(str_replace ( "\n", "", $id3album ));

      $org_ticketid   = $org_articleid."000".(count(ticketmanager::getAllTicketsForArticle($org_articleid)));
      $articleid      = urlencode($org_articleid);
      $org_ticketcode = ticketmanager::createRandomTicketCode();
      $ticketcode     = urlencode($org_ticketcode);
      $callback		  = urlencode($this->callback_httpaddr);

      // Building requestURL
      $requestURL = $this->service_httpaddr."?action=requestconvert&articleid=$articleid&ticketcode=$ticketcode&sourceformat=$sourceformat&targetformat=$targetformat&targetbitrate=$targetbitrate&filesize=$filesize&callback=$callback&targettitle=$id3title&artist=$id3artist&album=$id3album";
      if ($this->debug) print "DEBUG:::CONVERTER-CLASS::requestAudioConvertion: THE REQUESTURL: $requestURL \n";

      // Requestticket on Webservice
      if ($fp = fopen($requestURL ,"r"))
      {
        $answere = fread($fp,1024);
        if ($this->debug) print "DEBUG:::CONVERTER-CLASS::requestAudioConvertion: ANSWERE: $answere \n";
        fclose($fp);
        // Write Ticket to file
        if ($answere[0]=='0')
        {
          $ticketdata = $sourceformat.">>>".$convertorder;
          ticketmanager::writeTicketDataToFile("CONVERT",$org_ticketid,$org_ticketcode,$org_articleid,$ticketdata);
          if ($this->debug) print "\nDEBUG:::CONVERTER-CLASS::requestAudioConvertion: Wrote Tiket\n";
        }
      }
      else
      {
        if ($this->debug) print "\nPROBLEM:::CONVERTER-CLASS::requestAudioConvertion: Cannt connect to: $this->service_httpaddr\n";
        return 0;
      }
    }
    else
    {
      if ($this->debug) print "\nPROBLEM:::CONVERTER-CLASS::requestAudioConvertion: Cannt connect to: $this->service_httpaddr\n";
      return 0;
    }
  }

/**
* Name:downloadConvertedAudio($filename, $ticketid, $targetformat)
*
* reloads the converted file from a convert.cgi script
* if the script is not avalible the function returns FALSE
* 
*/
  function downloadConvertedAudio($filename, $ticketid, $targetformat)
  {    
    // request the file
    $bytecounter = 0;
    if ($this->connected)
    {
      if ($wp = fopen($this->service_httpaddr."?action=getconvertedfile&articleid=$ticketid&targetformat=$targetformat","r"))
      {
        if ($fp = fopen($filename,"w"))
        {
          while (!feof($wp))
          {
            $data = fread($wp,10240);
            fwrite($fp,$data);
            $bytecounter += strlen($data);
          }
          fclose($fp);
          fclose($wp);
          // if the file size is smaller than 500 bytes, we declar that there was an error
          if ($bytecounter<500) {$this->writeErrorLog("Not file at converter available: ".$this->service_httpaddr."?action=getconvertedfile&articleid=$ticketid&targetformat=$targetformat"); unlink($filename); return FALSE;}
          else 				   { return TRUE;}
        }
        fclose($wp);
        return FALSE;
      }
      else
      {
        $this->writeErrorLog("Error on download: ".$this->service_httpaddr."?action=getconvertedfile&articleid=$ticketid&targetformat=$targetformat");
      }
    }
    else
    {
      $this->writeErrorLog("No connection.");
    }
    return FALSE;
  }

  
  	// PRIVATE-Methods
/**
* Name:pingService()
* 
* pings the cgi converter service
* FALSE if not avalible
* TRUE in case of succsess
*/
  function pingService()
  {
    $pingUrl = $this->service_httpaddr."?action=ping";
    if ($this->debug)print "\nDEBUG:::CONVERTER-CLASS::pingService: PINGURL: $pingUrl \n";
    if ($fp=@fopen($pingUrl,"r"))
    {
      fclose($fp);
      return TRUE;
    }
    return FALSE;
  }


  	// STATIC-Methods
/**
* Name: writeErrorLog($text)
*
* Writes a error log file 
* "podbloggerData/audioconverter.log"
*/
  function writeErrorLog($text)
  {
    if ($fp = fopen("podbloggerData/audioconverter.log","w"))
    {
      fwrite($fp,date("d.m.Y-H:i:s")."/".$text."/n");
      fclose($fp);
    }
  }
  

/**
* Name:  parseConvertOrder($ordercode)
*
* parses odercodes like "WAV>>>OGG/HIGH=128" to a array 
* with the single Datafields
*/
  function parseConvertOrder($ordercode)
  {
    $backinfo = array();
    $backinfo['sourceFormat']  = FALSE;
    $backinfo['targetFormat']  = FALSE;   
    $backinfo['targetQuality'] = "NORM"; 
    $backinfo['targetBitrate'] = FALSE;
    
    $parts1 = explode(">>>",$ordercode,2);
    if (count($parts1)>1)
    {
      $backinfo['sourceFormat']  = strtoupper(trim($parts1[0]));
      $parts2 = explode("/",$parts1[1]);
      $backinfo['targetFormat']  = strtoupper(trim($parts2[0]));          
      if (count($parts2)>1)
      {
        $parts3=explode("=",$parts2[1]);
        $backinfo['targetQuality']   = strtoupper(trim($parts3[0]));          
        if (count($parts3)>1)
        {
          $backinfo['targetBitrate'] = strtoupper(trim($parts3[1]));           
        }
      } 
    }
    
    return $backinfo;            
  }
}

?>