<?

  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # audiomailimport.class.php                      #
  #################################################

  // The following Variables need to be integrated to podblogger-config
  $PHP_CALLBACKADDRESS			= "http://".HTTP_BASISADRESSE."convert.php";
  $PERLCONVERTER_ADDRESS		= $AUDIOCONVERT_ADDRESS;

  $CONFIG_AUDIOMAIL_EMAILHOST	= $MAILIMPORT_POP;
  $CONFIG_AUDIOMAIL_EMAILUSER	= $MAILIMPORT_NAME;
  $CONFIG_AUDIOMAIL_EMAILPASS 	= $MAILIMPORT_PASS;

  require_once("include/audiomailimport.class.php");
  require_once("include/audioconverter.class.php");
  require_once("include/article.class.php");

  /**
  * Name: writeLog($text)
  *
  * writes a logfile to
  * "podbloggerData/audiomailimport.php.log"
  */
  function writeLog($text)
  {
    if ($fp = fopen("podbloggerData/audiomailimport.php.log","a"))
    {
      fwrite($fp,$text."\n");
      fclose($fp);
    }
  }

  /**
  * Name: checkAndImportNewAudioMail($checkintervall_duration_in_minutes=0)
  *
  * this function checks new audio files in the global mail box adress
  * sends e-mail to the admin
  * sends converting tickets if file need a conversion
  * gives a notification in the admin section
  *
  * returns the number of downloads or an error string
  */
  function checkAndImportNewAudioMail($checkintervall_duration_in_minutes=0)
  {

      $audios = audiomailimport::getAudioMails($GLOBALS['CONFIG_AUDIOMAIL_EMAILHOST'], $GLOBALS['CONFIG_AUDIOMAIL_EMAILUSER'], $GLOBALS['CONFIG_AUDIOMAIL_EMAILPASS'],"uploadData/");

      if (!is_Array($audios))
      {
        // return the error string
        return $audios;
      }
      else
      {
      
      foreach ($audios as $audio)
      {
        // EMAIL Benachrichtigung an ADMIN, wenn das ganze z.B, von index.php ausgefhrt wird

        $newarticle = new article(article::createUniqueID());
        $newarticle->setUnixTime(time());
        $newarticle->setTitle(get_lang('mailimport_title'));
        $newarticle->setFile($audio);
        $newarticle->setCategory($GLOBALS['PODCAST_CATEGORY'][0]);
        $newarticle->setAuthorComment("<br><font color='blue'>".get_lang('mailimport_description')."</font>");
        $newarticle->save("uploadData");

        // $CONVERT_TARGETFORMATS is define in the podbloggerData/manSettings.txt
        $filename = $audio; $artikelID = $newarticle->getID();
        if ((isset($GLOBALS['CONVERT_TARGETFORMATS'])) && ($GLOBALS['AUDIOCONVERT_SWITCH']=="AN"))
        {
          print "<!-- START Convertorder ->\n";
          // Uploadformat
          $uploadformat = strtoupper(getDateiEndung($filename));

          // calculate needed conversions
          $konvertFormats = Array();
          foreach (explode(";",$GLOBALS['CONVERT_TARGETFORMATS']) as $convertorder)
          {
            // calculate targetformat
            $parts = explode("/",$convertorder);
            $targetformat = strtoupper($parts[0]);
            // maybe parse other Parameter
            $targetquality  = "";
            if (isset($parts[1]))
            {
              $parts = explode("=",$parts[1]);
              $targetquality  = strtoupper($parts[0]);
            }
        // two cases for convertings
            // 1. the uploadformat differs from the targetformat
            if ($targetformat != $uploadformat)
            {
              array_push($konvertFormats, $convertorder);
            }
            // 2 format is right but quality musst be change
            elseif  ($targetquality!="")
            {
              array_push($konvertFormats, $convertorder);
            }
           print "<!-- END Convertorder  ->\n";
          }

          // maybe order convertings
          if (count($konvertFormats)>0)
          {
            // Init converter
            print "<!-- ";
            $converter = new audioconverter($GLOBALS['AUDIOCONVERT_ADDRESS'],"http://".HTTP_BASISADRESSE."convert.php");
            print " ->\n";
            foreach ($konvertFormats as $convertorder)
            {
              print "<!-- request Convert $convertorder ->\n";
              print "<!-- \n";
              $converter->requestAudioConvertion("uploadData/".$filename, $convertorder, $artikelID);
              print "->";
            }
          }
        }
        else
        {
          print "<!-- NO Convertorder ->\n";
        }
      }
      }
      
      return count($audios);
  }
?>