<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # audiomailimport.class.php                     #
  #################################################

// needed files
require_once("pop3.class.inc.php");
require_once("mime_email.class.php");

define("FILE_WITH_LASTCHECKTIME","podbloggerData/audiomaillastcheck.txt");

// static
class audiomailimport
{

  /**
  * Name: getAudioMails($pop3host, $user, $pass, $saveDir="")
  *
  * reads out a pop3-mailaccount
  * and is downloading WAV/MP3/OGG-Files to saveDir
  * bsp: saveDir="dir/"
  *
  * returns an "array of filenames" or an "errorstring"
  * so user got to check the return value carefully 
  *
  */

  function getAudioMails($pop3host, $user, $pass, $saveDir="")
  {
    $audiofilenames = Array();

    $debug = false;
    if (isset($_GET['debug']) ) $debug = TRUE;

    $mailarray = getDataMailsFromPop3($pop3host, $user, $pass);

    if (is_Array($mailarray))
    {
    foreach($mailarray as $mailraw)
    {
      $mimemail = new mime_email();
      $mimemail->set_emaildata($mailraw);
      $mimemail->go_decode();

      if ($debug) print "Absender:".$mimemail->from."\n";
      if ($debug) print "Betreff:".$mimemail->from."\n";
      if ($debug) print "Datum:".$mimemail->from."\n";

      if ($debug) print "RAW:\n";
      if ($debug) foreach ($mailraw as $line) {print $line;}
      if ($debug) print "+++++++  ENDE RAW\n";

      // search for auduiofiles
      for($i=0;$i<count($mimemail->mime_block);$i++)
      {

        $attachmentname = $mimemail->mime_block[$i]->getMimeContentDispositionName();
        if ( (isset($attachmentname)) && (!(strpos($attachmentname,".")===FALSE)) )
        {
          // findout file suffix
          $parts = explode(".",$attachmentname);
          $endung = strtolower(array_pop($parts));
          if (($endung=="mp3") || ($endung=="ogg") || ($endung=="wav"))
          {
            if ($debug) print "Audiodatei gefunden:".$attachmentname."\n";

            while (file_exists($saveDir.$attachmentname))
            {$attachmentname = "_".$attachmentname;}

            $encoding = strtolower(trim($mimemail->mime_block[$i]->getMimeTransferEncoding()));
            if ($debug) print "Encoding:".$encoding."\n";

            if (($encoding=="base64") && ($fp = fopen($saveDir.$attachmentname,"w")))
            {
              fwrite($fp,base64_decode($mimemail->mime_block[$i]->getMimeContent()));
              fclose($fp);
              array_push($audiofilenames,$attachmentname);
            }
          }
        }
      }
    }
    }
    else
    {
      // returns Error string
      return $mailarray;
    }

    return $audiofilenames;
  }

  /**
  * Name: isMailImportIntervall($intervallduration_in_minutes)
  *
  * this function calculate the time period for the e-mail account request
  * and return TRUE if duration is over or FALSE if not
  *
  */
  function isMailImportIntervall($intervallduration_in_minutes)
  {
    if (file_exists(FILE_WITH_LASTCHECKTIME))
    {
      if ($fp = fopen(FILE_WITH_LASTCHECKTIME,"r"))
      { $lastcheck=fread($fp,1024); fclose($fp); }
    }
    else
    { $lastcheck=0; }


    $intervallduration_in_seconds 	= $intervallduration_in_minutes * 60;
    $intervall_now_lastcheck 		= time()-$lastcheck;

    if ($intervall_now_lastcheck > $intervallduration_in_seconds)
    {
      if ($fp = fopen(FILE_WITH_LASTCHECKTIME,"w"))
      {
        fwrite($fp,time());
        fclose($fp);
      }
      return TRUE;
    }
    else
    {
      return FALSE;
    }
  }
}
?>