<?

  ## Bereitet die Klasse stringparser_bbcode.class.php fr podbloogger auf

  ## stringparser_bbcode.class.php ist GPL (siehe Datei fr mehr Informationen)
  ## von Christian Seiler 2004

  require_once 'include/stringparser_bbcode.class.php';

  // Es werden statische FUNKTIONEN in einer pseudo Klasse gekapselt, damit
  // man im PHP-Code besser erkennt woher die Funktion kommt.

  class bbcode_inc {

    // statische FUNKTIONEN fr den externen Gebrauch

    function renderBBCode($text)
    {
      $BBCodeParser = new StringParser_BBCode ();
      bbcode_inc::bulidBBCodeRulesOnParser($BBCodeParser);
      return $BBCodeParser->parse($text);
    }

    // Wenn Text HTML-Code enthlt, dann kein BB-Code nutzen
    function renderHTML_or_BBCode($text)
    {
       // Kein HTML in $text
       if (strlen($text) == strlen(striptags($text)))
       {
         return bbcode_inc::renderBBCode($text);
       }
       // Es ist HTML in $text
       else
       {
         return bbcode_inc::stripBBCode($text);
       }
    }

    // Entfernt BBCode aus $text
    function stripBBCode ($text) {
      return preg_replace ("/[^\n]/", '', $text);
    }

    // interne FUNKTIONEN (sollen von auen nicht gebraucht werden)

    function bulidBBCodeRulesOnParser (&$BBCodeParser)
    {
        $BBCodeParser->addFilter (STRINGPARSER_FILTER_PRE, 'convertlinebreaks');

        $BBCodeParser->addParser (array ('block', 'inline', 'link', 'listitem'), 'htmlspecialchars');
        $BBCodeParser->addParser (array ('block', 'inline', 'link', 'listitem'), 'nl2br');
        $BBCodeParser->addParser ('list', 'bbcode_stripcontents');

        $BBCodeParser->addCode ('b', 'simple_replace', null, array ('start_tag' => '<b>', 'end_tag' => '</b>'),
                          'inline', array ('listitem', 'block', 'inline', 'link'), array ());
        $BBCodeParser->addCode ('i', 'simple_replace', null, array ('start_tag' => '<i>', 'end_tag' => '</i>'),
                          'inline', array ('listitem', 'block', 'inline', 'link'), array ());
        $BBCodeParser->addCode ('url', 'usecontent?', 'do_bbcode_url', array ('usecontent_param' => 'default'),
                          'link', array ('listitem', 'block', 'inline'), array ('link'));
        $BBCodeParser->addCode ('link', 'callback_replace_single', 'bbcode_inc::do_bbcode_url', array (),
                          'link', array ('listitem', 'block', 'inline'), array ('link'));
        $BBCodeParser->addCode ('img', 'usecontent', 'do_bbcode_img', array (),
                          'image', array ('listitem', 'block', 'inline', 'link'), array ());
        $BBCodeParser->addCode ('bild', 'usecontent', 'do_bbcode_img', array (),
                          'image', array ('listitem', 'block', 'inline', 'link'), array ());
        $BBCodeParser->setOccurrenceType ('img', 'image');
        $BBCodeParser->setOccurrenceType ('bild', 'image');
        //$BBCodeParser->setMaxOccurrences ('image', 100);
        $BBCodeParser->addCode ('list', 'simple_replace', null, array ('start_tag' => '<ul>', 'end_tag' => '</ul>'),
                          'list', array ('block', 'listitem'), array ());
        $BBCodeParser->addCode ('*', 'simple_replace', null, array ('start_tag' => '<li>', 'end_tag' => '</li>'),
                          'listitem', array ('list'), array ());
        $BBCodeParser->setCodeFlag ('*', 'closetag', BBCODE_CLOSETAG_OPTIONAL);
        $BBCodeParser->setCodeFlag ('*', 'paragraphs', true);
        $BBCodeParser->setCodeFlag ('list', 'paragraph_type', BBCODE_PARAGRAPH_BLOCK_ELEMENT);
        $BBCodeParser->setCodeFlag ('list', 'opentag.before.newline', BBCODE_NEWLINE_DROP);
        $BBCodeParser->setCodeFlag ('list', 'closetag.before.newline', BBCODE_NEWLINE_DROP);
        $BBCodeParser->setRootParagraphHandling (true);
    }

  }

  // FUNKTIONEN, DIE BBCODE-TAGS VERARBEITEN MSSEN auerhalb DER KLASSE STEHEN

  // Unify line breaks of different operating systems
  function convertlinebreaks ($text) {
    return preg_replace ("/\015\012|\015|\012/", "\n", $text);
  }

  /// Function to include URLS
  function do_bbcode_url ($action, $attributes, $content, $params, $node_object) {
    if ($action == 'validate') {
        return true;
    }
    if (!isset ($attributes['default'])) {
        return '<a href="'.htmlspecialchars ($content).'" target="_blank">'.htmlspecialchars ($content).'</a>';
    }
    return '<a href="'.htmlspecialchars ($attributes['default']).'" target="_blank">'.$content.'</a>';
  }

  // Function to include images
  function do_bbcode_img ($action, $attributes, $content, $params, $node_object) {
    if ($action == 'validate') {
     return true;
    }
    return '<img src="'.htmlspecialchars($content).'" alt="">';
  }

?>