<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #     
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # comment.class.php                             #
  #################################################

  ##############################################################################
  # this file contains all commet-objects handled by the podblogger system
  # textcomment, trackback

/**
* Name CLASS :: comment
* 
* this class is a abstract class of a comment in the podblogger system
*/
  

 
class comment {

/** 
* member variables
*  
* var $type 		= "abstract";
* var $authordata	= array();
* var $unixtime      	= 0;
* var $quickdeletecode  = "";
*
*/
 
var $type 				= "abstract";
 var $authordata		= array();
 var $unixtime      	= 0;
 var $quickdeletecode   = "";


 	// GETTER-METHODS

/**
* Name: getType()
*
* return $this->type;
*/
 function getType()
 {
   return $this->type;
 }
/**
* Name: getPublishedUnixtime()
*
* return $this->unixtime;
*/
 function getPublishedUnixtime()
 {
   return $this->unixtime;
 }
/**
* Name:  getAuthorName()
*
* return $this->getAuthorData("NAME");
*/
 function getAuthorName()
 {
   return $this->getAuthorData("NAME");
 }
/**
* Name:  getAuthorMail()
*
* return $this->getAuthorData("MAIL");
*/
 function getAuthorMail()
 {
   return $this->getAuthorData("MAIL");
 }
/**
* Name: getAuthorIP()
*
* return $this->getAuthorData("IP");
*/
 function getAuthorIP()
 {
   return $this->getAuthorData("IP");
 } 
/**
* Name: getAuthorHOST()
*
* return $this->getAuthorData("HOST");
*/ 
 function getAuthorHOST()
 {
   return $this->getAuthorData("HOST");
 } 
/**
* Name: getAuthorData($id)
*
* return $this->authordata[$id]; or FALSE
*/ 
 function getAuthorData($id)
 {
   if (isset($this->authordata[$id])) 	{return $this->authordata[$id];}
   else 								{return FALSE;}
 }
/**
* Name: getQuickdeleteCode()
*
* return md5($this->quickdeletecode.$GLOBALS["ADMIN_PASSWORD"]);
*/
 function getQuickdeleteCode()
 {
   return md5($this->quickdeletecode.$GLOBALS["ADMIN_PASSWORD"]);
 }
/**
* Name: getInsideQuickdeleteCode()
*
* return $this->quickdeletecode;
*/
 function getInsideQuickdeleteCode()
 {
   return $this->quickdeletecode;
 }

 
 	// SETTER-METHODS
 /**
 * Name: setType($typeSTR)
 *
 * sets the type of comment, need for differ between comments
 * should only be used by subclass
 */
 function setType($typeSTR)
 {
   $this->type=$typeSTR;
 }
/**
* Name:setPublishedUnixtime($utime)
*
* set the unixtime when comment was created
*/
function setPublishedUnixtime($utime)
 {
   $this->unixtime = $utime;
 }
/**
* Name:setAuthorData($id, $data)
*
* set the AuthorData
*/
 function setAuthorData($id, $data)
 {
   $this->authordata[$id] = substr($data,0,200);
 }
/**
* Name:setAuthorName($data)
*
* set the AuthorName
*/
 function setAuthorName($data)
 {
   $this->setAuthorData("NAME", $data);
 }
/**
* Name:setAuthorMail($data)
*
* set the Author mail adress
*/
 function setAuthorMail($data)
 {
   $this->setAuthorData("MAIL",$data);
 }
/**
* Name:setAuthorIP($data)
*
* set the Author IP adress
*/
 function setAuthorIP($data)
 {
   $this->setAuthorData("IP",$data);
 }
/**
* Name:setAuthorHOST($data)
*
* set the Author HOST adress
*/ 
 function setAuthorHOST($data)
 {
   $this->setAuthorData("HOST",$data);
 }  

}

/**
* CLASS :: textcomment extends comment
*
*/
class textcomment extends comment {

/**
* member variable 
*
* var $commenttext = "";
*/

 var $commenttext = "";

/**
* Name: textcomment($authorname, $commenttext, $authormail="")
*
* Constructs the Object
* generats the QuickdeleteCode
* set comment data
*/

 function textcomment($authorname, $commenttext, $authormail="")
 {
   $this->setType("TEXTCOMMENT");
   $this->setPublishedUnixtime(time());
   $this->setAuthorName($authorname);
   $this->setAuthorMail($authormail);
   $this->setAuthorIP(getenv('REMOTE_ADDR'));
   $this->setAuthorHOST(gethostbyaddr(getenv('REMOTE_ADDR')));
   
   // generats the QuickdeleteCode 
   // for the possibility for a direct delete hyperlink
   $this->quickdeletecode = md5(time()-rand(1000,99999));
   
   //set comment data 
   $this->commenttext = substr($commenttext,0,5000);

 }

 
 	// GETTER-METHODS

 /**
 * Name: getCommenttext()
 * 
 * return $this->commenttext;
 */

 function getCommenttext()
 {
   return $this->commenttext;
 }

}

/**
*CLASS :: trackback extends comment
*
*/
class trackback extends comment {

/**
* member variable 
*
* var $title       	= "";
* var $blogname    	= "";
* var $excerpt 		= "";
* var $url		= ""; 
*
*/

 var $title       	= "";
 var $blogname    	= "";
 var $excerpt 		= "";
 var $url			= "";

/**
* Name: CONSTRUCTOR function
*
* generats the QuickdeleteCode
* set the trackbackdata
*/
 function trackback($title, $blogname, $excerpt, $url)
 {
   $this->setType("TRACKBACK");
   $this->setPublishedUnixtime(time());
   $this->setAuthorName("");
   $this->setAuthorMail("");   
   $this->setAuthorIP(getenv('REMOTE_ADDR'));
   $this->setAuthorHOST(gethostbyaddr(getenv('REMOTE_ADDR')));
   
   // generats the QuickdeleteCode 
   // for the possibility for a direct delete hyperlink
   $this->quickdeletecode = md5(time()-rand(1000,99999));
   
   // set the trackbackdata 
   $this->title 	= substr($title,0,300);
   $this->blogname 	= substr($blogname,0,300);
   $this->excerpt 	= substr($excerpt,0,2000);
   $this->url		= substr($url,0,400);
 }
 
 	//GETTER-METHODS
/**
* Name: getTitle()
*
* return $this->title;
*/
function getTitle()
 {
   return $this->title;
 } 
/**
* Name: getBlogname()
*
* return $this->blogname;
*/ 
 function getBlogname()
 {
   return $this->blogname;
 }  
/**
* Name: getExcerpt()
*
* return $this->blogname;
*/ 
 function getExcerpt()
 {
   return $this->excerpt;
 } 
/**
* Name: getURL()
*
* return $this->url;
*/ 
 function getURL()
 {
   return $this->url;
 }
}
?>