<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #################################################
  # funktions_sammlung.inc.php                         #
  #################################################

  #############################################################
  # function summary and process initialisation
  # important for nearly every podblogger 0.5 sourcecodefile


 // ------------------------------------------------------------
 // declare constant variables
 // ------------------------------------------------------------

 // HTTP_BASISADRESSE = scripts latest adress
 if (isset($_SERVER['REQUEST_URI']))
 {
   $teile = explode("/",$_SERVER['REQUEST_URI']);
   array_pop($teile);
   define("HTTP_BASISADRESSE",$_SERVER['HTTP_HOST'] . implode("/",$teile)."/");
 }
 else if (isset($_SERVER['SCRIPT_NAME']))
 {
   $teile = explode("/",$_SERVER['SCRIPT_NAME']);
   array_pop($teile);
   define("HTTP_BASISADRESSE",$_SERVER['HTTP_HOST'] . implode("/",$teile)."/");
 }

 // SMARTY const
 define('SMARTYPATH_COMPILE','podbloggerData/smarty_compile/');
 define('SMARTYPATH_CONFIG'	,'podbloggerData/smarty_config/');
 define('SMARTYPATH_CACHE'	,'podbloggerData/smarty_cache/');

 // ------------------------------------------------------------
 // LOAD and INIT the Configfile
 // ------------------------------------------------------------

    require("include/loadConfig.inc.php");


 // ------------------------------------------------------------
 // LOAD and INIT the languageresourcees for output
 // ------------------------------------------------------------

    require("include/language.inc.php");

 // ------------------------------------------------------------
 // get some values from the configfile.
 // ------------------------------------------------------------

 // http-adress from php uploadscript dieses UPLOAD-Scriptes
  $PHP_CALLBACK_SCRIPT 	 = "http://" .HTTP_BASISADRESSE. "upload.php";

  // MB -> Byte
  $WEBSPACE_LIMIT = $WEBSPACE_LIMIT * (1024*1024);

 // ------------------------------------------------------------
 // swoaped functions
 // ------------------------------------------------------------

 /**
 * Name: issetPostGet($varname)
 *
 * check if 'varname' comes with POST or with GET http method
 * returns TRUE or FALSE
 */
 function issetPostGet($varname)
 {
   if ( isset($_POST[$varname]) )
   {
     return TRUE;
   }
   else if ( isset($_GET[$varname]) )
   {
     return TRUE;
   }
   return FALSE;
 }
 /**
 * Name:getPostGetText($varname)
 *
 * returns the given String from the POST or GET method
 */
 function getPostGetText($varname)
 {
   if ( isset($_POST[$varname]) )
   {
     return stripslashes($_POST[$varname]);
   }
   else if ( isset($_GET[$varname]) )
   {
     return stripslashes($_GET[$varname]);
   }
   return "";
 }
 /**
 * Name:getPostGetInt($varname)
 *
 * returns the given Integer from the POST or GET method
 */
 function getPostGetInt($varname)
 {
   if ( isset($_POST[$varname]) )
   {
     return intval($_POST[$varname]);
   }
   else if ( isset($_GET[$varname]) )
   {
     return intval($_GET[$varname]);
   }
   return 0;
 }

  /**
 * Name:my_search_stringArray($searchValue, $array)
 *
 * searches array for a given value
 */
  function my_search_stringArray($searchValue, $array)
  {
    if (is_Array($array))
    {
      if (count($array) > 0)
      {
        for ($i=0;$i<count($array);$i++)
        {
          $array_value = $array[$i];
          if (is_String($array_value))
          {
            if ($array_value == $searchValue)
            {
              return TRUE;
            }
          }
        }
        return FALSE;
      }
      else
      {
        return FALSE;
      }
    }
    else
    {
      return FALSE;
    }
  }
 /**
 * Name:getFilesFromDirWithEnding($dir,$ending)
 *
 * returns a array wich holds all filesnames that matches the given
 * ending in the given directory
 */
 function getFilesFromDirWithEnding($dir,$ending)
  {
    $infDateien = array();
    if (is_string($dir))
    {
      if ($verzeichnis = opendir($dir))
      {
        while ($datei = readdir($verzeichnis))
        {
         $datNameTeile = explode(".",$datei);
         if (array_pop($datNameTeile) == $ending)
         { array_push($infDateien,$datei); }
        }
        closedir($verzeichnis);
      }
      else
      {
        //  die("Das Verzeichnis $dir kann nicht geffnet werden. Ggf. existiert es nicht.");
      }
    }
    return $infDateien;
  }
 /**
 * Name:getHtmlDats($dir)
 *
 * returns a array wich holds all filesnames that matches the ending
 * .htm or .html in the given directory
 */
 function getHtmlDats($dir)
  {
    $infDateien = array();
    $verzeichnis = opendir($dir);
    while ($datei = readdir($verzeichnis))
    {
     $datNameTeile = explode(".",$datei);
     $endung = array_pop($datNameTeile);
     if (($endung == "htm") || ($endung == "html"))
     { array_push($infDateien,$datei); }
    }
    closedir($verzeichnis);
    return $infDateien;
  }
 /**
 * Name:getDateiEndung ($datei)
 *
 * returns a file suffix e.g. (.txt|.mp3|.bmp)
 */
 function getDateiEndung ($datei)
  {
     $datNameTeile = explode(".",$datei);
     return array_pop($datNameTeile);
  }
 /**
 * Name:movefile($org,$target)
 *
 * moves a file from $original place,to $target place
 */
  function movefile($org,$target)
  {
    $forg = fopen($org,"rb");
    if ($ftar = fopen($target,"wb"))
    {
      while (!feof($forg))
      {
        fwrite($ftar,fread($forg,2048));
      }
      fclose($forg);
      fclose($ftar);
      @unlink($org);
    }
    else {die("FEHLER: Keine Schreibrechte oder kein Platz fr'".$target."'");}
  }
/**
 * Name:charfilter($data)
 *
 * filters given Data beetween ASCII code number 32 and 122
 */
  function charfilter($data)
  {
    $ergebnis = "";
    $data = trim($data);
    for ($i=0; $i < strlen($data); $i++)
    {
      if (ord($data[$i]) >= 32 AND ord($data[$i]) <= 122)
      { $ergebnis = $ergebnis.$data[$i];}
    }
    return $ergebnis;
  }
/**
 * Name:sonderzeichenWandeln($str)
 *
 * recodes the german spezial character
 * e.g.[$str = str_replace("","ae",$str);]
 */
 function sonderzeichenWandeln($str)
  {
    $str = str_replace("","ae",$str);
    $str = str_replace("","ue",$str);
    $str = str_replace("","oe",$str);
    $str = str_replace("","ss",$str);
    $str = str_replace("&",get_lang('and'),$str);

    $str = str_replace('"',"-",$str);
    $str = str_replace("'","",$str);
    $str = str_replace("<br>"," ",$str);
    $str = str_replace("("," ",$str);
    $str = str_replace(")"," ",$str);


    return htmlspecialchars($str);
  }

  /**
   * This function recodes the german special characters
   *
   */
  function sonderzeichenRueckkodierung($str)
  {
    # ä =  # ö =  # ü = 
    $str = str_replace("ä","",$str);
    $str = str_replace("ö","",$str);
    $str = str_replace("ü","",$str);
    return $str;
  }

/**
 * Name:array2string ($arraydata)
 *
 * this funktions build a String out of the given array
 */
  function array2string ($arraydata)
  {
    $outStr = "";
    if (is_array($arraydata))
    {
      $outStr = $outStr."(";
      foreach ($arraydata as $data)
      {
        $outStr = "/".$outStr.array2string($data);
      }
      $outStr = $outStr.")";
    }
    else
    {
      $outStr = $outStr.$arraydata;
    }
    return $outStr;
  }
/**
 * Name:getUsedWebspace()
 *
 * adds the filessize of all avalible Audiofiles
 * and returns the value
 */
function getUsedWebspace()
  {
    $verbrauch = 0;
    $verzeichnis = opendir("uploadData");
    while ($datei = readdir($verzeichnis))
    {
      if (strtolower(getDateiEndung($datei)) == "mp3")
      {$verbrauch += filesize("uploadData/".$datei);}
    }
    closedir($verzeichnis);
    $verzeichnis = opendir("publicData");
    while ($datei = readdir($verzeichnis))
    {
      if (strtolower(getDateiEndung($datei)) == "mp3")
      {$verbrauch += filesize("publicData/".$datei);}
    }
    closedir($verzeichnis);
    return $verbrauch;
  }
/**
 * Name:getHtmlPart($datei,$name)
 *
 * returns a given String(name) as html comment out of the given file (datei)
 */
function getHtmlPart($datei,$name)
  {
    if ($lineArray = @file($datei))
    {
      $HTMLString = implode("",$lineArray);
      $partArray  = explode("<!-- HTMLPART:",$HTMLString);
      $str="";
      foreach ($partArray as $part)
      {
        if (strpos(strtolower($part),strtolower($name)) == 1) // if pattern matches $name
        { return "<!-- HTMLPART: ".$part."<!-- ENDE HTMLPART $name -->"; }
      }
      return "<!-- PART $name IN $datei NOT FOUND -->";
    }
    else return "<!-- $datei NOT FOUND -->";
  }
/**
* Name:printProblembeschreibung ($name)
*
* print an error massage from "include/errors.htm" file
*/
function printProblembeschreibung ($name)
  {
    print getHtmlPart("htmlContent/probleme.htm",$name);
  }
/**
* Name:write_htaccess($verzeichnis)
*
* write a htaccess-file in the given directory
*/
function write_htaccess($verzeichnis)
  {
    if ($fp = @fopen($verzeichnis.".htaccess","w"))
    {
      fwrite($fp,"Order deny,allow\n\rDeny from all\n\r");
      fclose($fp);
    }
  }
/**
* Name:write_weiterleitung($ziel)
*
* write a html-file with a redirection to the given target ($ziel)
*/
  function write_weiterleitung($ziel)
  {
  ?>
    <html>
    <head>
    <? print '<meta http-equiv="refresh" content="0; URL='.$ziel.'">'; ?>
    <title>...</title>
    </head>
    <body><br>
    <center>
    <? print '<a href="'.$ziel.'">'; ?>
    click ...</a></center>
    </body>
    </html>
  <?
  exit();
  }
/**
* Name:loadPostGetString($name)
*
* loads the POST or GET String stores it that way
* $GLOBALS[$name]=getPostGetText($name)
*/
  function loadPostGetString($name)
  {
    if (issetPostGet($name)) {$GLOBALS[$name]=getPostGetText($name);}
    else {die("FEHLER: Parameter '$name' fehlt.");}
  }
/**
* Name:menuButtonStr($text, $link)
*
* defines the look for the MENU Buttons and build a new one
* with the given $text and $link
*/
  function menuButtonStr($text, $link)
  {
    return '<strong>[</strong>&nbsp;<a href="'.$link.'">'.$text.'</a>&nbsp;<strong>]</strong>';
  }
/**
* Name:getUnixTimeFromStr($date)
*
* converts a String as Unixtime e.g
* dd.mm.yyy;hh:mm
*/
function getUnixTimeFromStr($date)
  {
    $parts = explode(";",$date,2);
    if (count($parts)==2)
    {
      $dateStr 	= $parts[0];
      $timeStr 	= $parts[1];
      $dateParts = explode(".",$dateStr,3);
      $timeParts = explode(":",$timeStr,2);

      // check if all data are numeric data
      if (!is_numeric($timeParts[0])) {return FALSE;}
      if (!is_numeric($timeParts[1])) {return FALSE;}
      if (!is_numeric($dateParts[0])) {return FALSE;}
      if (!is_numeric($dateParts[1])) {return FALSE;}
      if (!is_numeric($dateParts[2])) {return FALSE;}

      if ( (count($dateParts)==3) && (count($timeParts)==2) )
      {
        $unixTime = mktime($timeParts[0], $timeParts[1], 0, $dateParts[1], $dateParts[0], $dateParts[2]);
        if ((isset($unixTime)) && ($unixTime > 0))
        {
          return $unixTime;
        }
        else return FALSE;
      }
      else return FALSE;
    }
    else return FALSE;
  }
/**
* Name:getPhpUploadLimit($format="STRING")
*
* checkout how php is configured for uploading data
* and return that value
*/
  function getPhpUploadLimit($format="STRING")
  {
    $max_upload   = get_cfg_var('upload_max_filesize');
    $max_postsize = get_cfg_var('post_max_size');

    $fak_upload   = 1000; if (stristr($max_upload,"M"))   $fak_upload   = 1000000;
    $fak_postsize = 1000; if (stristr($max_postsize,"M")) $fak_postsize = 1000000;

    $int_upload   = intval($max_upload);
    $int_postsize = intval($max_postsize);

    if (($int_postsize * $fak_postsize) > ($int_upload * $fak_upload ))
    {
      $limit = $int_upload;

      if ($format=="BYTE") {return ($limit*$fak_upload);}

      if ($fak_upload==1000)    {$limit = $limit." KB";}
      if ($fak_upload==1000000) {$limit = $limit." MB";}
    }
    else
    {
      $limit = $int_postsize;

      if ($format=="BYTE") {return ($limit*$fak_postsize);}

      if ($fak_postsize==1000)    {$limit = $limit." KB";}
      if ($fak_postsize==1000000) {$limit = $limit." MB";}
    }

    return $limit;
  }
/**
* Name:cmp ($a, $b)
*
* compares two skalar values e.g
* $a == $b
*/
  // Vergleichsfunktion
  function cmp ($a, $b)
  {
   if ($a == $b) return 0;
   return ($a > $b) ? -1 : 1;
  }

?>