<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # layout.class.php                              #
  #################################################

  ##############################################################################
  # this object holds all important data for a plugin Template layout

/**
* Define global variables
*
* define("LAYOUTDIR","layoutPlugins");
* define("LAYOUTCONFIGDIR","podbloggerData/layoutConfigs");
*/
define("LAYOUTDIR","layoutPlugins");
define("LAYOUTCONFIGDIR","podbloggerData/layoutConfigs");

class layout {

 /**
 * Member variables
 *
 * var $layoutID	= "";	// folder for the design templats
 * var $name 		= "";
 * var $author 		= "";
 * var $hoemepage 	= "";
 * var $defArray 	= array();
 * var $objectState 	  	= "INIT"; // True or FALSE for valid state or not
 *
 */

  var $layoutID		= "";	// ist der Verzeichnisname des Layouts
  var $name 		= "";
  var $author 		= "";
  var $hoemepage 	= "";

  var $defArray 	= array();
  
  // True or FALSE for valid state or not
  var $objectState 	  	= "INIT";

  /**
  * Name: layout($id)
  *
  * constructor loads layouts
  */
  function layout($id)
  {
    $this->layoutID = $id;
  }


  // Setter-Funktionen
/**
* Name:setName($data)
*
* $this->name = $data;
*/
  function setName($data)
  {
    if ($data == "VOID") {$data = "";}
    $this->name = $data;
  }
/**
* Name:setAuthor($data)
*
* $this->author = $data;
*/
  function setAuthor($data)
  {
    if ($data == "VOID") {$data = "";}
    $this->author = $data;
  }
/**
* Name:setHomepage($data)
*
* $this->homepage = $data;
*/
  function setHomepage($data)
  {
    if ($data == "VOID") {$data = "";}
    $this->homepage = $data;
  }
/**
* Name: addDefinition($data)
*
* $this->defArray,$data
*/
  function addDefinition($data)
  {
    if (count($data) >=2 )
    array_push($this->defArray,$data);
  }
/**
* Name: setDefinitionValue($defName, $defValue)
*
* $this->defArray[$i]['value']=$defValue;
* return TRUE or FALSE
*/
  function setDefinitionValue($defName, $defValue)
  {
    $i = 0;
    while (isset($this->defArray[$i]))
    {
      if ($this->defArray[$i]['smartyname'] == $defName) {$this->defArray[$i]['value']=$defValue; return TRUE;}
      $i++;
    }
    return FALSE;
  }

  // Getter-Funktionen

/**
* Name: getName()
*
* return $this->name;
*/
  function getName()
  {
    return $this->name;
  }
/**
* Name:  getAuthor()
*
* return $this->author;
*/
  function getAuthor()
  {
    return $this->author;
  }
/**
* Name:  getHomepage()
*
* return $this->homepage;
*/
  function getHomepage()
  {
    return $this->homepage;
  }
/**
* Name:  getID()
*
* return $this->layoutID;
*/
  function getID()
  {
    return $this->layoutID;
  }
/**
* Name:  getDefinitionArray()
*
* return $this->defArray;
*/
  function getDefinitionArray()
  {
    return $this->defArray;
  }
/**
* Name:  getDefinitionValue($defName)
*
* return $def['value'];
*/
  function getDefinitionValue($defName)
  {
    foreach ($this->defArray as $def)
    {
      if ($def['smartyname'] == $defName)
      {
        if (isset($def['value']))
        {return $def['value'];}
      }
    }
    return "";
  }

/**
* Name: checkValid()
*
* a template is valid if the name and the ID were set
* and the following files were found
*  - index.tpl
*  - upload_1.tpl
*  - upload_2.tpl
*  - upload_3.tpl
*  - upload_error.tpl
*/
  function checkValid()
  {
    if ($this->objectState == "VALID") {return TRUE;}

    if ($this->layoutID == "") 	  {return FALSE;}
    if ($this->name     == "")    {return FALSE;}

    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/index.tpl")) 			{return FALSE;}
    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/upload_1.tpl")) 		{return FALSE;}
    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/upload_1.tpl")) 		{return FALSE;}
    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/upload_1.tpl"))		{return FALSE;}
    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/upload_error.tpl"))	{return FALSE;}

    $this->objectState = "VALID";
    return TRUE;
  }

  function loadDefinitionValues()
  {
     $file = LAYOUTCONFIGDIR."/layout_".$this->layoutID.".conf";
     if (file_exists($file))
     {
       if ($fp = fopen($file,"r"))
       {
         $object_str = implode("",file($file));
         $valueArray = unserialize($object_str);

         //rewrite the saved definitionsvalues in the actuell definition array
         $i = 0;
         while (isset($this->defArray[$i]))
         {
           if (isset($valueArray[$this->defArray[$i]['smartyname']]))
           {
             $this->defArray[$i]['value'] = $valueArray[$this->defArray[$i]['smartyname']];
           }
           $i++;
         }

       }
     }
     else return FALSE;
  }
/**
* Name: saveDefinitionValues()
*
* build the array with the definition values and
* writes the definition file.
* return TRUE or FALSE
*/
  function saveDefinitionValues()
  {
    $file = LAYOUTCONFIGDIR."/layout_".$this->layoutID.".conf";

    $saveArray = array();
    // build the array with the definition values
    foreach ($this->defArray as $def)
    {
      if (isset($def['value']))
      {$saveArray[$def['smartyname']] = $def['value'];}
    }

    $data_str = serialize($saveArray);
    if ($fp = fopen($file,"w"))
    {
      fwrite($fp,$data_str);
      fclose($fp);
      return TRUE;
    }
    return FALSE;
  }


  // Statische Funktionen
/**
* Name:loadLayoutFromPluginDir($dir)
*
* loads a layout-object from the pluginfolder
*
*/
  function loadLayoutFromPluginDir($dir)
  {
    // check if the layout_definition.txt file exists
    if (file_exists(LAYOUTDIR."/".$dir."/layout_definition.txt"))
    {
      // make new LAYOUT-OBJEKT
      $o_layout = new layout($dir);

      $lines = file(LAYOUTDIR."/".$dir."/layout_definition.txt");

      //clean & sort the lines in the layout_definition.txt files
      $data_lines 	     = array();
      $def_lines      	 = array();
      $globalvalue_lines = array();
      foreach ($lines as $line)
      {
        //clean some linebrakes
        $line = trim(chop($line));
        //delete whitespace and comments
        if ( (strlen($line) > 0) && (!(substr($line,0,2)=="//")) )
        {
          if     ((substr($line,0,5)=="TEXT("))     {array_push($def_lines,$line);}
          elseif ((substr($line,0,7)=="SYSTEM("))   {array_push($globalvalue_lines,$line)}
          elseif ((substr($line,0,9)=="METADATA(")) {array_push($globalvalue_lines,$line)}          
          else {array_push($data_lines,$line);}
        }
      }

      //process the Data Array
      if (isset($data_lines[0])) {$o_layout->setName($data_lines[0]);}
      if (isset($data_lines[1])) {$o_layout->setAuthor($data_lines[1]);}
      if (isset($data_lines[2])) {$o_layout->setHomepage($data_lines[2]);}

      // process the Definitions Array
      foreach ($def_lines as $line)
      {
        // TEXT delete
        $line = substr($line,5);
        // the latest ')' chars
        $line = substr($line,0,strlen($line)-1);
        //split into datafields
        $felder = explode(")/(",$line);

        $definition = array();
        if (count($felder) >= 2)
        {
          //musst have fields
          $definition['smartyname'] 	= $felder[0];
          $definition['description'] 	= $felder[1];

          // optional fields
          if (isset($felder[2])) {$definition['maxlength'] = $felder[2];}

          // add Definition to the Layout
          $o_layout->addDefinition($definition);
        }
      } // end foreach $def_lines

      // process the global values Array
      foreach ($globalvalue_lines as $line)
      {
        // TEXT delete
        if (substr($line,0,9)=="METADATA(") {$line = substr($line,9);}
        
        // the latest ')' chars
        $line = substr($line,0,strlen($line)-1);
        //split into datafields
        $felder = explode(")/(",$line);

        $definition = array();
        if (count($felder) >= 2)
        {
          //musst have fields
          $definition['smartyname'] 	= $felder[0];
          $definition['description'] 	= $felder[1];

          // optional fields
          if (isset($felder[2])) {$definition['maxlength'] = $felder[2];}

          // add Definition to the Layout
          $o_layout->addDefinition($definition);
        }
      } // end foreach $def_lines   

      // if Layout is valid then return
      if ($o_layout->checkValid())
      {
        $o_layout->loadDefinitionValues();
        return $o_layout;
      }
      else
      {
        //print ("// not valid");
        return FALSE;
      }

    } // end file_exists
    else
    {
      //print ("// es existiert keine layout_definition.txt datei");
      return FALSE;
    }
  }

  /**
  * Name:getAllLayoutPlugIns()
  *
  * Is needed for reading older "inf" files
  * return $layout_array or FALSE
  */
  function getAllLayoutPlugIns()
  {
     $layout_array = array();
     // init all subfolders in the Layout folder
     $layout_dirs = array();
     $handle = opendir(LAYOUTDIR);
     while ($file = readdir($handle))
     {
       if (is_dir(LAYOUTDIR."/".$file))
       {
         array_push($layout_dirs, $file);
       }
     }

     //look for a valid Layout-Plugin folder
     foreach ($layout_dirs as $dir)
     {
       if ($o_layout = layout::loadLayoutFromPluginDir($dir))
       {
         array_push($layout_array, $o_layout);
       }
     }

     // Return layout array
     if (count($layout_array) > 0) 	{return $layout_array;}
     else							{return FALSE;}
  }

}

?>