<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # Konfigurationsfunktionen                      #
  #################################################

  require("include/ConfigTool.class.php");
  define("CONFIGFILE_PATH","podbloggerData/");

  #######################################################################
  # INIT-WORK
  #######################################################################
  #
  # This include-File is nearly used by ervery podblogger sourcecode file
  # to use the config data do "include/funktions_sammlung.inc.php"
  #######################################################################


  // Default ConfigWerte --------------------------------------------
  // this default values were used for podbloggers first start an writing of
  // the first configfile.

  $defValues = array();

  // New config values can be set by using 'addDefaultConfig(CONFIG_KEY,CONFIG_DEFAULTVALUE)' function
  // new data will be updated after relaoding the configfile.
  addDefaultConfig("PODBLOGGER_VERSION","0.5");
  addDefaultConfig("PODBLOGGER_STATUS","INSTALL");
  addDefaultConfig("PODBLOGGER_NEXTSTEP","INSTALLCHECK_START");
  addDefaultConfig("PODCAST_NAME","My Podblogger");
  addDefaultConfig("PODCAST_DESCRIPTION","");
  addDefaultConfig("PODCAST_CATEGORY",array("General","Misc"));

  addDefaultConfig("ADMIN_PASSWORD","");
  addDefaultConfig("ADMIN_NAME","");
  addDefaultConfig("ADMIN_EMAIL","");
  addDefaultConfig("ADMIN_EMAILNOTIFICATION","NEIN");

  addDefaultConfig("ADMIN_LANGUAGE","default");
  addDefaultConfig("FILES_PER_PAGE","10");
  addDefaultConfig("STATS_RSS","NEIN");
  addDefaultConfig("STATS_MP3","NEIN");
  addDefaultConfig("WEBSPACE_LIMIT","0");
  addDefaultConfig("JUST_ADMIN_UPLOAD","NEIN");
  addDefaultConfig("LOKAL_PERL","FALSE");

  addDefaultConfig("UPLOADRELAIS_SWITCH","AUS");
  addDefaultConfig("UPLOADRELAIS_UP_ADRESS","");
  addDefaultConfig("UPLOADRELAIS_DOWN_ADRESS","");
  addDefaultConfig("AUDIOCONVERT_SWITCH","AUS");
  addDefaultConfig("AUDIOCONVERT_ADDRESS","");
  addDefaultConfig("MAILIMPORT_SWITCH","AUS");
  addDefaultConfig("MAILIMPORT_POP","");
  addDefaultConfig("MAILIMPORT_NAME","");
  addDefaultConfig("MAILIMPORT_PASS","");

  addDefaultConfig("TEXTCOMMENTS","AUS");
  addDefaultConfig("TRACKBACKS",  "AN");

  addDefaultConfig("LAYOUT_ID","std");
  addDefaultConfig("STDLAYOUT_MP3FLASHPLAYER","JA");

  ############ AUTO-UPDATE for Podblogger 0.3 ##################################
 // updates some changes from the podblogger 0.3 to the 0.4 & 0.5
 // that concern the configuration routines.
  if (file_exists("config.txt.php"))
  {
    if (!file_exists(CONFIGFILE_PATH."config.txt"))
    {

      // checking file rights in 'CONFIGFILE_PATH'
      if (!checkDir(CONFIGFILE_PATH))
      {
        print "<strong>PROBLEM:</strong><br>Please set the rights of the directory '".CONFIGFILE_PATH."' (in podblogger root directory) to 777. (1)<br><br>";

        print "<strong>PROBLEM:</strong><br>Podblogger konnte nicht mit der Installation beginnen, da das Verzeichnis '".CONFIGFILE_PATH."' im podblogger-Verzeichnis auf dem Webserver scheinbar keine Schreibrechte besitzt. ".
              "Bitte versuchen Sie diese Schreibrechte (chmod 777) manuell z.B. mit einem FTP-Programm zu setzten.";

        print "<br><br>Mehr Informationen zum Setzten von Schreibrechten unter:<br>";
        print "<a href='http://www.pc-special.net/?idcat=73' target='_blank'>http://www.pc-special.net/?idcat=73</a><br><br>";

        exit();
      }

      // load values from PB0.3 configfile
      require("config.txt.php");

      // apply new configfile
      $config_object = new ConfigTool();
      $config_object->setIndent( 30 );
      $config_object->setFileName(CONFIGFILE_PATH."config.txt" );

      // put new loaded values into new configfile
      savePHPvar($config_object, "PODCAST_NAME", 				"PODCAST_NAME", 			getDefault("PODCAST_NAME"));
      savePHPvar($config_object, "PODBLOGGER_VERSION", 			"PODBLOGGER_VERSION", 		"0.3");
      savePHPvar($config_object, "PODBLOGGER_STATUS", 			"PODBLOGGER_STATUS", 		"UPDATE");

      savePHPvar($config_object, "PODCAST_DESCRIPTION", 		"PODCAST_BESCHREIBUNG", 	getDefault("PODCAST_DESCRIPTION"));
      savePHPvar($config_object, "PODCAST_CATEGORY", 			"PODCAST_KATEGORIEN", 		getDefault("PODCAST_CATEGORY"));

      savePHPvar($config_object, "ADMIN_PASSWORD", 				"ADMIN_PASSWORD", 			getDefault("ADMIN_PASSWORD"));
      savePHPvar($config_object, "ADMIN_NAME", 					"ADMIN_NAME", 				getDefault("ADMIN_NAME"));
      savePHPvar($config_object, "ADMIN_EMAIL", 				"ADMIN_EMAIL", 				getDefault("ADMIN_EMAIL"));
      savePHPvar($config_object, "ADMIN_EMAILNOTIFICATION", 	"EMAIL_BENACHRICHTIGUNG", 	getDefault("ADMIN_EMAILNOTIFICATION"));

      savePHPvar($config_object, "FILES_PER_PAGE", 				"DATEIEN_PRO_SEITE", 		getDefault("FILES_PER_PAGE"));
      savePHPvar($config_object, "STATS_RSS", 					"PODCAST_RSS_STATS", 		getDefault("STATS_RSS"));
      savePHPvar($config_object, "STATS_MP3", 					"PODCAST_MP3_STATS", 		getDefault("STATS_MP3"));
      savePHPvar($config_object, "WEBSPACE_LIMIT", 				"WEBSPACE_LIMIT", 			getDefault("WEBSPACE_LIMIT"));
      savePHPvar($config_object, "UPLOADRELAIS_MODE", 			"UPLOAD_MODE", 				"man" );
      savePHPvar($config_object, "EXTSERVER_MODE", 			    "UPLOADRELAIS_MODE", 		getDefault("EXTSERVER_MODE"));
      savePHPvar($config_object, "UPLOADRELAIS_UP_ADRESS", 		"UPLOAD_CGI_SCRIPT", 		getDefault("UPLOADRELAIS_UP_ADRESS"));
      savePHPvar($config_object, "UPLOADRELAIS_DOWN_ADRESS", 	"DOWNLOAD_CGI_SCRIPT", 		getDefault("UPLOADRELAIS_DOWN_ADRESS"));

      savePHPvar($config_object, "STDLAYOUT_MP3FLASHPLAYER", 	"PODCAST_MP3FLASHPLAYER", 	getDefault("STDLAYOUT_MP3FLASHPLAYER"));


      //save new config file
      $config_object->saveToFile();


      // delete the old config file
      if (!@unlink("config.txt.php"))
      {
        if (file_exists(CONFIGFILE_PATH."config.txt"))
        {
          print "PROBLEM: Neue Konfiguration konnte angelegt werden. Doch die alte Datei '/config.txt.php' lsst<br>".
                "sich nicht lschen. Bitte lschen Sie diese direkt auf dem Server. Ansonsten kann podblogger nicht sauber laufen.";
        }
        else
        {
          print "PROBLEM: podblogger kann nicht im Verzeichnis '".CONFIGFILE_PATH."' schreiben!".
                "Bitte setzten Sie ber ein FTP-Programm die Schreibrechte (chmod(777)).";

          print "<br><br>Mehr Informationen zum Setzten von Schreibrechten unter:<br>";
          print "<a href='http://www.pc-special.net/?idcat=73' target='_blank'>http://www.pc-special.net/?idcat=73</a><br><br>";
        }
        exit();
      }
    }
    else
    {
      print "PROBLEM: Es exitieren zwei Konfigurationsdateien!<br><br>".
            "- Die alte Konfiguration '/config.txt.php'<br>".
            "- Die neue Konfiguration '/".CONFIGFILE_PATH."config.txt'<br><br>".
            "Sie knnen das Problem lsen, indem Sie die alte Konfiguration auf dem Server lschen.<br>".
            "Doch damit gehen auch die darin enthaltenden Einstellungen verlohren.<br>";
      exit();
    }

  }

 ############fin################################################################

 ############ apply CONFIG-file on first start #################################

  if (!file_exists(CONFIGFILE_PATH."config.txt"))
  {
    // checking file rights in 'CONFIGFILE_PATH'
    if (!checkDir(CONFIGFILE_PATH))
    {
      print "<strong>PROBLEM:</strong><br>Please set the rights of the directory '".CONFIGFILE_PATH."' (in podblogger root directory) to 777. (2)<br><br>";

      print "<strong>PROBLEM:</strong><br>podblogger konnte nicht mit der Installation beginnen, da das Verzeichnis '".CONFIGFILE_PATH."' im podblogger-Verzeichnis auf dem Webserver scheinbar keine Schreibrechte besitzt. ".
            "Bitte versuchen Sie diese Schreibrechte (chmod 777) manuell z.B. mit einem FTP-Programm zu setzten.";

      print "<br><br>Mehr Informationen zum Setzten von Schreibrechten unter:<br>";
      print "<a href='http://www.pc-special.net/?idcat=73' target='_blank'>http://www.pc-special.net/?idcat=73</a><br><br>";

      exit();
    }

    // apply configuration
    $config_object = new ConfigTool();
    $config_object->setIndent( 30 );
    $config_object->setFileName(CONFIGFILE_PATH."config.txt" );

    // put new loaded values from defalut-Array into new configfile
    foreach ($defValues as $value)
    {
      initConfigValue($config_object, $value["key"], $value["value"]);
    }

    // save config file
    $config_object->saveToFile();

    // check if configfile(config.txt) was written
    if (file_exists(CONFIGFILE_PATH."config.txt"))
    {
      // check if .htacces file protects the directory
      if (!file_exists(CONFIGFILE_PATH.".htaccess"))
      {
        if ($fp = @fopen(CONFIGFILE_PATH.".htaccess","w"))
        {
          fwrite($fp,"Order deny,allow\nDeny from all\n");
          fclose($fp);
        }
      }
    }
  }


  ############ CONFIG-DATEN LADEN ####################################
  // the values from 'config.txt' musst be set to global php  variables

  $config_object = new ConfigTool();
  $config_object->setConfigFromFile(CONFIGFILE_PATH."config.txt");

  // auto load all 'DefaultArray' KEY's from the config.txt file
  // and store them as GLOBAL variables
  foreach ($defValues as $value)
  {
    $GLOBALS[$value['key']] = getValue($config_object, $value['key']);
  }

  // Try to read out some data from the manSettings.txt
  // this data will also apply as Global variables to the Podbloggersystem
  // the manSettings.txt file holds data about fileformats for uploading an
  // converting files e.g. take a look into the file ;-)


  if (file_exists(CONFIGFILE_PATH."manSettings.txt"))
  {
    $lines = file(CONFIGFILE_PATH."manSettings.txt");
    foreach ($lines as $line)
    {
      $line = chop($line);
      if ( (strlen($line)>0) && ($line[0]!="#") && (stristr($line,"===")) )
      {
        $parts = explode("===",$line,2);
        $name  = trim(array_shift($parts));
        $value = trim(implode("===",$parts));
        if (strlen($name)>3)
        {
          $GLOBALS[$name] = $value;
        }
      }
    }
  }

  // Renaming some importent variables
  $PODCAST_BESCHREIBUNG     = $PODCAST_DESCRIPTION;
  $PODCAST_KATEGORIEN       = $PODCAST_CATEGORY;
  $EMAIL_BENACHRICHTIGUNG   = $ADMIN_EMAILNOTIFICATION;
  $DATEIEN_PRO_SEITE        = $FILES_PER_PAGE;
  $PODCAST_RSS_STATS        = $STATS_RSS;
  $PODCAST_MP3_STATS        = $STATS_MP3;
  $UPLOAD_CGI_SCRIPT        = $UPLOADRELAIS_UP_ADRESS;
  $DOWNLOAD_CGI_SCRIPT      = $UPLOADRELAIS_DOWN_ADRESS;
  $PODCAST_MP3FLASHPLAYER   = $STDLAYOUT_MP3FLASHPLAYER;

  // Now all important configuration values are loaded


  ############ check the current case UPDATE or INSTALL ########################

  // ---- UPDATE configuration podblogger 0.4 and higher ------

  // check the PODBLOGGER_VERSION variable
  // if the value is under the default value case == update

  if  ( doubleval($PODBLOGGER_VERSION) < (getDefault('PODBLOGGER_VERSION')) )
  {
     $PODBLOGGER_STATUS = "UPDATE";
     updateValueInConfigFile("PODBLOGGER_STATUS");

    $PODBLOGGER_NEXTSTEP = "INSTALLCHECK_START";
    updateValueInConfigFile("PODBLOGGER_NEXTSTEP");
  }

  // in any case redirect to installcheck.php

  if ( (!isset($GLOBALS['installcheck'])) && ($PODBLOGGER_NEXTSTEP == "INSTALLCHECK_START") )
  {

    $PODBLOGGER_NEXTSTEP = "INSTALLCHECK_FIRST";
    updateValueInConfigFile("PODBLOGGER_NEXTSTEP");

    // html redirect (installcheck.php)
    ?>
    <html>
    <head>
    <? print '<meta http-equiv="refresh" content="0; URL=installcheck.php">'; ?>
    <title>...</title>
    </head>
    <body><br>
    <center>
    <? print '<a href="installcheck.php">'; ?>
    click ...</a></center>
    </body>
    </html>
    <?
    exit();
  }

  #### FINISH INIT-WORK #############################################


  ####################################################################
  # EIGENE KONFIGURATIONFUNKTIONEN
  ####################################################################
  #
  # Folgende Funktionen werden zum Arbeiten mit der Klasse ConfigTool
  # bentigt.
  #
  ####################################################################

/**
* Name:config_isset (&$config_object, $valueName)
*
* check if config value is set
* return:BOOLEAN
*/
function config_isset (&$config_object, $valueName)
  {
    if (!$config_object->isDefined($valueName))
    {return FALSE;}
    else
    { return TRUE;}
  }
/**
* Name:initConfigValue(&$config_object, $valueName, $value)
*
* sets config value if it isn't set
* returns nothing
*/
function initConfigValue(&$config_object, $valueName, $value)
  {
    if (!config_isset($config_object, $valueName))
    {
      $value = serialize($value);
      $config_object->addKeyValue( $valueName, urlencode($value));
    }
  }
/**
* Name:updateConfigValue(&$config_object, $valueName, $value)
*
* updates config value with a new one
* returns nothing
*/
function updateConfigValue(&$config_object, $valueName, $value)
  {
    if (config_isset($config_object, $valueName))
    {
      $value = serialize($value);
      $config_object->updateKeyValue( $valueName, urlencode($value));
    }
  }
/**
* Name: savePHPvar(&$config_object, $valueName, $phpVar, $defaultValue)
*
* saves php variables into the configfile if it wasent set allready value == DEFAULT
* returns nothing
*/
function savePHPvar(&$config_object, $valueName, $phpVar, $defaultValue)
  {
    // prfen, ob PHP-Variable gesetzt wurde
    if (isset($GLOBALS[$phpVar]))
    { $toSaveValue = $GLOBALS[$phpVar]; }
    else
    { $toSaveValue = $defaultValue;}

    // ConfigWert speichern
    initConfigValue($config_object, $valueName, $toSaveValue);
  }
/**
* Name: getValue(&$config_object, $valueName)
*
* returns a config value by the given $valueName and $config_object
*/
function getValue(&$config_object, $valueName)
  {
    if (config_isset($config_object, $valueName))
    {
      $value = $config_object->get($valueName);
      // if (strlen($value) > 1) 	{return unserialize(urldecode($value));}
      return unserialize(urldecode($value));
    }
    else
    {
      // for variable is not set yet check for default value in Default-Array
       {

        foreach ($GLOBALS['defValues'] as $value)
        {
          if ($value["key"] == $valueName)
          {
            // Default-Wert found writing into Config file
            $config_object->setIndent( 30 );
            initConfigValue($config_object, $value["key"], $value["value"]);
            // save config file
            $config_object->saveToFile();
            return $value["value"];
          }
        }

        //If not found exit with error massage
        exit("Der Wert '".$valueName."' existiert nicht als Config-Vaule!! Weder in der Configdatei ... noch als Defaultwert.");

      }
    }
  }
/**
* Name: updateValueInConfigFile($key)
*
* updates a value by a given key
* returns nothing
*/
function updateValueInConfigFile($key)
  {
    $value = $GLOBALS[$key];
    $conf = new ConfigTool();
    $conf->setConfigFromFile(CONFIGFILE_PATH."config.txt");
    if (config_isset($conf, $key))
    {
      $value = serialize($value);
      $conf->updateKeyValue( $key, urlencode($value));
      $conf->saveToFile();
    }
    else
    {
      die("FEHLER: Config-Wert '".$key."' existiert nicht in config.txt.");
    }
  }
/**
* Name: addDefaultConfig($key, $value)
*
* adds a value to the Default-Array
* returns nothing
*/
function addDefaultConfig($key, $value)
  {
    array_push($GLOBALS['defValues'],array("key" => $key, "value" => $value));
  }
/**
* Name: getDefault ($key)
*
* returns the matching value by the given key from the Default-Array
*/
function getDefault ($key)
  {
    foreach ($GLOBALS['defValues'] as $defPair)
    {
      if ($defPair['key'] == $key)
      { return $defPair['value']; }
    }
    return FALSE;
  }
/**
* Name: checkDir($verzeichnispfad)
*
* test write permission for a given folder
* returns Boolean (TRUE or FALSE)
*/
function checkDir($verzeichnispfad)
  {
    if ($fp = @fopen($verzeichnispfad."test.tst","w"))
    {
      // write file a testfile
      fwrite($fp,"TEST");
      fclose($fp);
      $fp = @fopen($verzeichnispfad."test.tst","r");
      $text = @fread($fp,1024);
      @fclose($fp);
      @unlink($verzeichnispfad."test.tst");

      // check written testfile
      if ($text == "TEST")
      { return TRUE; }

    }
    return FALSE;
  }
?>