<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # ticketmanager.inc.php                         #
  #################################################

###################################################################################
# class of static methods to manage serveral tickets
# tickets are needed to remember if external orders (e.g. request for service) were
# really done by the system and by another source

// a global unique number
$RandomTicketCodeCounter = 0;

class ticketmanager
{

  /**
  * Name:  writeTicketDataToFile($type,$ticketid,$ticketcode,$belongsToArticle="0",$ticketdata="")
  *
  * stores a ticket to the ticketlist
  */
  function writeTicketDataToFile($type,$ticketid,$ticketcode,$belongsToArticle="0",$ticketdata="")
  {
    $ticketcode = trim($ticketcode);
    $filemode="a";
    if (!file_exists("podbloggerData/tickets.txt"))
    {
      print "<!-- ticketfile will be created ->";
      if ($fp = fopen("podbloggerData/tickets.txt","w"))
      {
        fclose($fp);
        chmod ("podbloggerData/tickets.txt", 0644);
      }
      else
      {
        if ($debug) print "\nPROBLEM:::TICKETMANAGER-CLASS::writeTicketDataToFile: Cannt create: podbloggerData/tickets.txt\n";
      }
    }

    // Store Ticketdata to file
    if ($fp = fopen("podbloggerData/tickets.txt","a"))
    {
       flock($fp,LOCK_EX);
       fwrite($fp,"$type;".time().";$ticketid;$ticketcode;$belongsToArticle;".urlencode($ticketdata).";RUNNING\n");
       flock($fp,LOCK_UN);
       fclose($fp);
    }
    else
    {
      if ($debug) print "\nPROBLEM:::TICKETMANAGER-CLASS::writeTicketDataToFile: Cannt connect open: podbloggerData/tickets.txt\n";
    }
  }
/**
* Name: getType($ticketArray)
*
* return $ticketArray[0];
*/
  function getType($ticketArray)
  { return $ticketArray[0]; }
/**
* Name: getTime($ticketArray)
*
* return $ticketArray[1];
*/
  function getTime($ticketArray)
  { return $ticketArray[1]; }
/**
* Name: getID($ticketArray)
*
* return $ticketArray[2];
*/
  function getID($ticketArray)
  { return $ticketArray[2]; }
/**
* Name: getCode($ticketArray)
*
* return $ticketArray[3];
*/
  function getCode($ticketArray)
  { return $ticketArray[3]; }
/**
* Name: getRelatedArticle($ticketArray)
*
* return $ticketArray[4];
*/
  function getRelatedArticle($ticketArray)
  { return $ticketArray[4]; }
/**
* Name: getData($ticketArray)
*
* return urldecode($ticketArray[5]);
*/
  function getData($ticketArray)
  { return urldecode($ticketArray[5]); }
/**
* Name: getState($ticketArray)
*
* return trim($ticketArray[6]);
*/
  function getState($ticketArray)
  { return trim($ticketArray[6]); }

/**
* Name: setState($id,$state)
*
* read Ticketlines
* Store Ticketdata to file and modify state on given ticket
*
*/
  function setState($id,$state)
  {
     //read Ticketlines
    $lines = file("podbloggerData/tickets.txt");
    // Store Ticketdata to file and modify state on given ticket
    if ($fp = fopen("podbloggerData/tickets.txt","w"))
    {
       flock($fp,LOCK_EX);

       //write back Ticketlines
       foreach ($lines as $line)
       {
         $ticketparts = explode(";",$line);
         if ($ticketparts[2]==$id)
         {
           $ticketparts[6]=$state;
           fwrite($fp,implode(";",$ticketparts)."\n");
         }
         else
         { fwrite($fp,$line); }
       }

       flock($fp,LOCK_UN);
       fclose($fp);
    }
    else
    {
      if ($debug) print "\nPROBLEM:::TICKETMANAGER-CLASS::deleteTicket: Cannt connect open: podbloggerData/tickets.txt\n";
    }
  }

/**
* Name:loadTicketArray()
*
* returns a 2d-array 1: several tickets 2: ticket data fields
*/
  function loadTicketArray()
  {
    $ticketArray = Array();
    // load Ticket-Array
    $lines = file("podbloggerData/tickets.txt");
    foreach($lines as $line)
    {
      if ($line!="")
      {
        $ticket = explode(";",$line);
        array_push($ticketArray,$ticket);
      }
    }
    return $ticketArray;
  }

  /**
  * Name:getTicketData($id)
  *
  * returns the datafield of a ticket
  * the datafield is used to store extended information
  * on the order connected to the ticket (e.g. the quality of convertion)
  */
  function getTicketData($id)
  {
    $ticketArray = Array();
    // load Ticket-Array
    $lines = file("podbloggerData/tickets.txt");
    foreach($lines as $line)
    {
      if ($line!="")
      {
        $ticketparts = explode(";",$line);
        if ($ticketparts[2]==$id) {return urldecode($ticketparts[5]);}
      }
    }
    return FALSE;
  }


  /**
  * Name:deleteTicket($ticketline)
  *
  * delets a given ticketline from the ticket storage
  * read  ticketlines
  * Store ticketdata to file
  * writeback ticketlines
  *
  */
  function deleteTicket($ticketline)
  {
    //read  ticketlines
    $lines = file("podbloggerData/tickets.txt");
    // Store ticketdata to file
    if ($fp = fopen("podbloggerData/tickets.txt","w"))
    {
       flock($fp,LOCK_EX);

       // ticketlines zurckschreiben
       foreach ($lines as $line)
       {
         $ticketparts = explode(";",$line);
         if ((trim($line)!=$ticketline) && (!ticketmanager::isOutdated($ticketparts[1])))
         { fwrite($fp,$line); }
       }

       flock($fp,LOCK_UN);
       fclose($fp);
    }
    else
    {
      if ($debug) print "\nPROBLEM:::TICKETMANAGER-CLASS::deleteTicket: Cannt connect open: podbloggerData/tickets.txt\n";
    }
  }

  /**
  * Name:deleteTicketById($id)
  *
  * delets a ticket from the ticket storage by ticketid
  */

  function deleteTicketById($id)
  {
    $id = trim($id);
    //read ticketlines
    $lines = file("podbloggerData/tickets.txt");
    // Store Ticketdata to file
    if ($fp = fopen("podbloggerData/tickets.txt","w"))
    {
       flock($fp,LOCK_EX);

       //write back ticketlines
       foreach ($lines as $line)
       {
         $ticketparts = explode(";",$line);
         $ticketparts[2] = trim($ticketparts[2]);
        if (strcmp($ticketparts[2],$id)!=0)
        {
          if (!ticketmanager::isOutdated($ticketparts[1]))
          {
            fwrite($fp,$line);
          }
        }
       }

       flock($fp,LOCK_UN);
       fclose($fp);
    }
    else
    {
      if ($debug) print "\nPROBLEM:::TICKETMANAGER-CLASS::deleteTicket: Cannt connect open: podbloggerData/tickets.txt\n";
    }
  }
/**
* Name:getTicketById($id)
*
* returns the ticket array by id
*
*/

  function getTicketById($id)
  {
    $id = trim($id);
    //read ticketlines
    $lines = file("podbloggerData/tickets.txt");
    //writeback ticketlines
    foreach ($lines as $line)
    {
      $ticketparts = explode(";",$line);
      $ticketparts[2] = trim($ticketparts[2]);
      if (strcmp($ticketparts[2],$id)==0)
      {
        return $ticketparts;
      }
    }
    return FALSE;
  }

  /**
  * Name: deleteAllTicketsForArticle($artcleid)
  *
  * delets a ticket from the ticket storage by ticketid
  */
  function deleteAllTicketsForArticle($artcleid)
  {
    $artcleid = trim($artcleid);
   //read ticketlines
    if (file_exists("podbloggerData/tickets.txt"))
    { 
      $lines = file("podbloggerData/tickets.txt");
    } else { $lines = array(); }  
    // Store Ticketdata to file
    if ($fp = fopen("podbloggerData/tickets.txt","w"))
    {
       flock($fp,LOCK_EX);

      //writeback ticketlines
       foreach ($lines as $line)
       {
         $ticketparts = explode(";",$line);
         $ticketparts[4] = trim($ticketparts[4]);
         if ((strcmp($ticketparts[4],$artcleid)!=0) && (!ticketmanager::isOutdated($ticketparts[1])))
         { fwrite($fp,$line); }
       }

       flock($fp,LOCK_UN);
       fclose($fp);
    }
    else
    {
      if ($debug) print "\nPROBLEM:::TICKETMANAGER-CLASS::deleteTicket: Cannt connect open: podbloggerData/tickets.txt\n";
    }
  }

  /**
  * Name:getAllTicketsForArticle($artcleid)
  *
  * delets a ticket from the ticket storage by ticketid
  */
  function getAllTicketsForArticle($artcleid)
  {
    $backArray = array();
    $artcleid = trim($artcleid);

    //read ticketlines
    if (!file_exists("podbloggerData/tickets.txt")) {return array();}
    $lines = file("podbloggerData/tickets.txt");

    //writeback ticketlines
    foreach ($lines as $line)
    {
      $ticketparts = explode(";",$line);
      $ticketparts[4] = trim($ticketparts[4]);
      if (strcmp($ticketparts[4],$artcleid)==0)
      {
        array_push($backArray,$ticketparts);
      }
    }

    return $backArray;
  }

  /**
  * Name: areTicketsActive()
  *
  * delets a ticket from the ticket storage by ticketid
  */
  function areTicketsActive()
  {
      //read ticketlines
    if (!file_exists("podbloggerData/tickets.txt")) {return FALSE;}
    $lines = file("podbloggerData/tickets.txt");

     //writeback ticketlines
    foreach ($lines as $line)
    {
      $ticketparts = explode(";",$line);
      $ticketparts[6] = trim($ticketparts[6]);
      if ($ticketparts[6]!="DONE") { return TRUE; }
    }

    return FALSE;
  }

  /**
  * Name:isTicketValid($type,$articleid,$code)
  *
  * checks if a ticket is valid (in storage)
  */
  function isTicketValid($type,$articleid,$code)
  {
    $tickets = ticketmanager::loadTicketArray();
    foreach ($tickets as $ticket)
    {
      if ((is_Array($ticket)) && (count($ticket)>=4) && ($ticket[0]==$type) && ($ticket[4]==$articleid) && (trim($ticket[3])==$code))
      return trim($ticket[2]);
    }
    return FALSE;
  }


  /**
  * Name:isTicketValid($type,$articleid,$code)
  *
  *  return TRUE if a ticket is older than 30 days
  */
  function isOutdated($tickettime)
  {
    $seconds = 30 * 24 * 60 * 60;
    print "<!-- ($tickettime) > (".time()-$seconds.")-->";
    if (intval($tickettime) > (time()-$seconds)) { print "<!-- FALSE ->"; return FALSE;}
    print "<!-- TRUE ->";
    return TRUE;
  }

  /**
  * Name:isTicketValid($type,$articleid,$code)
  *
  *  creates a ticketcode by random
  */
  function createRandomTicketCode()
  {
    $GLOBALS['RandomTicketCodeCounter']++;
    $randZahl = intval($GLOBALS['RandomTicketCodeCounter'].mt_rand(100000,999999));
    return $randZahl;
  }
}
?>