<?
  #################################################
  # podblogger 0.5                                #
  # author:      Christian Rotzoll                #
  # co author:   Hagen Toennies                   #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # RSS-FEED-Generator                            #
  #################################################

  require_once("include/funktions_sammlung.inc.php");
  require_once("include/bbcode.inc.php");
  require_once("include/LogFile.class.php");
  require_once("include/article.class.php");
  require_once("include/testServerPath.inc.php");
  require_once("include/mp3Info.class.php");
  require_once("include/layout.class.php"); // for the systemvalues by layout plugin

/**
* Name: is_client_iTunes()
*
* checks if i-tunes is the client
* return TRUE or FALSE;
*/
  function is_client_iTunes()
  {
    $client = getenv('HTTP_USER_AGENT');
    if (stristr($client,"iTunes")) // 'iTunes/4.9' for Version 4.9
    {return TRUE;}
    else
    {return FALSE;}
  }

/**
* Name: is_client_Windows()
*
* checks if windows is the client
* return TRUE or FALSE;
*/
  function is_client_Windows()
  {
    $client = getenv('HTTP_USER_AGENT');
    if (stristr($client,"Windows"))
    {return TRUE;}
    else
    {return FALSE;}
  }

  // checks if the Podbloggersystem is runable after an update
  if ($PODBLOGGER_STATUS != "READY")
  {
    //before the Install or Update routine has finished, the RSS file is not avalible
    header("HTTP/1.0 404 Not Found");

    exit();
  }

  // import format parameter
  $format = "";
  if (issetPostGet('format'))
  {
    $format = getPostGetText('format');
    if (isset($PUBLISHFORMATS))
    {
      $allowedFormats = explode(";",strtoupper($PUBLISHFORMATS));
      if (!in_array(strtoupper($format),$allowedFormats))
      { printErrorRSS("Format is not supported", "Sorry. This cast does not support the file format you requested."); }
    }

    if (issetPostGet('quality'))
    {
      $quality = strtoupper(getPostGetText('quality'));
      if ( ($quality!="NORM") && ($quality!="LOW") && ($quality!="HIGH") )
      { printErrorRSS("Not supported quality.", "Quality can be LOW, NORM or HIGH."); }
    }
  }


  // import kategorie/cat if set
  $kategorie = "";
  if (issetPostGet('cat'))	     { $kategorie = getPostGetText('cat'); }
  if (issetPostGet('kategorie')) { $kategorie = getPostGetText('kategorie'); }
  if ($kategorie!="") { $titelzusatz = " - ".$kategorie; }
  else 				  { $titelzusatz = ""; }


  // maybe just print the iTunes One Click subscription
  if (issetPostGet('pcast'))
  {
    $pcast = getPostGetText('pcast');
    if ( !is_client_Windows() )
    {
      // for mac computers redirect again with pcast-protokoll
      if ($kategorie=="") { header("Location: pcast://".HTTP_BASISADRESSE."rss.php"); }
      else				  { header("Location: pcast://".HTTP_BASISADRESSE."rss.php?cat=".$kategorie); }
      exit();
    }

    if ($PODCAST_BESCHREIBUNG=="") {$PODCAST_BESCHREIBUNG="no description available";}
    if (!isset($RSS_TOPCATEGORY)) {$RSS_TOPCATEGORY="Audio Blogs";}

    // printing the XML needed to make iTunes subscribe to the feed
    header("Content-Disposition: attachment; filename=oneclick.pcast");
    header('Content-Type: application/octet-stream',TRUE);
    print '<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE pcast PUBLIC "-//Apple Computer//DTD PCAST 1.0//EN" "http://www.itunes.com/DTDs/pcast-1.0.dtd">
<pcast version="1.0">
<channel>';

    if ($kategorie=="") { print '<link rel="feed" type="application/rss+xml" href="http://'.HTTP_BASISADRESSE.'rss.php" />';}
    else				{ print '<link rel="feed" type="application/rss+xml" href="http://'.HTTP_BASISADRESSE.'rss.php?cat='.$kategorie.'" />';}

    print '<title>'.sonderzeichenWandeln(strip_tags($PODCAST_NAME.$titelzusatz)).'</title>
<category>'.$RSS_TOPCATEGORY.'</category>
<subtitle>'.sonderzeichenWandeln(strip_tags(substr($PODCAST_DESCRIPTION,0,50))).'</subtitle>
</channel>
</pcast>';

    exit();
  }

  if ($PODCAST_RSS_STATS == "JA")
  {
    $client = getenv("REMOTE_ADDR");
    // no logging of client software because to much data and logifile is not good compressed yet
    $client = getenv('HTTP_USER_AGENT');
    LogFile::writeLog("RSS/".$kategorie, $client, "RSS");
  }

$DatsInFeed = 5;
// print the RSS XML-File
header ('Content-Type: application/xml; charset=UTF-8',TRUE);

if ($PODCAST_BESCHREIBUNG=="") {$PODCAST_BESCHREIBUNG="no description available";}
print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
/*print "<?xml-stylesheet type=\"text/xsl\" href=\"http://".HTTP_BASISADRESSE."htmlContent/rss.xsl\" ?>\n";
print "<?xml-stylesheet type=\"text/css\" href=\"http://".HTTP_BASISADRESSE."htmlContent/rss.css\" ?>\n"; */
print "<rss xmlns:itunes=\"http://www.itunes.com/dtds/podcast-1.0.dtd\" xmlns:content=\"http://purl.org/rss/1.0/modules/content/\" version=\"2.0\">\n";
print "<channel>\n";
print "<title>".sonderzeichenWandeln(strip_tags($PODCAST_NAME)).$titelzusatz."</title>\n";
print "<link>http://".HTTP_BASISADRESSE."</link>\n";
print "<description>".sonderzeichenWandeln(strip_tags(stripslashes($PODCAST_BESCHREIBUNG)))."</description>\n";
print "<pubDate>" . date("r") . "</pubDate>\n";
print "<lastBuildDate>" . date("r") ."</lastBuildDate>\n";
print "<category>MISC</category>";
print "<language>de</language>\n";
print "<copyright>for license see http://".HTTP_BASISADRESSE."</copyright>\n";
print "<generator>podblogger v0.5</generator>\n";

print "<itunes:author>".sonderzeichenWandeln($ADMIN_NAME)."</itunes:author>\n";
print "<itunes:subtitle>".sonderzeichenWandeln(strip_tags(stripslashes($PODCAST_BESCHREIBUNG)))."</itunes:subtitle>\n";
print "<itunes:summary>".sonderzeichenWandeln(strip_tags(stripslashes($PODCAST_BESCHREIBUNG)))."</itunes:summary>\n";
print "<itunes:owner>\n";
print "<itunes:name>".sonderzeichenWandeln($ADMIN_NAME)."</itunes:name>\n";
print "<itunes:email>".$ADMIN_EMAIL."</itunes:email>\n";
print "</itunes:owner>\n";
print "<itunes:explicit>".$RSS_EXPLICIT."</itunes:explicit>\n";
print "<itunes:keywords>".$RSS_KEYWORDS."</itunes:keywords>\n";
if ($RSS_SUBCATEGORY!="All") { print '<itunes:category text="'.$RSS_TOPCATEGORY.'"><itunes:category text="'.$RSS_SUBCATEGORY.'"/></itunes:category>'."\n"; }
else { print '<itunes:category text="'.$RSS_TOPCATEGORY.'"/>'."\n"; }

// RSS-IMAGE-INCLUDE
//If there is an image named "rsspic.gif" to include into the RSS File it will be included
// should be 88 x 31 pixels and GIF Format
if (file_exists("rsspic.gif"))
{
print '<image>'."\n";
print '  <url>http://'.HTTP_BASISADRESSE."rsspic.gif".'</url>'."\n";
print '  <title>'.sonderzeichenWandeln(strip_tags($PODCAST_NAME)).$titelzusatz.'</title>'."\n";
print '  <width>88</width>'."\n";
print '  <height>31</height>'."\n";
print '  <link>http://'.HTTP_BASISADRESSE.'index.php</link>'."\n";
print '</image>'."\n";
}

// iTUNES-IMAGE-INCLUDE
//If there is an image named "rsspic.jpg" it will be included for iTunes
// should be 300 x 300 pixels and JEPG Format
if (file_exists("rsspic.jpg"))
{
  print '<itunes:image href="http://'.HTTP_BASISADRESSE."rsspic.jpg".'"/>'."\n";
  print '<itunes:link rel="image" type="video/jpeg" href="http://'.HTTP_BASISADRESSE."rsspic.jpg".'">'.sonderzeichenWandeln(strip_tags($PODCAST_NAME)).$titelzusatz.'</itunes:link>'."\n";
}

if ((strlen($ADMIN_EMAIL) > 6) && ($ADMIN_NAME!=""))
{
  print "<managingEditor>".$ADMIN_EMAIL." (".sonderzeichenWandeln($ADMIN_NAME).")"."</managingEditor>";
}
print "\n<ttl>5</ttl>\n\n";

//search for all public contributions
$Dateien = getFilesFromDirWithEnding("publicData","article");

//sort by time stamp
$keyArray = array();
foreach ($Dateien as $datei)
{

  $artikel = article::loadArticleFromFile("publicData/".$datei);

  // maybe check fileaccess rights
  if ( (isset($GLOBALS['RESTRICTED_ACCESS'])) && ($GLOBALS['RESTRICTED_ACCESS']=="YES") )
  {
    $fileaccess = $artikel->getRightsData('fileaccess');
    if ($fileaccess=="NOT_PUBLISHED") { continue; } // dont use this item on RSS
    elseif ($fileaccess=="RESTRICTED_ACCESS")
    {
       // include user defined function to test access rights
       if (!file_exists("podbloggerData/mod_include/security.inc.php")) {  continue;  }
       include_once("podbloggerData/mod_include/security.inc.php");
       if (!function_exists("is_valid_access_article")) { continue; }

      // check if user got is allowed to access item
      if (is_valid_access_article($artikel->getID()) != 2) { continue; }  // user is not allowed, continue with next item
    }
  }

  // if a special format is quested just use the article if he contains the fileformat
  if ($format!="")
  {
    $aFormats = $artikel->getAvailableFormats();
    if (!in_array(strtoupper($format),$aFormats)) {continue;}
  }

  // Only include contributions where the categorie do not beginns with '!';
  $kat = $artikel->getCategory();
  if ($kat[0] != '!')
  {
    if ($kategorie!="")
    {
      if ($kategorie == $artikel->getCategory())
      {$keyArray[$artikel->getUnixTime()] = $artikel;}
    }
    else
    {  $keyArray[$artikel->getUnixTime()] = $artikel; }
  }

}

arsort($keyArray);
reset($keyArray);

// pepare information needed to deal with iTunes
$isiTunes = FALSE;
$isiTunesHackWorking = FALSE;
if (is_client_iTunes())
{
  $isiTunes = TRUE;
  if (testServerPath())
  {$isiTunesHackWorking=TRUE;}
}

// maybe put the $DatsInFeed into the RSS file
// or the files of the last seven days

foreach ($keyArray as $artikel)
{
  //check if the file is not older then seven days
  $diffTime = time() - $artikel->getUnixTime();
  $tage     = round($diffTime / (60*60*24));

  $filename = $artikel->getFile();
  if ($format!="")
  {
    // if quality parameter was set, try to use the requested quality
    $qualities = $artikel->getAvailableQualities($format);
    $useQuality = "NORM";
    if ($quality!="")
    {
      if (in_array($quality,$qualities))
      { $useQuality = $quality; }
      else
      { if (!in_array($useQuality,$qualities)) { $useQuality = array_pop($qualities); } }
    }

    // set the special format and quality
    $filename = $artikel->alternative_files[strtoupper($format)][$useQuality];

    // safety check
    if (!file_exists("publicData/".$filename)) { $filename = $artikel->getFile(); }
  }

  // if it musst, the Mp3 Link has to gu thru the 'getMediaScript'
   if ($PODCAST_MP3_STATS == "JA")
   {
     if ($isiTunes)
     {
       // check if server can use the iTunesHack
       if ($isiTunesHackWorking)
       {
         // use the iTunesHack to use the getMedia.php-Link for statistics
         $mp3Link = "http://".HTTP_BASISADRESSE."getMedia.php/publicData/".$artikel->getFile();
       }
       else
       {
         // as long as iTunes has problems RSS (Version 5.0 still got this problem) counting musst be switchted off ...
         $mp3Link = "http://".HTTP_BASISADRESSE."publicData/".$artikel->getFile();
       }
     }
     else
     {
       $mp3Link = "http://".HTTP_BASISADRESSE."getMedia.php?file=publicData/".$artikel->getFile();
     }
   }
   else
   {
     $mp3Link = "http://".HTTP_BASISADRESSE."publicData/".$artikel->getFile();
   }

  $itemauthor = $artikel->getAuthorMail();
  if ($itemauthor=="") {$itemauthor=strip_tags($ADMIN_EMAIL);}

  if (($DatsInFeed > 0) || ($tage <= 62))
  {
    $beschreibung_htmlCode = bbcode_inc::renderBBCode(sonderzeichenWandeln(sonderzeichenRueckkodierung($artikel->getDescription())));
    $beschreibung_clean    = sonderzeichenWandeln(html_entity_decode(strip_tags($beschreibung_htmlCode)));
    $beschreibung_htmlCode = $beschreibung_htmlCode;

    // RSS 2.0
    print ("<item>\n");
    print ("<title>".sonderzeichenWandeln($artikel->getCategory())." - ".sonderzeichenWandeln(strip_tags($artikel->getTitle()))."</title>\n");
    print ("<link>http://".HTTP_BASISADRESSE. "index.php?permalink=" .$artikel->getID()."</link>\n");
    print ("<guid>http://".HTTP_BASISADRESSE. "index.php?permalink=" .$artikel->getID()."</guid>");
    print ("<comments>http://".HTTP_BASISADRESSE. "index.php?permalink=" .$artikel->getID()."</comments>");
    print ("<category>".sonderzeichenWandeln($artikel->getCategory())."</category>");
    print ("<author>".sonderzeichenWandeln($itemauthor)."</author>");
    print ("<description>".$beschreibung_clean."</description>\n");
    print ("<content:encoded><![CDATA[".$beschreibung_htmlCode."]]></content:encoded>\n");
    print ("<pubDate>".date("r",$artikel->getUnixTime())."</pubDate>\n");
    print ("<enclosure url=\"".$mp3Link."\" length=\"");
    print filesize("publicData/".$artikel->getFile());

    if     (strtoupper(getDateiEndung($artikel->getFile()))=="MP3") { print ("\" type=\"audio/mpeg\"/>\n"); }
    elseif (strtoupper(getDateiEndung($artikel->getFile()))=="OGG") { print ("\" type=\"application/ogg\"/>\n"); }
    elseif (strtoupper(getDateiEndung($artikel->getFile()))=="WAV") { print ("\" type=\"audio/x-wav\"/>\n"); }
    elseif (strtoupper(getDateiEndung($artikel->getFile()))=="MOV") { print ("\" type=\"video/quicktime\"/>\n"); }
    elseif (strtoupper(getDateiEndung($artikel->getFile()))=="AVI") { print ("\" type=\"video/x-msvideo\"/>\n"); }
    elseif (strtoupper(getDateiEndung($artikel->getFile()))=="WMV") { print ("\" type=\"Video/x-ms-wmv\"/>\n"); }
    elseif (strtoupper(getDateiEndung($artikel->getFile()))=="WMA") { print ("\" type=\"Audio/x-ms-wma\"/>\n"); }
    else   {print ("\" />\n");}

    // iTunes
    print "<itunes:author>".sonderzeichenWandeln(strip_tags($PODCAST_NAME)).$titelzusatz."</itunes:author>\n";
    $summary = $beschreibung_clean;
    if (strlen($summary)>0) {$subtitle = substr($summary,0,120); if (strlen($summary)>120) {$subtitle=$subtitle." ...";} }
    else {$subtitle = sonderzeichenWandeln(strip_tags($artikel->getTitle()));}
    print "<itunes:subtitle>".$subtitle."</itunes:subtitle>\n";
    print "<itunes:summary>".$summary."</itunes:summary>\n";
    print "<itunes:explicit>".$RSS_EXPLICIT."</itunes:explicit>\n";
    print "<itunes:keywords>".$RSS_KEYWORDS."</itunes:keywords>\n";
    if ($RSS_SUBCATEGORY!="All") { print '<itunes:category text="'.$RSS_TOPCATEGORY.'"><itunes:category text="'.$RSS_SUBCATEGORY.'"/></itunes:category>'; }
    else { print '<itunes:category text="'.$RSS_TOPCATEGORY.'"/>'."\n"; }
    $info = new mp3Info("publicData/".$artikel->getFile());
    if ($info->error==FALSE)
    {print "<itunes:duration>".$info->getLength()."</itunes:duration>";}

    print ("</item>\n\n");
    $DatsInFeed--;
  }
}

print "</channel>\n</rss>\n";

exit();

function printErrorRSS($errTitle, $errDescription)
{
  header ('Content-Type: application/xml; charset=UTF-8',TRUE);
  print '<?xml version="1.0" ?>
<rss version="2.0">
     <channel>
          <title>'.sonderzeichenWandeln(strip_tags($GLOBALS['PODCAST_NAME']))." - Error: ".$errTitle.'</title>
          <link>http://'.HTTP_BASISADRESSE.'index.php</link>
          <description>'.$errDescription.'</description>
     </channel>
</rss>';
  exit();
}

?>