<?
  #################################################
  # podblogger 0.5                                #
  # by Christian Rotzoll                          #
  #    and Hagen Christian Toennies               #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # DATEIUPLOAD-Script                            #
  #################################################
/**
* Needed files
*
* require("include/funktions_sammlung.inc.php");
* require('include/smarty/Smarty.class.php');
* require('include/layout.class.php');
* require('include/ID3v1x.class.php');
* require('include/article.class.php');
*/

  require("include/funktions_sammlung.inc.php");
  require('include/smarty/Smarty.class.php');
  require('include/layout.class.php');
  require('include/ID3v1x.class.php');
  require('include/article.class.php');
  require('include/mp3Info.class.php');
  if ($AUDIOCONVERT_SWITCH=="AN") include_once("include/audioconverter.class.php");

  //instance and configure SMARTY Template-Dataobjects
  $smarty = new Smarty;

  $smarty->template_dir = LAYOUTDIR;
  $smarty->compile_dir = SMARTYPATH_COMPILE;
  $smarty->config_dir = SMARTYPATH_CONFIG;
  $smarty->cache_dir = SMARTYPATH_CACHE;

  $smarty->assign('PODCAST_sitename',$PODCAST_NAME);

  // ------ Step Init ------------------------
  if (issetPostGet('step'))
  {
    $step = getPostGetInt('step');
  }
  else
  {
    if (issetPostGet('uploadid'))
    {$step = 2;}
    else
    {$step = 1;}
  }

  if (issetPostGet('phpupload'))
  {$phpupload = 1;}
  else
  {$phpupload = 0;}

  session_start();
  if (!isset($_SESSION['admin']))
  { $_SESSION['admin'] = "notADMIN"; }

  /**
  * Name:testPublicUpload()
  *
  * Check who is allowed to upload Audiofiles
  */
  function testPublicUpload()
  {
    if ($GLOBALS['JUST_ADMIN_UPLOAD']=="JA")
    {
      if ($_SESSION['admin']=="notADMIN")
      {
        print "<html><body><br><center>".get_lang('upload_justadminupload')."</center></body></html>";
       exit();
      }
    }
    return TRUE;
  }

  // ------ UPLOAD:Step1 ------------------------
  // --------------------------------------------
  // here we beginn to deliver startupload form to choose the file
  // to upload


  if ( ($step == 1) && (testPublicUpload()) )
  {

  // write header informtions to determine the site caching
  header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
  header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
  header("Cache-Control: no-store, no-cache, must-revalidate");
  header("Cache-Control: post-check=0, pre-check=0", false);
  header("Pragma: no-cache");


  // ------ delete error Uploads ----------------
  // --------------------------------------------

    // generate a Goodliste wich hold all allowed folders and files
    $goodlist = array(".htaccess");
    $artcle_files = getFilesFromDirWithEnding("uploadData","article");
    foreach ($artcle_files as $artikel_file)
    {
      if($artikel = article::loadArticleFromFile("uploadData/".$artikel_file))
      {
        // The article file musst be saved if
        // 1. after a successful file upload
        // 2. if the file is younger than 6h

	//calculate the age of an article file in unixtime()
        $ageOfArticle = time() - $artikel->getUnixTime();

        // X min 2 sec
        if (!isset($CLEANSWEEP_UPLOADDIRECTORY)) {$CLEANSWEEP_UPLOADDIRECTORY = 6 * 60;}
        $deadline = intval($CLEANSWEEP_UPLOADDIRECTORY) * 60;

        // If one case is true ...
        if (($artikel->checkValid()) || ($ageOfArticle < $deadline))
        {
          // then put all article files and depending audiofiles into the goodlist
          array_push($goodlist, $artikel_file);
          $goodlist = array_merge($goodlist, $artikel->getAllAppendantFiles());
        }
      }
    }

    // 1.delete all files that ar not in the Goodlist
    $verzeichnis = opendir("uploadData");
    while ($datei = readdir($verzeichnis))
    {
      // if not in goodlist
      if (!my_search_stringArray($datei, $goodlist))
      {
        if (! is_Dir("uploadData/".$datei) ) {@unlink("uploadData/".$datei);}
      }
    }
    closedir($verzeichnis);


  // ------ check harddisk space ----------------
  // --------------------------------------------

  // calculate the hole Webspace
  if ($freeByte = @diskfreespace("uploadData"))
  {
    $freeMByte = round($freeByte / (1024 * 1024));

    if ($freeMByte < 5)
    {
      if ($EMAIL_BENACHRICHTIGUNG == "JA")
      {
        require_once("include/mail_wrapper.class.php");
        mail_wrapper::sendmail($ADMIN_EMAIL, '[podblogger-mail] '.get_lang('upload_mail_subject1'), get_lang('upload_freespacewarning',HTTP_BASISADRESSE));
      }
    }
  }

  // storage limits
  if ($WEBSPACE_LIMIT != 0)
  {
    $verbraucht = getUsedWebspace();
    if ($verbraucht >= $WEBSPACE_LIMIT)
    {
      fehlerMeldung (get_lang('upload_webspacelimit'));
    }
    elseif ((($verbraucht+10) > $WEBSPACE_LIMIT) && ($EMAIL_BENACHRICHTIGUNG == "JA"))
    {
        require_once("include/mail_wrapper.class.php");
        mail_wrapper::sendmail($ADMIN_EMAIL, '[podblogger-mail] '.get_lang('upload_mail_subject2'), get_lang('upload_webspacewarning',HTTP_BASISADRESSE));
    }
  }

  // ------ check if CGI-UPLOAD is ready---------
  // --------------------------------------------

  $CGIUPLOAD = FALSE;
  $hinweis = "";

  if ($UPLOADRELAIS_SWITCH=="AN")
  {
      if ($fp = @fopen($UPLOAD_CGI_SCRIPT."?callback_script=status","r"))
      {
        $antwort = fread($fp,2048);
        fclose($fp);

        $data = explode("\n",$antwort);

        if (strstr($data[0],"TRAFFICLIMIT"))
        {
          // case that the upload traffic is over the limit
          $tage = $data[1];
          $hinweis = get_lang('upload_trafficlimit',$tage);
        }
        else if ($data[1]=="GO!")
        {
         $CGIUPLOAD = TRUE;
        }
      }
  }

  // ------calculate SMARTY datafields   --------
  // --------------------------------------------

     if ($CGIUPLOAD)
     {
       // upload via CGI-Upload-Relais
       $smarty->assign('PODCAST_uploadscript',$UPLOAD_CGI_SCRIPT);
       $smarty->assign('PODCAST_ImportantFormValues','<input type="hidden" name="callback_script" value="'.$PHP_CALLBACK_SCRIPT.'">');
     }
     else
     {
       // PHP-Upload
       $smarty->assign('PODCAST_uploadscript',"upload.php");
       $smarty->assign('PODCAST_ImportantFormValues','<input type="hidden" name="phpupload" value="1"><input type="hidden" name="step" value="2">');
     }

    // maybe.warning $PODCAST_UploadSystemWarnings for Template

    $UploadSystemWarnings = "";
    if ($hinweis!="") $UploadSystemWarnings = "<strong>".get_lang('hint').": </strong>".$hinweis."<br><br>";

    $verbraucht = getUsedWebspace();
    $UploadSystemWarnings .= "    <!-- verbrauchterWebspace/limit : ".round($verbraucht/(1024*1024))."/".round($WEBSPACE_LIMIT/(1024*1024))." -->";

    if (!$CGIUPLOAD)
    {
      $UploadSystemWarnings .= get_lang('upload_phpuploadlimit',getPhpUploadLimit());
      $smarty->assign('PODCAST_maxByteUpload',getPhpUploadLimit("BYTE"));
    }
    else
    {
      $smarty->assign('PODCAST_maxByteUpload',0);
    }

    $smarty->assign('PODCAST_UploadSystemWarnings',$UploadSystemWarnings);


    // Display templatesite
    $smarty->display($LAYOUT_ID.'/upload_1.tpl');

  }


  // ------ UPLOAD:STEP 2 --------------------
  // --------------------------------------------


  // 1  Calls a file from the upload.cgi scripth
  // 2. delivers the form for the meta informations for the audio file


  elseif ($step == 2)
  {

    if ( ($phpupload) && (testPublicUpload()) )
    {
      ####### PHP-UPLOAD ENTGEGEN NEHMEN ##################################

      $CGI_upload_name = $_FILES['file']['name'];

      // check file suffix
      // $ALLOWEDUPLOADFORMATS is defined at manSettings.txt
      $validFormat = TRUE;
      if (isset($ALLOWEDUPLOADFORMATS))
      {
        $validFormat = FALSE;
        $formats =  explode(";", trim($ALLOWEDUPLOADFORMATS));
        foreach ($formats as $format)
        {
          if ( strtoupper( getDateiEndung($CGI_upload_name) ) == strtoupper($format) )
          { $validFormat = TRUE; }
        }
      }
      if (!$validFormat)
      {
        fehlerMeldung ("<strong>".get_lang('upload_forbiddenFormat',getDateiEndung($CGI_upload_name))."</strong><br>");
      }

      // handel names
      $CGI_upload_name = sonderzeichenInDateinameWandeln($CGI_upload_name);
      $CGI_upload_name = ggfDatumskennungHinzufuegen($CGI_upload_name);
      $CGI_upload_name = urlencode($CGI_upload_name);

      while (file_exists("uploadData/".$CGI_upload_name))
      {
        $CGI_upload_name = "_".$CGI_upload_name;
      }

      //check Webspacelimit
      if ( ($WEBSPACE_LIMIT != 0) && ((getUsedWebspace()+$_FILES['file']['size']) > $WEBSPACE_LIMIT) )
      {
        fehlerMeldung (get_lang('upload_webspaceProblem') );
      }
      // write article file to save audiofile from deleting
      $artikelID = article::createUniqueID();
      if (isset($CGI_upload_name))
      {
        $artikel = new article($artikelID);
        $artikel->setUnixTime(time());
        $artikel->setFile($CGI_upload_name);
        $artikel->save("uploadData");
      }

      // copy file an report errors
      if (!move_uploaded_file($_FILES['file']['tmp_name'], "uploadData/" . $CGI_upload_name))
      {
        @unlink("uploadData/".$artikelID.".article");

        if ($_FILES['file']['error'] == 1)
        {
          fehlerMeldung (get_lang('upload_tooBigForPHP'));
        }
        elseif ($_FILES['file']['error'] > 1)
        {
          fehlerMeldung (get_lang('upload_uploadProblem1'));
        }
        else
        {
          fehlerMeldung (get_lang('upload_uploadProblem2'));
        }
      }
    }
    else
    {
      ####### reload the uploaded files from CGI-UPLOAD-RELAIS ################

      if (issetPostGet('uploadid'))
      {
        $CGI_upload_id = getPostGetInt('uploadid');

	  //----- get the name of the uploaded file from cgi script
          if ($wp = fopen("$DOWNLOAD_CGI_SCRIPT?request=vorhanden&id=$CGI_upload_id","r"))
          {
            $upload_existiert = fread($wp,2048);
            fclose($wp);
            $upload_existiert = trim($upload_existiert);
          }
          else
          { die("\n".get_lang('upload_uploadProblem3',$DOWNLOAD_CGI_SCRIPT,$CGI_upload_id));}

          // only if the download is avalible "download"
          if ($upload_existiert == "TRUE")
          {


            if ($wp = fopen("$DOWNLOAD_CGI_SCRIPT?request=filename&id=$CGI_upload_id","r"))
            {
              $CGI_upload_name = fread($wp,2048);
              fclose($wp);
              $CGI_upload_name = trim($CGI_upload_name);

              // check file suffix
              // $ALLOWEDUPLOADFORMATS is defined at manSettings.txt
              $validFormat = TRUE;
              if (isset($ALLOWEDUPLOADFORMATS))
              {
                $validFormat = FALSE;
                $formats =  explode(";", trim($ALLOWEDUPLOADFORMATS));
                foreach ($formats as $format)
                {
                  if ( strtoupper( getDateiEndung($CGI_upload_name) ) == strtoupper($format) )
                  { $validFormat = TRUE;}
                }
              }
              if (!$validFormat)
              {
                fehlerMeldung ("<strong>".get_lang('upload_forbiddenFormat',getDateiEndung($CGI_upload_name))."</strong><br>");
              }

              $CGI_upload_name = sonderzeichenInDateinameWandeln($CGI_upload_name);
              $CGI_upload_name = ggfDatumskennungHinzufuegen($CGI_upload_name);

             $CGI_upload_name = urlencode($CGI_upload_name);
            }
            else
            { die("\n".get_lang('upload_uploadProblem3',$DOWNLOAD_CGI_SCRIPT,$CGI_upload_id));
            }


            while (file_exists("uploadData/".$CGI_upload_name))
            {
              $CGI_upload_name = "_".$CGI_upload_name;
            }
	    // write article file to save audiofile from deleting
            $artikelID = article::createUniqueID();
            if (isset($CGI_upload_name))
            {
              $artikel = new article($artikelID);
              $artikel->setUnixTime(time());
              $artikel->setFile($CGI_upload_name);
              $artikel->save("uploadData");
            }

	    // ---- get data from upload cgi script and save
            $bytecount = 0;
            if ($wp = fopen("$DOWNLOAD_CGI_SCRIPT?request=filedata&id=$CGI_upload_id","rb"))
            {
              if ($fp = fopen("uploadData/".$CGI_upload_name,"w+"))
              {
                while (!feof($wp))
                {
                  $data = fread($wp,2048);
                  $bytecount += strlen($data);
                  fwrite($fp,$data);
                }
                fclose($fp);
              }
              else
              { die("\n".get_lang('upload_uploadProblem4'));}
              fclose($wp);
              if ($bytecount==0)
              { die("\n".get_lang('upload_uploadProblem5',$DOWNLOAD_CGI_SCRIPT,$CGI_upload_id));}
            }
            else
            { die("\n".get_lang('upload_uploadProblem3',$DOWNLOAD_CGI_SCRIPT,$CGI_upload_id));}
          }  // end if $upload_existiert==TRUE

      }
      else
      {
        if (issetPostGet('filename'))
        {
          $CGI_upload_name = getPostGetText('filename');
        }
        else
        die(get_lang('upload_uploadProblem6'));
      }

     } // end else !phpupload

      // check for webspace limit overflow
      if ( ($WEBSPACE_LIMIT != 0) &&  ((getUsedWebspace()) > $WEBSPACE_LIMIT))
      {
        @unlink("uploadData/".$CGI_upload_name);
        fehlerMeldung (get_lang('upload_webspaceProblem'));
      }

      ####### PHP-Upload oder bzw. CGI-Upload fertig ##################################

      // try to get informations from audiofile

      if ((isset($CGI_upload_name)) && (strtoupper(getDateiEndung($CGI_upload_name)) == "MP3"))
      {
        // IDTag Data
        if ($mp3Inf = getMp3Info("uploadData/".$CGI_upload_name))
        {
          $titel = $mp3Inf['Titel'];
          $autor = $mp3Inf['Kuenstler'];
          $beschreibung = $mp3Inf['Kommentar']. " (".$mp3Inf['Album']. " / " .$mp3Inf['Jahr']. ")";
        }
        else
        {
          $titel = "";
          $autor = "";
          $beschreibung = "";
        }

        // general Data
        $info = new mp3Info("uploadData/".$CGI_upload_name,FALSE);
        if (is_object($info)) { $mp3dauer=$info->getLength(); }
        else { $mp3dauer=""; }

      } // end if
      else
      {
        $titel = "";
        $autor = "";
        $beschreibung = "";
        $mp3dauer="";
      } // else


    // ------ calculate SMARTY-datafields ---------
    // --------------------------------------------

    $smarty->assign('PODCAST_uploadscript',$PHP_CALLBACK_SCRIPT);

    $smarty->assign('PODCAST_MP3_Titel',$titel);
    $smarty->assign('PODCAST_MP3_Beschreibung',$beschreibung);
    $smarty->assign('PODCAST_MP3_Autor',$autor);

    $smarty->assign('PODCAST_kategorien_array',$PODCAST_KATEGORIEN);

    $smarty->assign('PODCAST_ImportantFormValues','<input type="hidden" name="step" value="3"><input type="hidden" name="artikelID" value="'.$artikelID.'"><input type="hidden" name="filename" value="'.$CGI_upload_name.'">');

    $smarty->assign('PODCAST_MP3_Dauer',$mp3dauer);


    $smarty->display($LAYOUT_ID.'/upload_2.tpl');

  } // end elseif step = 2


  // ------ UPLOAD:Step3 ------------------------
  // --------------------------------------------


  // 1. read and save input
  // 2. Send mail to admin
  // 3. Print out success
  // 4. maybe start audio converting

  else if ( ($step == 3) && (testPublicUpload()) )
  {
    // ---- get parameter
    if (issetPostGet('filename'))
    {$filename = getPostGetText('filename');}
    else { die("FEHLER: Es fehlen Parameter!");}
    $orgFilename = stripslashes($filename);
    $filename = strip_tags($filename);

    if (issetPostGet('artikelID'))
    {$artikelID = getPostGetText('artikelID');}
    else { die("FEHLER: Es fehlen Parameter!");}

    if (issetPostGet('titel'))
    {$titel = getPostGetText('titel');}
    else { die("FEHLER: Es fehlen Parameter!");}
    $titel = strip_tags($titel);

    if (issetPostGet('beschreibung'))
    {$beschreibung = getPostGetText('beschreibung');}
    else { $beschreibung = "";}
    $beschreibung = strip_tags($beschreibung);
    $beschreibung = str_replace("\r\n","\n",$beschreibung);
    $beschreibung = str_replace("\n\r","\n",$beschreibung);

    if (issetPostGet('autor_name'))
    {$autor_name = getPostGetText('autor_name');}
    else { $autor_name = ""; }
    $autor_name = strip_tags($autor_name);

    if (issetPostGet('autor_mail'))
    {$autor_mail = getPostGetText('autor_mail');}
    else { $autor_mail = ""; }
    $autor_mail = strip_tags($autor_mail);

    if (issetPostGet('autor_telefon'))
    {$autor_telefon = getPostGetText('autor_telefon');}
    else { $autor_telefon=""; }
    $autor_telefon = strip_tags($autor_telefon);

    if (issetPostGet('autor_bemerkung'))
    {$autor_bemerkung = getPostGetText('autor_bemerkung');}
    else { $autor_bemerkung=""; }
    $autor_bemerkung = strip_tags($autor_bemerkung);
    $autor_bemerkung = str_replace("\n","<br>",$autor_bemerkung);
    $autor_bemerkung = str_replace("\r","",$autor_bemerkung);

    if (issetPostGet('kategorie'))
    {$kategorie = getPostGetText('kategorie');}
    else { die("FEHLER: Es fehlen Parameter!");}

    if ($titel=="") {$titel = "noTitle";}

    if (issetPostGet('deletenotice'))
    {$delete_notice = getPostGetText('deletenotice');}
    else { $delete_notice="CONSULTATION"; }

    if (issetPostGet('file_access'))
    {$restricted_access = getPostGetText('file_access');}
    else { $restricted_access="PUBLIC"; }

    // import dynamic xtra meta data fields
    $xtra_field  = array(); $i=1;
    while (issetPostGet("xtra_field".$i))
    {
      $xtra_field[$i]=getPostGetText("xtra_field".$i);
      $i++;
    }

   // rewrite and extends the article file
    if ($artikel = article::loadArticleFromFile("uploadData/".$artikelID.".article"))
    {
      $artikel->setTitle($titel);
      $artikel->setDescription($beschreibung);
      $artikel->setAuthorName($autor_name);
      $artikel->setAuthorMail($autor_mail);
      $artikel->setAuthorXtra($autor_telefon);
      $artikel->setAuthorComment($autor_bemerkung);
      $artikel->setCategory($kategorie);
      $artikel->setRightsData('deletenotice',$delete_notice);
      $artikel->setRightsData('fileaccess',$restricted_access);

      if (count($xtra_field)>0)
      {
        for ($i=1;$i<=count($xtra_field);$i++)
        {
          // look for translation (can be set by manSettings.txt)
          $id = "xtra_field".$i;
          if (isset($GLOBALS["xtra_field".$i]))
          {
            $id = $GLOBALS["xtra_field".$i];
          }
          // save xtra-metadata
          $artikel->setExtendedData($id,$xtra_field[$i]);
        }
      }

      $artikel->save("uploadData");
    }
    else
    {
      die("PROBLEM: Datei '".$artikelID.".article' scheint nicht im Verzeichnis uploadData zu existieren");
    }

    // ---- maybe sen converting orders

    // $CONVERT_TARGETFORMATS is define in the podbloggerData/manSettings.txt
    if ((isset($CONVERT_TARGETFORMATS)) && ($AUDIOCONVERT_SWITCH=="AN"))
    {
      print "<!-- START Convertorder ->\n";
      // Uploadformat
      $uploadformat = strtoupper(getDateiEndung($filename));

      // calculate needed conversions
      $konvertFormats = Array();
      foreach (explode(";",$CONVERT_TARGETFORMATS) as $convertorder)
      {
        // calculate targetformat
        $parts = explode("/",$convertorder);
        $targetformat = strtoupper($parts[0]);
        // maybe parse other Parameter
        $targetquality  = "";
        if (isset($parts[1]))
        {
          $parts = explode("=",$parts[1]);
          $targetquality  = strtoupper($parts[0]);
        }
	// two cases for convertings
        // 1. the uploadformat differs from the targetformat
        if ($targetformat != $uploadformat)
        {
          array_push($konvertFormats, $convertorder);
        }
        // 2 format is right but quality musst be change
        elseif  ($targetquality!="")
        {
          array_push($konvertFormats, $convertorder);
        }
       print "<!-- END Convertorder ->\n";
      }

      // maybe order convertings
      if (count($konvertFormats)>0)
      {
        // Init converter
        print "<!-- ";
        $converter = new audioconverter($AUDIOCONVERT_ADDRESS,"http://".HTTP_BASISADRESSE."convert.php");
        print " ->\n";
        foreach ($konvertFormats as $convertorder)
        {
          print "<!-- request Convert $convertorder ->\n";
          print "<!-- \n";
          $converter->requestAudioConvertion("uploadData/".$filename, $convertorder, $artikelID);
          print "->";
        }
      }
    }
    else
    {
      print "<!-- NO Convertorder ->\n";
    }

    // ---- MP3 ID3v2-Tag Edit

    $ID3 = new ID3v1x("uploadData/".$orgFilename);
    $ID3->write_tag(1, strip_tags($titel), strip_tags($PODCAST_NAME), strip_tags($kategorie), date("Y",time()), substr(HTTP_BASISADRESSE,0,strlen(HTTP_BASISADRESSE)-1), "0", "37");

    // --------------------

    if (($_SESSION['admin'] != "ADMIN"))
    {
      if ($EMAIL_BENACHRICHTIGUNG == "JA")
      {
        require_once("include/mail_wrapper.class.php");
        mail_wrapper::sendmail($ADMIN_EMAIL, '['.$PODCAST_NAME.'] '.get_lang('upload_mailsubject') ,get_lang('upload_mailtext',$titel));

      }

      //deliver Template-site
      $smarty->display($LAYOUT_ID.'/upload_3.tpl');

    } // enf if ADMIN
    else
    {
      ?>
        <html>
        <head>
        <meta http-equiv="refresh" content="0; URL=admin.php">
        <title>Forwarding ...</title>
        </head>
        <body><br>
        <center><a href='admin.php'>... click here ...</a></center>
        </body>
        </html>
      <?
    } // end else !ADMIN
  } // end if step=3
  else
  {
    print ("Step:".$step);
  }
/**
* Name:sonderzeichenInDateinameWandeln($CGI_upload_name)
*
* replace some special characters
* return $CGI_upload_name;
*/

  function sonderzeichenInDateinameWandeln($CGI_upload_name)
  {
      $CGI_upload_name = str_replace(" ","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("","ae",$CGI_upload_name);
      $CGI_upload_name = str_replace("","ue",$CGI_upload_name);
      $CGI_upload_name = str_replace("","oe",$CGI_upload_name);
      $CGI_upload_name = str_replace("","ss",$CGI_upload_name);
      $CGI_upload_name = str_replace("'","",$CGI_upload_name);
      $CGI_upload_name = str_replace("(","_",$CGI_upload_name);
      $CGI_upload_name = str_replace(")","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("~","-",$CGI_upload_name);
      $CGI_upload_name = str_replace("@","_at_",$CGI_upload_name);
      $CGI_upload_name = str_replace("!","I",$CGI_upload_name);
      $CGI_upload_name = str_replace("\"","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("","",$CGI_upload_name);
      $CGI_upload_name = str_replace("&","_und_",$CGI_upload_name);
      $CGI_upload_name = str_replace("/","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("=","-",$CGI_upload_name);
      $CGI_upload_name = str_replace("?","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("<","_",$CGI_upload_name);
      $CGI_upload_name = str_replace(">","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("|","-",$CGI_upload_name);
      $CGI_upload_name = str_replace(";",".",$CGI_upload_name);
      $CGI_upload_name = str_replace(",",".",$CGI_upload_name);
      $CGI_upload_name = str_replace("`","",$CGI_upload_name);
      $CGI_upload_name = str_replace("","",$CGI_upload_name);
      return $CGI_upload_name;
  }
/**
* Name:ggfDatumskennungHinzufuegen($CGI_upload_name)
*
* add a timestamp to the given parameter
* return $CGI_upload_name;
*/
  function ggfDatumskennungHinzufuegen($CGI_upload_name)
  {
      // ggf. Datumskennung vorne anhngen, wenn erstesZeichen keine Zahl ist
      $erstesZeichen = $CGI_upload_name[0];
      if ( !( (ord($erstesZeichen)>=48) && (ord($erstesZeichen)<=57) ) )
      {
        $CGI_upload_name = date("Ymd")."_".$CGI_upload_name;
      }
      return $CGI_upload_name;
  }
/**
* Name: fehlerMeldung($fehlertext)
*
* generates an error massage
*
*/
  function fehlerMeldung($fehlertext)
  {
    $GLOBALS['smarty']->assign('PODCAST_fehlerText',$fehlertext);

    // Template-Seite ausgeben
    $GLOBALS['smarty']->display($GLOBALS['LAYOUT_ID'].'/upload_error.tpl');
    exit();
  }
/**
* Name: getMp3Info($datei)
*
* try to read out the Mp3 ID3v2 tags
*/
  function getMp3Info($datei)
  {
    if (file_exists($datei))
    {

     /* neue Version (noch mit Fehlern)
     $ID3 = new ID3v1x($datei);
     if($ID3->read_tag() == true)
     {
        $infoArray['Titel']     = $ID3->title;
        $infoArray['Kuenstler'] = $ID3->artist;
        $infoArray['Album']     = $ID3->album;
        $infoArray['Jahr']      = $ID3->year;
        $infoArray['Kommentar'] = $ID3->track;
        $infoArray['Genre']     = $ID3->genre;
        return $infoArray;
     }
     else
     {
       return false;
     }
     */

    /* ALTE VERSION */

        $fp = fopen($datei, "r");
        fseek($fp, (filesize($datei) - 128));
        $tag = fread($fp,3);

        if ($tag == "TAG")
        {
            // ID-Tag found  ; read Id3v2 tags
            $infoArray['Titel']     = strip_tags(charfilter(fread($fp, 30)));
            $infoArray['Kuenstler'] = strip_tags(charfilter(fread($fp, 30)));
            $infoArray['Album']     = strip_tags(charfilter(fread($fp, 30)));
            $infoArray['Jahr']      = strip_tags(charfilter(fread($fp, 4)));
            $infoArray['Kommentar'] = strip_tags(charfilter(fread($fp, 30)));
            $infoArray['Genre']     = strip_tags(charfilter(fread($fp, 1)));
            fclose($fp);
            return $infoArray;
        }
        else
        {
          // found ID3-tag gefunden
          fclose($fp);
          return false;
        }

    }
    else
    {
      return false;
    }
  }
?>